unit MyShape;

interface

Uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.UIConsts,
  System.Classes,
  System.Generics.Collections,
  System.math,
  System.Rtti,
  System.Messaging,
  System.Math.Vectors,

  FMX.Controls,
  FMX.Platform,
  FMX.MultiResBitmap,
  FMX.Types,
  FMX.Dialogs,
  FMX.Objects,
  FMX.Graphics,
  FMX.TextLayout,
  FMX.Layouts,
  FMX.StdCtrls;

type

 TCourantShape = class(TShape)
 private
 Fangle : integer;
 FCentre : TPointF;
 protected
   procedure setAngle(value : integer);
   procedure Paint; override;
   procedure setCentre(value : TpointF);
 public
   property angle : integer read Fangle write setAngle;
   property Stroke;
   property Centre : TPointF write setCentre;
   constructor Create(AOwner: TComponent); override;
 end;

const
    dimFleche = 5;

implementation

procedure TCourantShape.setCentre(value : TpointF);
begin
  //  position.x := value.x;
  //  position.y := value.y;
    FCentre := Value;
end;

constructor TCourantShape.Create(AOwner: TComponent);
begin
  inherited;
  Parent := TPaintBox(Aowner);
  Stroke.Kind := TBrushKind.Solid;
  Stroke.Color := claBlack;
  Fill.Kind := TBrushKind.Solid;
  Fill.Color := claBlack;
  Stroke.Thickness := 1;
  width := 2*dimFleche;
  height := 2*dimFleche;
end;

procedure TCourantShape.setAngle(value : integer);
begin
   RotationAngle := value*pi/4;
   Fangle := value;
end;

procedure TCourantShape.Paint;
var
  Points: TPolygon;
begin
    Points[0].X := Position.X;
    Points[0].Y := Position.Y;
    Points[1] := Points[0];
    Points[1].offset(dimFleche,dimFleche);
    Points[2] := Points[0];
    Points[2].offset(dimFleche,-dimFleche);
    Points[3] := Points[0];
    canvas.DrawPolygon(Points,1);
    Finalize(Points);
end;


end.


