unit dipoleU;

interface

uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,

  FMX.StdCtrls,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.ListBox,
  FMX.Layouts,
  FMX.Edit,
//  FMX.Platform,
  FMX.Controls.Presentation,

  pstcircker;


type
  TDipoleDlg = class(TForm)
    GenreLB: TListBox;
    NomEdit: TEdit;
    NomEdit_LBL: TLabel;
    TensionEdit: TEdit;
    TensionEdit_LBL: TLabel;
    CourantEdit: TEdit;
    CourantEdit_LBL: TLabel;
    VariableCB: TCheckBox;
    Label1: TLabel;
    Button1: TButton;
    Bevel: TPanel;
    defautCB: TCheckBox;
    FiltreRG: TListBox;
    OKbtn: TButton;
    escBtn: TButton;
    PasseBasItem: TListBoxItem;
    PasseBandeItem: TListBoxItem;
    zigzagCB: TCheckBox;
    AngleEdit: TEdit;
    AngleEdit_LBL: TLabel;
    InverseTensionCB: TCheckBox;
    InverseCourantCB: TCheckBox;
    Lang: TLang;
    StraightCB: TCheckBox;
    BabelCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure GenreLBClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    objetCourant : TDipole;
    procedure setLabel1;
  end;

var
  DipoleDlg: TDipoleDlg;

implementation

{$R *.FMX}

procedure TDipoleDlg.OKBtnClick(Sender: TObject);
begin with objetCourant do begin
  Fnom := nomEdit.Text;
  variable := variableCB.isChecked;
  tension := tensionEdit.Text;
  courant := courantEdit.Text;
  Fangle := Trunc(StrToFloat(angleEdit.Text) / 45);   // Stein 2013-04-28 - to show/change angle in component config box
  Modele := gdipole(genreLB.ItemIndex);
  filtre := gFiltre(filtreRG.itemIndex);
//  Flogic := Tlogic(logicLB.ItemIndex);
  zigzag := zigzagCB.isChecked;
  inverseTension := inverseTensionCB.isChecked;
  inverseCourant := inverseCourantCB.isChecked;
  straightVoltage := straightCB.IsChecked;
  withBabel := babelCB.IsChecked;
  if defautCB.IsChecked then ecritDefault;
end end;

procedure TDipoleDlg.Button1Click(Sender: TObject);
begin
  nomEdit.Text := label1.text;
end;

procedure TDipoleDlg.FormActivate(Sender: TObject);
var i : integer;
begin
if langue=fr then caption := 'Options dipole';
if langue=en then caption := 'Bipole options';
LoadLangFromStrings(Lang.LangStr[chaineLangue]);
for i := 0 to genreLB.Count-1 do
    genreLB.items[i] := nomCaptionDipole(gDipole(i));
with objetCourant do begin
  nomEdit.Text := Fnom;
  variableCB.IsChecked  := variable;
  tensionEdit.Text := tension;
  courantEdit.Text := courant;
  angleEdit.Text := IntToStr(45*Fangle);  // Stein 2013-04-28 - to show/change angle in component config box
  genreLB.ItemIndex := ord(modele);
  filtreRG.itemIndex := ord(filtre);
  filtreRG.Visible := modele=dfilter;
  defautCB.IsChecked  := false;
  zigzagCB.Visible := modele=dR;
  zigzagCB.isChecked := zigzag;
  inverseTensionCB.isChecked := inverseTension;
  inverseCourantCB.isChecked := inverseCourant;
  straightCB.IsChecked := straightVoltage;
  babelCB.IsChecked := withBabel;
end end;

procedure TDipoleDlg.FormShow(Sender: TObject);
begin with objetCourant do begin
  nomEdit.Text := Fnom;
  variableCB.IsChecked := variable;
  variableCB.visible := modele in [dR,dC,dL];
  tensionEdit.Text := tension;
  courantEdit.Text := courant;
  angleEdit.Text := IntToStr(45*Fangle);  // Stein 2013-04-28 - to show/change angle in component config box
  genreLB.ItemIndex := ord(modele);
  filtreRG.itemIndex := ord(filtre);
  filtreRG.Visible := modele=dfilter;
  defautCB.IsChecked  := false;
  zigzagCB.Visible := modele=dR;
  zigzagCB.isChecked := zigzag;
  setlabel1;
end end;

procedure TDipoleDlg.GenreLBClick(Sender: TObject);
begin
     setLabel1;
     filtreRG.Visible := genreLB.ItemIndex = ord(dFilter);
     zigzagCB.Visible := GenreLB.ItemIndex = ord(dR);
     nomEdit.Text  := nomDefautDipole[gdipole(genreLB.ItemIndex)];
     variableCB.visible := genreLB.ItemIndex in [0,1,2];
     if (gDipole(genreLB.ItemIndex) in [dGT,dBat,dGTac]) and (moteurLatex=lTikz) then begin
         NomEdit.Text := '';
         TensionEdit.Text := 'E';
     end;
     if (genreLB.ItemIndex = ord(dGT)) and (moteurLatex=lTikz) then begin
         NomEdit.Text := '';
         CourantEdit.Text := 'I';
     end;
end;

procedure TDipoleDlg.SetLabel1;
begin
     case gdipole(genreLB.ItemIndex) of
          dR : label1.Text  := 'R_1=\SI{3}{\kilo\ohm}';
          dC : label1.Text  := 'C_1=\SI{3}{\micro\farad}';
          dL : label1.Text  := 'L_1=\SI{3}{\milli\henry}';
          else label1.Text  := '';
     end;
end;

end.
