unit pstcircker;

interface

Uses
// Converted to FireMonkey with Mida 255
// http://www.midaconverter.com - JEAN.MICHEL.MILLET

  System.SysUtils,
  System.Types,
  System.IOUtils,
  System.UITypes,
  System.Classes,
  System.Variants,
  System.IniFiles,
  System.UIConsts,
  System.Math,
  System.Math.Vectors,
  System.Generics.Collections,
  System.StrUtils,

{$IFDEF MSWINDOWS}
  sysInfoCtrls,
  FMX.Platform.win,
  Winapi.Windows,
{$ENDIF}
{$IFDEF MACOS}
  Macapi.ObjectiveC,
  Macapi.CoreFoundation,
  Macapi.Foundation,
  Macapi.CocoaTypes,
  Macapi.AppKit,
  Macapi.CoreGraphics,
{$ENDIF}

{$IFDEF POSIX}
  Posix.Stdlib,
{$ENDIF POSIX}

  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.Memo,
  FMX.Layouts,
  FMX.Edit,
  FMX.Graphics,
  FMX.DialogService.Sync;

var Feuille : Tcanvas;
    origineX,origineY : single;
    pointOrigine : TPointF;
    withBabel : boolean;

Type
     TLanguagePstCirc = (fr,en);
     TMoteurLatex = (lTikz,lPST);
     TgenreSauvegarde = (uDelete,uAdd,uMove,uModif);
     TgenreObjet = (Un_monopole,Un_dipole,Un_tripole,Un_quadripole,Un_lien,Un_Carrefour,Une_tension,Un_texte,Un_frame);
     Torientation = (oVert,oHoriz,oNone);
// troisime cas car un noeud n'est ni l'un ni l'autre (ou les deux  la fois !)
     gTripole = (tAO,tnpn,tpnp,tSwitch,tMixer,tCirculator,tAND,tOR,tNAND,tNOR,tXOR);
     gFiltre = (pBas,pBande,pHaut,cBande);
     gTransistor = (tBipolaire,tFet,tMos,tigbt,tPhoto);
     gDipole = (dR,dC,dL,
              dGT,dGC,dAm,dVm,
              dQuartz,
              dSwitch,dBat,
              dDiode,dZener,dGTO,dLed,dinterC,dPhotoDiode,dVaricap,
              dLampe,dFilter,dVCO,dAmpli,
              dMotor,dNot,dGTac,dPushSwitch);
     gQuadripole = (qTransfo,qOptoC,qGenerique);
     gMonopole = (mMasse,mAntenne);
     gMasse = (mTerre,mTrait,mTriangle,mChassis);
     gAntenne = (aSimple,aReceiving,aTransmitting,aLineStub);
     gDroiteGauche = (aDroite,aGauche,aCentre);
     Tetat = (eNone,eDeplace,eLienDebut,eLienFin,eAjoute,eDecale,
              eTensionDebut,eTensionFin,eFrameDebut,eFrameFin);
     indexBornes = 1..4;

     TNoeud = class(TObject)
          FPointF : TPointF;
          Fnom : string;
          Fpredefini : boolean;
          procedure EcritPSTCirc;
          function TexteCircuitikz : string;
          function TexteIEC : string;
          Procedure Affiche(FPath : TPathData);
          Constructor Create(aP:TPointF;const Anom : string);
     end;
     TListNoeud = class(System.Generics.Collections.TList<TNoeud>)
     private
     protected
     procedure Notify(const item : TNoeud;
       Action: System.Generics.Collections.TCollectionNotification);override;
     end;

     TObjet = class(TPersistent)
         private
         Nbornes : integer;
         FPointF,FoldPointF,FPointClick : TPointF;
         FIndexNoeud : array[indexBornes] of integer;
         Fflottant : boolean;
         FgenreObjet : TgenreObjet;
         FnomBorne : string;
         FnomObjet : string; // pour Tikz reprage bornes quadripole
         FaTracer : boolean;
         function getCodeBorne(i : indexBornes) : string;virtual;
         function getBorne(i : indexBornes) : TPointF;virtual;
         function getOrientation(i : indexBornes) : Torientation;virtual;
         function getAtracer : boolean; virtual;
         function getNoeud(i : indexBornes) : TNoeud;virtual;
         protected
         public
         LabelOffset:integer;
         Fangle : integer; // en unit pi/4 ; sens trigo  l'envers (y vers le bas )
         Fnom : string;
         property PointClick : TPointF read FPointClick;
         property oldPoint : TPointF read FoldPointF;
         property Point : TPointF read FPointF;
         property genreObjet : TgenreObjet read FgenreObjet;
         function labelOffsetLatex : string;
         function PointRel(larg,haut : single) : TpointF;
         procedure Affiche(const couleur : TalphaColor = claBlack); virtual;
         procedure AfficheBorne(i:indexBornes);
         procedure EcritPSTCirc; virtual; abstract;
         function DessineCircuitikz : string; virtual;
         function DessineIEC : string; virtual;
         function TexteCircuitikz(j : integer) : string; virtual;
         function TexteIEC(j : integer) : string;virtual;
         procedure ChercheNoeuds;virtual;
         procedure EcritFichier(F : TMemIniFile;index : integer); virtual;abstract;
         procedure EcritEnTete(F : TMemIniFile;const S : string);
         procedure LitFichier(F : TMemIniFile;const S : String); virtual;
         Constructor Create;
         Function Proche(Xs,Ys:single) : single;virtual;
         Function BorneProche(Xs,Ys:single;var dMin : single) : integer;virtual;
         Function NoeudProche(Xs,Ys:single;var dMin : single) : integer;virtual;
         property CodeBorne[i:indexBornes] : string read getCodeBorne;
         property Borne[i:indexBornes] : TPointF read getBorne;
         property Noeud[i:indexBornes] : TNoeud read getNoeud;
         property Atracer : boolean read getAtracer;
         property Orientation[i:indexBornes] : TOrientation read getOrientation;
         property Flottant : boolean read Fflottant;
         Procedure Offset(dx,dy:single);virtual;
         Procedure SetPosition(x,y : single);virtual;
         Procedure SavePosition(x,y : single);virtual;
         Procedure GetEcart(x,y : single;var dx,dy : single);virtual;
         Procedure VerifMinMaxX(var mini,maxi : single);
         Procedure VerifMinMaxY(var mini,maxi : single);
         function getNomBorne : string;
         procedure setNomObjet(const defaut : string);
         Procedure Rotate;virtual;
         procedure EcritDefault; virtual;
         procedure Assign(Source : TPersistent); override;
         Procedure OutTextP(x,y : single;const s:String);
     end;
     TListObjet = class(System.Generics.Collections.TList<TObjet>)
     private
     protected
     procedure Notify(const item : TObjet;
       Action: System.Generics.Collections.TCollectionNotification);override;
     end;

     TTripole = Class(Tobjet)
                        private
                        function getCodeBorne(i : indexBornes) : string;override;
                        function getBorne(i : indexBornes) : TpointF;override;
                        function getOrientation(i : indexBornes) : Torientation;override;
                        function getAtracer : boolean; override;
                        public
                        Modele  : gTripole;
                        ModeleTransistor : gTransistor;
                        inversion,alimentation,ideal : boolean;
                        zigzag : boolean;
                        french : boolean;
                        SortieEnHaut : boolean;
                        DroiteGauche : gDroiteGauche;
                        inputArrow : boolean;
                        withDiode : boolean;
                        BorneATracer : array[indexBornes] of boolean;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function DessineCircuitikz : string; override;
                        function TexteCircuitikz(j : integer) : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const S : String); override;
                        Constructor Create(ModeleT:gTripole);
                        Constructor CreateSimple;
                        procedure ChercheNoeuds;override;
                        Function Proche(Xs,Ys:single) : single;override;
                        procedure EcritDefault; override;
                        procedure Assign(Source : TPersistent); override;
                End;

     TDipole = Class(Tobjet)
                        private
                        function getCodeBorne(i : indexBornes) : string;override;
                        function getOrientation(i : indexBornes) : Torientation;override;
                        public
                        Modele  : gdipole;
                        variable : boolean;
                        zigzag : boolean;
                        inverseTension,inverseCourant : boolean;
                        tension,courant : string;
                        dipoleOutput : gDroiteGauche;
                        inputArrow : boolean;
                        capaChimique : boolean;
                        filtre : gFiltre;
                        ison : boolean; // Stein 19/05/2013
                        function getBorne(i : indexBornes) : Tpointf;override;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function DessineCircuitikz : string; override;
                        function TexteCircuitikz(j : integer) : string; override;
                        function TexteIEC(j : integer) : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const s : String); override;
                        Constructor Create(ModeleD:gdipole);
                        Constructor CreateSimple;
                        procedure EcritDefault; override;
                        procedure Assign(Source : TPersistent); override;
                End;

    TQuadripole = Class(Tobjet)
                        private
                        primaireAtracer,secondaireAtracer : boolean;
                        function getCodeBorne(i : indexBornes) : string;override;
                        function getOrientation(i : indexBornes) : Torientation;override;
                        function getAtracer : boolean; override;
                        public
                        Modele  : gquadripole;
                        ideal,noyau : boolean;
                        function getBorne(i : indexBornes) : TpointF;override;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function DessineCircuitikz : string; override;
                        function TexteCircuitikz(j : integer) : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const s : String); override;
                        Constructor Create(ModeleQ:gquadripole);
                        Constructor CreateSimple;
                        procedure EcritDefault; override;
                        procedure Assign(Source : TPersistent); override;
                End;

     Tlien = Class(Tobjet)
                        private
                        public
                        Debut,Fin:TObjet;
                        BorneDebut,BorneFin:integer;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function TexteCircuitikz(j : integer) : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const s : String); override;
                        function getBorne(i : indexBornes) : TPointF;override;
                        procedure ChercheNoeuds;override;
                        procedure ChercheNoeudsLogic;
                        Function Proche(Xs,Ys:single) : single;override;
                        Function NoeudProche(Xs,Ys:single;var dMin : single) : integer;override;
                        Constructor Create;
                        procedure Assign(Source : TPersistent); override;
              End;

      TTension = Class(Tobjet)
                        private
                        function getCodeBorne(i : indexBornes) : string;override;
                        public
                        Debut,Fin:TObjet;
                        BorneDebut,BorneFin:integer;
                        procedure ChercheNoeuds;override;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function DessineCircuitikz : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const s : String); override;
                        function Proche(Xs,Ys:single) : single;override;
                        procedure Rotate;override;
                        procedure EcritDefault; override;
                        Constructor Create;
                        procedure Assign(Source : TPersistent); override;
              End;

     TFrame = Class(Tobjet)
                        private
                        public
                        Debut,Fin:TPointF;
                        procedure Affiche(const couleur : TalphaColor = claBlack);override;
                        procedure EcritPSTCirc; override;
                        function DessineCircuitikz : string; override;
                        procedure EcritFichier(F : TMemIniFile;index : integer); override;
                        procedure LitFichier(F : TMemIniFile;const s : String); override;
                        Function Proche(Xs,Ys:single) : single;override;
                        Procedure SetPosition(x,y : single);override;
                        Function BorneProche(Xs,Ys:single;var dMin : single) : integer;override;
                        Procedure Offset(dx,dy:single);override;
                        Constructor Create;
                        procedure Assign(Source : TPersistent); override;
              End;

     TMonopole  = Class(Tobjet)
                     private
                     function getCodeBorne(i : indexBornes) : string;override;
                     public
                     ModeleM : gMasse;
                     ModeleA : gAntenne;
                     Modele : gMonopole;
                     connectingDot : boolean;
                     procedure Affiche(const couleur : TalphaColor = claBlack);override;
                     procedure EcritPSTCirc; override;
                     function TexteCircuitikz(j : integer) : string; override;
                     procedure ChercheNoeuds;override;
                     procedure EcritFichier(F : TMemIniFile;index : integer); override;
                     procedure LitFichier(F : TMemIniFile;const s : String); override;
                     Function NoeudProche(Xs,Ys:single;var dMin : single) : integer;override;
                     Constructor Create;
                     procedure EcritDefault; override;
                     procedure Assign(Source : TPersistent); override;
              End;

     TCarrefour= Class(Tobjet)
                    private
                    function getCodeBorne(i : indexBornes) : string;override;
                    public
                    Fconnected : boolean;
                    procedure Affiche(const couleur : TalphaColor = claBlack); override;
                    procedure EcritPSTCirc; override;
                    function DessineCircuitikz : string; override;
                    function TexteCircuitikz(j : integer) : string; override;
                    procedure ChercheNoeuds;override;
                    procedure EcritFichier(F : TMemIniFile;index : integer); override;
                    procedure LitFichier(F : TMemIniFile;const s : String); override;
                    Function NoeudProche(Xs,Ys:single;var dMin : single) : integer;override;
                    Procedure SetPosition(x,y : single);override;
                    Constructor Create;
                    procedure Assign(Source : TPersistent); override;
              End;

      TTexte= Class(Tobjet)
                    private
                    function getCodeBorne(i : indexBornes) : string;override;
                    public
                    procedure Affiche(const couleur : TalphaColor = claBlack); override;
                    procedure EcritPSTCirc; override;
                    function DessineCircuitikz : string; override;
                    procedure ChercheNoeuds;override;
                    procedure EcritFichier(F : TMemIniFile;index : integer); override;
                    procedure LitFichier(F : TMemIniFile;const s : String); override;
                    Function NoeudProche(Xs,Ys:single;var dMin : single) : integer;override;
                    Constructor Create(const Anom : string);
                    Constructor CreateSimple;
              End;

     TpileObjet = System.Generics.Collections.TStack<TObjet>;
     Tsauvegarde = class
        private
        Fobjet,FobjetSauve: Tobjet;
        Fundo: TgenreSauvegarde;
        FpileDelete : TpileObjet;
        public
        procedure Restaure;
        procedure AddObjetDetruit(Aobjet : TObjet);
        constructor Create(objetCourant : TObjet;aUndo : TgenreSauvegarde);
        destructor Destroy; override;
     end;
     TpileSauvegarde = class
        private
        Liste : System.Generics.Collections.TList<Tsauvegarde>;
        function getCount : integer;
        public
        function pop : Tsauvegarde;
        procedure push(s : Tsauvegarde);
        procedure Reset;
        constructor Create;
        destructor Destroy; override;
        property count : integer read getCount;
     end;
 //    TpileSauvegarde = TStack<Tsauvegarde>;

Const
      Pas = 20; // Unit pstricks = 2*pas = 1 cm par dfaut
      LargeurMax = 29; // largeur A4 en cm en mode paysage
      HauteurMax = 29; // hauteur A4 en cm n mode portrait
      demiPas   = Pas/2;
      pasLabel  = 8;
      dimBorne  = 3;
      dimFleche = 5;
      LargeurDi    = Pas;
      HauteurDi    = Pas/2;
      LargeurTri   = 2*Pas;  // en fait demi-largeur
      HauteurTri   = 3*Pas/2; // en fait demi-hauteur
      HauteurQgen  = 5*Pas/2;

      nomDefautDipole : array[gDipole] of string = ('R','C','L','E','I','A','V','Q',    // Stein 2013/04/28
              'K','E','D','Z','K','LED','K','D','D',
              '','','VCO','','Mcc','Not','E','Kb');
      nomTripole : array[gTripole] of string =
          ('AO','npn','pnp','K','Mixer','Circulateur','AND','OR','NAND','NOR','XOR');
      nomCaptionTripoleFr : array[gTripole] of string =
          ('AO','NPN','PNP','Interrupteur','Mlangeur','Circulateur',
           'AND','OR','NAND','NOR','XOR');
      nomCaptionTripoleEn : array[gTripole] of string =
          ('AO','NPN','PNP','Switch','Mixer','Circulator',
           'AND','OR','NAND','NOR','XOR');
      nomQuadripole : array[gQuadripole] of string =
          ('T','OC','Q');
      codeIni : array[TgenreObjet] of char =
          ('M','D','T','Q','L','N','V','A','F');
      NomObjet : array[TgenreObjet] of string =
          ('Masse','Diple','Tripole','Quadripole','Lien','Noeud','Tension','Texte','Frame');
      codeMasse : array[gMasse]of string =
          ('ads','old','triangle','chassis');
      codeDG : array[gDroiteGauche] of string = ('right','left','');
      codeHB : array[boolean] of string = ('bottom','top');
      codeConnect : array[boolean] of string = ('ocirc','circ');
      symboleConnect : array[boolean] of char = ('o','*');

Procedure ResetNoeuds;
Procedure ResetObjets;
Procedure EcritPSTCirc;
Procedure PreambulePSTCirc;
Function AideEtat(aetat : Tetat) : string;
Function AideMove : string;

Procedure PreambuleCircuitikz;
Procedure EcritCircuitikzClip;

Procedure PreambuleIEC;
Procedure EcritIECClip;

function nomCaptionDipole(dipole : gDipole) : string;
function nomCaptionTripole(tripole : gTripole) : string;

var
   moteurLatex : TMoteurLatex;
   Objets : TlistObjet;
   Noeuds : TlistNoeud;
   nomDefault : string;
   LogicWidth : single  = 4*Pas;  // pour PSTricks
   LogicHeight : single = 2*Pas; // pour PSTricks
   LogicConnectLength : single = Pas; // pour PSTricks
   HauteurQtransfo : single = 3*Pas;
   LargeurQ : single = 3*Pas;
   langue : TLanguagePstCirc;
   straightVoltage : boolean = true;
   chaineLangue : string;
   PileSauvegarde: TpileSauvegarde;
   mesDocuments : string;
   ExemplesDir : string;
   helpFile : string;
   {$IFDEF DEBUG}
   fileTrace : TextFile;
   {$ENDIF}

resourceString

sectionQuadripole = 'Quadripole';
sectionTripole = 'Tripole';
sectionMonopole = 'Monopole';
sectionDipole = 'Dipole';
sectionMasse = 'Masse';
sectionTension = 'Tension';
stIdeal = 'Ideal';
stModele = 'Modele';
stzigzag = 'zigzag';
stInvers = 'Invers';
stAntenne = 'Antenne';
stNoyau = 'Noyau';
stAlim = 'Alim';
stTransistor = 'transistor';
stNom = 'nom';
stFrench = 'french';
stCourant = 'Courant';


clicStr = 'Cliquer sur un point rouge ou un espace vide ';
MoveObjectStr = 'Dplacer l''objet';
DebutStr = '(dbut)';
FinStr = '(fin)';
AddStr = 'Cliquer pour ajouter l''objet';
DecaleStr = 'Dplacer le dessin';
baseStr = '(base)';
flecheStr = '(flche)';
aideMoveStr = ' : clic droit pour modifier ; Suppr pour supprimer ; clic+Ctrl pour pivoter';
InvertStr = 'Inversion des bornes + et -';
CoupleurStr = 'Coupleur';
GenericStr = 'Gnrique';
optoCoupleurStr = 'Opto-Coupleur';
CoupleurBisStr = 'Coupleur bis';

clicStrEn = 'Click on a red point or a blank space ';
MoveObjectStrEn = 'Move about the object';
DebutStrEn = '(start)';
FinStrEn = '(stop)';
AddStrEn = 'Click on the diagram to add the object';
DecaleStrEn = 'Shift diagram';
baseStrEn = '(base)';
flecheStrEn = '(arrow)';
aideMoveStrEn = ' : right-click to change ; Del. to delete ; Ctrl+click to rotate';
InvertStrEn = 'Invert + -';
CoupleurStrEn = 'Mixer';
GenericStrEn = 'Generic';
optoCoupleurStrEn = 'Optocoupler';
CoupleurBisStrEn = 'Mixer bis';

const
   SaveFileStr : array[TLanguagePstCirc] of string = ('Sauver le fichier ?','Save the file ?');
   notFoundStr : array[TLanguagePstCirc] of string = (' non trouv',' not found');
   Query1 : array[TLanguagePstCirc] of string = ('Texte','Text');
   Query2 : array[TLanguagePstCirc] of string = ('texte : ','text : ');
   EmetteurUpStr : array[TLanguagePstCirc] of string =('Emetteur en haut','Emitter up');
   EmetteurDownStr : array[TLanguagePstCirc] of string = ('Emetteur en bas','Emitter down');
   DrainDownStr : array[TLanguagePstCirc] of string = ('Drain en bas','Drain down');
   DrainUpStr : array[TLanguagePstCirc] of string = ('Drain en haut','Drain up');

implementation

const
      rayonLogic  = pas/5;
      RayonDi     =  largeurDi;
      nomFiltre : array[gFiltre] of string = ('lowpass','bandpass','highpass','bandstop');
      nomCaptionDipoleFr : array[gDipole] of string = (
      'Rsistance','Capacit','Inductance','Gnrateur de tension','Gnrateur de courant',   // 0..4
      'Ampremtre','Voltmtre','Quartz','Interrupteur','Batterie',                      // 5..9
      'Diode','Diode Zener','GTO','D.E.L.','Interrupteur command','Photodiode','Varicap', // 10..16
      'Lampe','Filtre','VCO','Amplificateur',  // 17..20
      'Moteur cc','NOT','Vac','Poussoir');  // 21..23
      nomCaptionDipoleEn : array[gDipole] of string = (
      'Resistor','Capacitor','Inductor','Voltage source','Current source',   // 0..4
      'Ammeter','Voltmeter','Quartz','Switch','Battery',                      // 5..9
      'Diode','Zener diode','GTO','L.E.D.','Switch','Photodiode','Varicap', // 10..16
      'Lamp','Filter','VCO','Amplifier',  // 17..20
      'DC motor','NOT','Vac','Push switch');  // 21..23
       codeTransistor : array[gTransistor] of string = ('pn','fet','mos','igbt','pn,photo');
       codeRotation : array[0..7] of string =
          ('r','dr','d','dl','l','ul','u','ur');
       codeRotationTikz : array[0..7] of string =
          ('right','above right','above','above left','left','below left','below','below right');

var
    TexteLatex : TstringList;
    texteSup : string; //  cause du moteur de circuitikz qui ne se comporte pas comme un dipole

function VerifNom(Anom : string) : string;
var longueur : integer;
    i : integer;
    prefixe,nomComplet : string;
    compteur : integer;
    carac : char;
begin
    longueur := length(Anom);
    compteur := 0;
    for i := 1 to Noeuds.count-1 do begin
       nomComplet := noeuds[i].Fnom;
       prefixe := copy(nomComplet,1,longueur);
       if (prefixe=Anom) then begin
           if length(nomComplet)=longueur
               then inc(compteur)
               else begin
                   Carac := nomComplet[longueur+1];
                   if charInset(carac,['0'..'9']) then inc(compteur);
               end;
       end;
    end;
    inc(compteur);
    result := Anom+IntToStr(compteur);
end;

function nomCaptionDipole(dipole : gDipole) : string;
begin
    if langue=en then result := nomCaptionDipoleEn[dipole];
    if langue=fr then result := nomCaptionDipoleFr[dipole];
end;

function nomCaptionTripole(tripole : gTripole) : string;
begin
    if langue=en then result := nomCaptionTripoleEn[tripole];
    if langue=fr then result := nomCaptionTripoleFr[tripole];
end;

function AideEtat(aetat : Tetat) : string;
begin
    if langue=fr then
    case aetat of
      eNone: result := '';
      eDeplace: result := MoveObjectStr;
      eLienDebut: result := clicStr+DebutStr;
      eLienFin: result := clicStr+FinStr;
      eAjoute: result := AddStr;
      eDecale: result := DecaleStr;
      eTensionDebut: result := clicStr+BaseStr;
      eTensionFin: result := clicStr+flecheStr;
      eFrameDebut: result := clicStr;
      eFrameFin: result := clicStr;
    end;
    if langue=en then
    case aetat of
      eNone: result := '';
      eDeplace: result := MoveObjectStrEn;
      eLienDebut: result := clicStrEn+DebutStrEn;
      eLienFin: result := clicStrEn+FinStrEn;
      eAjoute: result := AddStrEn;
      eDecale: result := DecaleStrEn;
      eTensionDebut: result := clicStrEn+BaseStrEn;
      eTensionFin: result := clicStrEn+flecheStr;
      eFrameDebut: result := clicStrEn;
      eFrameFin: result := clicStrEn;
    end;
end;

function AideMove : string;
begin
  if langue=fr then result := aideMoveStr;
  if langue=en then result := aideMoveStrEn;
end;

function ajouteNoeud(P : TPointF;const Anom : string) : integer;
var Anoeud : Tnoeud;
    i : integer;
begin
   for i := 1 to Noeuds.count-1 do begin
       if (noeuds[i].FPointF=P) then begin
          result := i;
          exit;
       end;
   end;
   Anoeud := Tnoeud.Create(P,anom);
   result := Noeuds.count;
   Noeuds.add(Anoeud);
end;

function ajouteNoeudLogic(P : TPointF;const Anom : string) : integer;
var Anoeud : Tnoeud;
begin
   Anoeud := Tnoeud.Create(P,anom);
   Anoeud.Fpredefini := true;
   result := Noeuds.count;
   Noeuds.add(Anoeud);
end;

procedure ObjetSuivantTikz(Anoeud : TNoeud;var texte : string);
var i,j : integer;
    trouve : boolean;
    code : string;
begin
    code := '';
    trouve := false;
    i := 0;
    while not trouve and (i<Objets.Count) Do begin
        if objets[i].aTracer then begin
           for j := 1 to Objets[i].NBornes do
               if (objets[i].Noeud[j]=Anoeud) then begin
                 code := objets[i].TexteCircuitikz(j);
                 trouve := true;
                 break;
               end;
        end;
        inc(i);
    end;
    if (code='') and (texte<>'') then code := Anoeud.TexteCircuitikz;
    texte := texte+code;
end;

Procedure ligneP(P1,P2:TpointF);
Begin
   Feuille.DrawLine(P1,P2,1)
end;

Procedure ligneXY(x1,y1,x2,y2:single);
Begin
   Feuille.DrawLine(TPointF.Create(x1,y1),TpointF.Create(x2,y2),1)
end;

procedure RectangleP(P1,P2: TpointF);
var arect : TrectF;
begin
    arect := TrectF.Create(P1,P2);
    feuille.DrawRect(arect,0,0,[],1);
    feuille.FillRect(arect,0,0,[],1);
end;

Procedure cercle(P: TpointF;rr:single;plein : boolean);
var arect : TrectF;
begin
   feuille.Stroke.Thickness := 1;
   aRect := TrectF.Create(P.x-rr,P.y-rr,P.x+rr,P.y+rr);
   if plein
      then begin
          feuille.Fill.Kind := TBrushKind.Solid;
          feuille.FillEllipse(aRect,1);
      end
      else feuille.DrawEllipse(aRect,1);
end;

Procedure arc(P: TpointF;rr:single;startAngle,SweepAngle : single);
var rayon : TpointF;
begin
   feuille.Stroke.Thickness := 1;
   rayon.X := rr;
   rayon.Y := rr;
   feuille.DrawArc(P,rayon,startAngle,sweepAngle,1);
end;

Procedure Tobjet.OutTextP(x,y : single;const s:String);
var arect : TrectF;
    L,H : single;
    P : TpointF;
Begin
   if s='' then exit;
   P := PointRel(x,-y);
   L := feuille.TextWidth(S)/2;
   H := feuille.TextHeight(S)/2;
   arect := TrectF.Create(P.x-L,P.y-H,P.x+L,P.y+H);
   feuille.Fill.kind := TBrushKind.Solid;
   feuille.Font.Style := [TFontStyle.fsBold];
   feuille.FillText(aRect,s,false,
         1,[TFillTextFlag.RightToLeft],
         TTextAlign.Center,TTextAlign.Center);
End;

Function indexObjet(Aobjet : Tobjet) : integer;
var i : integer;
begin
   result := 0;
   for i := 0 to Objets.Count - 1 do
         if Aobjet=objets[i] then begin
            result := i;
            break;
         end;
end;

function FTS(x : single) : string;
var posV : integer;
begin
   result := floatToStrF(x/(2*Pas),ffFixed,4,2);
   posV := pos(',',result);
   if posV>0 then result[posV] := '.';
   posV := pos('.',result);
   if posV>0 then begin
      if result[length(result)]='0' then delete(result,length(result),1);
      if result[length(result)]='0' then delete(result,length(result),1);
      if result[length(result)]='.' then delete(result,length(result),1);
   end;
end;


Function PointLatex(P : TPointF) : string;
begin
    result := '('+FTS(P.X-origineX)+','+FTS(origineY-P.Y)+')';
end;

Function TObjet.DessineCircuitikz : string;
begin
    FAtracer := true;
    result := '';
end;

Function TObjet.DessineIEC : string;
begin
    FAtracer := true;
    result := '';
end;

Function TObjet.LabelOffsetLatex : string;

function FTS : string;
var posV : integer;
begin
   result := floatToStrF(-2*labelOffset/demiPas,ffFixed,3,1);
   posV := pos(',',result);
   if posV>0 then result[posV] := '.';
end;

begin
    result := 'labeloffset='+FTS
end;

procedure ajouteOption(var option : string;const a : string);
begin
    if option='' then option := '[' else option := option+',';
    option := option+a;
end;

function Tobjet.PointRel(larg,haut : single) : TpointF;
var dx,dy : single;
begin
     result := FPointF;
     dx := larg*cos(Fangle*Pi/4)+haut*sin(Fangle*Pi/4);
     dy := -larg*sin(Fangle*Pi/4)+haut*cos(Fangle*Pi/4);
     result.offset(dx,dy)
end;

function NomLatex(Anom : string) : string;
var posEgal : integer;
begin
 // pour circuitikz, remplacer = par {=}
   if moteurLatex=lTikz then begin
      posEgal := pos('=',anom);
      if posEgal>0 then begin
        insert('{',Anom,posEgal);
        insert('}',Anom,posEgal+2);
      end;
   end;
   if anom=''
      then result := ''
      else result := '$'+Anom+'$'
end;

Procedure TNoeud.Affiche(FPath : TPathData);
var P1,P2 : TpointF;
Begin
   if Fpredefini then ; // ??
   P1 := FPointF;
   P2 := FPointF;
   P1.Offset(-dimBorne,-dimBorne);
   P2.Offset(dimBorne,dimBorne);
   FPath.addRectangle(TrectF.Create(P1,P2),0,0,[]);
end;

function TObjet.TexteCircuitikz(j : integer) : string;
begin
  FAtracer := false;
  result := '';
end;

function TObjet.TexteIEC(j : integer) : string;
begin
  FAtracer := false;
  result := '';
end;

procedure Ttripole.ChercheNoeuds;
var i : integer;
begin
    if (moteurLatex=lPST)
       then case Modele of
           tSwitch: for i := 1 to 3 do
              FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
           else inherited
       end
       else inherited
end;

function Ttripole.TexteCircuitikz(j : integer) : string;
const
   textTransistor : array[gTransistor,1..3] of char =
      (('B','E','C'),
       ('G','S','D'),
       ('G','S','D'),
       ('B','E','C'),
       ('B','E','C'));
   codeOpAmp : array[1..3] of string = ('-','+','out');
   codeLogic : array[1..3] of string = ('in 2','in 1','out');
   codeSwitch : array[1..3] of string = ('in','out 2','out 1');
   codeMixer : array[1..3] of char = ('1','3','2'); // 2 en bas 4 en haut
var code : string;
    k : integer;
begin
     result := '';
     if BorneATracer[j] then begin
        BorneATracer[j] := false;
        case Modele of
           tnpn : begin
             k := j;
             if inversion and (j in [3,2]) then k := 5-j;
             code := textTransistor[ModeleTransistor,k];
           end;
           tpnp : begin
             k := j;
             if not inversion and (j in [3,2]) then k := 5-j;
             code := textTransistor[ModeleTransistor,k];
           end;
           tAO : begin
              code := codeOpAmp[j];
              if not inversion and (j in [1,2]) then code := codeOpAmp[3-j];
           end;
           (*
           tPotar : begin //  traiter comme un dipole !
                  case j of
                     1,2 : begin
                         result := '';
                         BorneATracer[j] := false;
                         exit;
                     end;
                     3 : code := 'wiper';
                  end;
           end;
           *)
           tSwitch: code := codeSwitch[j];
           tand,tnand,tor,tnor,txor : code := codeLogic[j];
           tCirculator : begin
              code := intToStr(j);
              if code='4' then code := '3'; //  cause de yscale=-1
           end;
           tMixer : begin
              if j=1 then code := '1';
              if j=2 then code := '3';
              if j=3 then if sortieEnHaut
                  then code := '4'
                  else code := '2';
           end;
        end;
        if FIndexNoeud[j]=0 then
             FindexNoeud[j] := ajouteNoeud(borne[j],CodeBorne[j]);
             // if not trouve crer le noeud
        code := Noeud[j].texteCircuitikz+ '-| ('+FnomObjet+'.'+code+')';
        (*
        if (j in [1,2]) and BorneATracer[3-j]  then begin
           BorneATracer[3-j] := false;
           objetSuivantTikz(Noeud[3-j],code);
        end;
        *)
        result := code;
     end;
end; // Ttripole.TexteCircuitikz

function Ttripole.DessineCircuitikz : string;
const
   codePorte : array[tAND..tXOR] of string = ('and','or','nand','nor','xor');
var code : string;
    i : integer;
    PosT : TpointF;
begin
    for i := Low(indexBornes) to High(indexBornes) do
        BorneATracer[i] := true;
    for I := 1 to 3 do
         if FIndexNoeud[i]=0 then
             FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
             // if not trouve crer le noeud
    FaTracer := false;
    PosT := FPointF;
    result := '';
    code := '';
    case Modele of
        tAO: begin
           code := 'op amp';
           if not inversion then code := code+',yscale=-1';
           if alimentation then code := 'fd '+code;
           setNomObjet('AO');
           PosT.x := (borne[1].x+borne[3].x)/2;
           PosT.y := borne[1].y+pas;
        end;
        tSwitch: begin
           code := 'spdt';
           code := code+',scale=0.8';
           // Pour avoir les sorties  +- 1/4 en x et y
           setNomObjet('Sw');
        end;
        tnpn:begin
             code := 'n'+codeTransistor[ModeleTransistor];
             if withDiode then code := code+',bodydiode';
             if inversion then code := code+',yscale=-1';
             if modeleTransistor=tPhoto then BorneAtracer[1] := false;
             setNomObjet('npn');
        end;
        tpnp:begin
            case modeleTransistor of
               tBipolaire : code := 'pnp';
               tPhoto : code := 'pnp,photo';
               else code := 'p'+codeTransistor[ModeleTransistor];
            end;
            if withDiode then code := code+',bodydiode';
            if inversion then code := code+',yscale=-1';
            if ModeleTransistor=tPhoto then BorneAtracer[1] := false;
            setNomObjet('pnp');
        end;
        (*
        tpotar: begin  //  traiter comme un dipole !
           setNomObjet('Pot');
           if zigzag
              then code := 'american potentiometer'
              else code := 'pR';
           code := '\draw '+Noeud[2].texteCircuitikz + ' to ['+code+',n='+FnomObjet+'] '+Noeud[1].texteCircuitikz +' ;';
           TexteLatex.add(code);
           exit;
        end;
        *)
        tMixer: begin
           setNomObjet('M');
           code := 'mixer';
        end;
        tcirculator : begin
           setNomObjet('C');
           code := 'circulator';
           if sortieEnHaut then code := code+',yscale=-1';
        end;
        tAND,tOR,tNOR,tNAND,tXOR : begin
           setNomObjet('porte');
           code := codePorte[Modele]+' port,yscale=0.9';
           posT.offset(LogicWidth,-LogicHeight/2);
        end;
    end;
    if code='' then exit;
    if (Modele=tAO) and not inversion and (Fnom<>'') then begin
        code := '\draw '+pointLatex(PosT)+' node['+code+'] ('+FnomObjet+') {} '+
                pointLatex(posT)+' node[right] {'+nomLatex(Fnom)+'};';
      // texte  part, sinon l'inversion des bornes inverse le nom
    end
    else code := '\draw '+pointLatex(PosT)+' node['+code+'] ('+FnomObjet+') '+
                '{'+nomLatex(Fnom)+'};';
    result := code;
end; // dessineCircuitTikz

procedure Ttripole.EcritPSTCirc;

const nomLogic : array[tAND..tXOR] of string = ('and','or','nand','nor','xor');
var code,option,temp : string;
    i : integer;
    nom1,nom2 : string;
begin
   option := '';
   case Modele of
        tAO: begin
           code := '\OA';
           if french then ajouteOption(option,'tripolestyle=french');
           if not inversion then ajouteOption(option,'OAinvert=false');
           if alimentation then ajouteOption(option,'OApower=true');
           if not ideal then ajouteOption(option, 'OAperfect=false');  // AO ideal Stein 18/11/11
(*
OAperfect=false
OAiplus (boolean): (default: false)
OAiminus (boolean): (default: false)
OAiout (boolean): (default: false)
OAipluslabel (string): (default: \empty )
OAiminuslabel (string): (default: \empty )
OAioutlabel (string): (default: \empty )
*)
        end;
        tSwitch:begin
           code := '\Tswitch';
           ajouteOption(option,'tripolestyle='+codeDG[DroiteGauche]);
        end;
        tnpn:begin
           code := '\transistor';
           temp := floatToStr((noeud[2].FPointF.X - noeud[1].FPointF.X)/(2*Pas)-0.5);
           i := AnsiPos(',',temp);
           if i>0 then temp := copy(temp,0,i-1) + '.' + copy(temp,i+1,length(temp));
           ajouteOption(option,'basesep='+temp);// basesep = (E.x - B.x - 0.5)
           case ModeleTransistor of
              tFET : ajouteOption(option,'transistortype=FET');
              tMOS : ajouteOption(option,'transistortype=NMOS');
              tIGBT : ;
           end;
        end;
        tpnp:begin
           code := '\transistor';
           ajouteOption(option,'transistortype=PNP');
           temp := floatToStr((noeud[2].FPointF.X - noeud[1].FPointF.X)/(2*Pas)-0.5);
           i := AnsiPos(',',temp);
           if i>0 then temp := copy(temp,0,i-1) + '.' + copy(temp,i+1,length(temp));
           ajouteOption(option,'basesep='+temp);// basesep = (E.x - B.x - 0.5)
           case ModeleTransistor of
               tFET : ajouteOption(option,'transistortype=FET');
               tMOS : ajouteOption(option,'transistortype=PMOS');
               tIGBT : ;
           end;
        end;
(*
transistorinvert (boolean): (default: false)
transistoribase (boolean): (default: false)
transistoricollector (boolean): (default: false)
transistoriemitter (boolean): (default: false)
transistoribaselabel (string): (default: \empty )
transistoricollectorlabel (string): (default: \empty )
transistoriemitterlabel (string): (default: \empty )
*)    (*
      tpotar: begin
          code := '\potentiometer';
          if zigzag then ajouteOption(option, 'dipolestyle=zigzag');
      end;
      *)
      tMixer: begin
           code := '\mixer';
           ajouteOption(option,'tripolestyle='+codeHB[sortieEnHaut]);
           ajouteOption(option,'inputarrow=true');
      end;
      tcirculator : begin
          code := '\circulator{0}';
        //  ajouteOption(option,'tripolestyle=circulator');
      end;
      tAND,tOR,tNOR,tNAND,tXOR : begin
          code := '\logic';
          ajouteOption(option,'logicType='+nomLogic[Modele]);
          if Modele in [tNOR,tNAND] then ajouteOption(option,'invertoutput=true');
      end;
   end;
   if option<>'' then code := code+option+']';
   case Modele of
       tnand,tand,tor,tnor,txor : code := code+pointLatex(FPointF);
       tSwitch : begin
          code := '\pnodes(-1,1){A}(+1,1){B}(0,-0.5){C}'+code;
          code := code+'(A)(B)(C)'+'{'+nomLatex(Fnom)+'}';
       end;
       (*
       tPotar : begin
            code := '\pnodes(-1,0){A}(+1,0){B}(0,-1){C}'+code;
            code := code+'(A)(B)(C)'+'{'+nomLatex(Fnom)+'}';
       end
       *)
       else for i := 1 to 3 do
          code := code+'('+noeud[i].Fnom+')';
   end;
   if Modele in [tMixer,tCirculator,tNAND,tOR,tNOR,tAND,tXOR]
      then code := code+'{'+Fnom+'}';
   if Modele in [tMixer,tCirculator]
      then code := code+'{}';
   case Modele of
        tSwitch : code := '\rput'+
             '{'+intToStr(45*Fangle)+'}'+pointLatex(FPointF)+'{'+code+'}';
        else if Fangle<>0 then code := '\rput'+
       '{'+intToStr(45*Fangle)+'}'+'{'+code+'}';
   end;
   for i := 1 to 3 do begin
       if FIndexNoeud[i]=0 then begin
           FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
           Noeud[i].ecritPSTCirc; // if not trouve crire le noeud
       end;
   end;
   TexteLatex.add(code);
   if Modele in [tNand,tAnd,tOr,tNor,tXor,tSwitch] then
      for i := 1 to 3 do begin
          nom1 := noeud[i].Fnom;
          nom2 := codeBorne[i];
          if (nom1<>nom2) then
              TexteLatex.Add('\wire'+'('+nom1+')'+'('+nom2+')');
      end;
end; // tripole.ecritPSTCirc

function TNoeud.TexteCircuitikz : string;
begin
     result := ' '+pointLatex(FPointF)+' '
end;

function TNoeud.TexteIEC : string;
begin
     result := ' '+pointLatex(FPointF)+' '
end;

procedure TNoeud.EcritPSTCirc;
begin
    if not Fpredefini then
       TexteLatex.add('\pnode '+pointLatex(FPointF)+' {'+Fnom+'}');
(*
intersect (boolean): (default: false)
intersectA (node):
intersectB (node):
*)
end;

function TCarrefour.TexteCircuitikz(j : integer) : string;
var texte : string;
begin
     FaTracer := false;
     texte := '';
     ObjetSuivantTikz(Noeud[j],texte);
     result := texte;
end;

procedure Tcarrefour.EcritPSTCirc;
begin
   TexteLatex.add('\pscircle*('+noeud[1].Fnom+'){2\pslinewidth}');
   if Fnom<>'' then
      TexteLatex.add('\uput['+codeRotation[Fangle]+']('+noeud[1].Fnom+'){'+nomLatex(Fnom)+'}');
end;

function Ttexte.DessineCircuitikz : string;
begin
    Fatracer := false;
    result := '\draw '+Noeud[1].texteCircuitikz+' node[]{'+nomLatex(Fnom)+'};';
  //  '+codeRotationTikz[Fangle]+'
end;

function Tcarrefour.DessineCircuitikz : string;
var i,j : integer;
    avecTrace : boolean;
begin
    Fatracer := true;
    result := '';
    i := 0;
    avecTrace := false;
    if straightVoltage then
    while not avecTrace and (i<Objets.Count) Do begin
        if objets[i] is TTension then begin
           for j := 1 to Objets[i].NBornes do
               if (objets[i].Noeud[j]=Noeud[1]) then begin
                 avecTrace := true;
                 break;
               end;
        end;
        inc(i);
    end;
    if Fnom<>''
       then result := '\draw'+Noeud[1].texteCircuitikz+'node['+codeRotationTikz[Fangle]+']{'+nomLatex(Fnom)+'} ;'
       else if avecTrace
            then result :=  '\draw'+Noeud[1].texteCircuitikz+'node['+codeConnect[FConnected]+'] {};';
end;

procedure Ttexte.EcritPSTCirc;
begin
    TexteLatex.add('\uput['+codeRotation[Fangle]+']('+noeud[1].Fnom+'){'+nomLatex(Fnom)+'}');
end;

procedure TObjet.ChercheNoeuds;
begin
   FaTracer := true;
end;

function Tobjet.getAtracer : boolean;
begin
    result := FAtracer;
end;

function Tquadripole.getAtracer : boolean;
begin
    result := primaireAtracer or secondaireATracer;
end;

function Ttripole.getAtracer : boolean;
var i : integer;
begin
    result := false;
    for i := 1 to 3 do
        result := result or BorneATracer[i];
end;

procedure TCarrefour.ChercheNoeuds;
begin
    FindexNoeud[1] := ajouteNoeud(FPointF,verifNom('N'));
end;

procedure TTexte.ChercheNoeuds;
begin
    FindexNoeud[1] := ajouteNoeud(FPointF,verifNom('T'));
end;

procedure TMonopole.ChercheNoeuds;
begin
    FindexNoeud[1] := ajouteNoeud(FPointF,verifNom('M'));
end;

function TDipole.DessineCircuitikz : string;
begin
     result := '';
     case Modele of
       dNot : begin
          setNomObjet('N');
          result := '\draw '+pointLatex(FPointF)+' node[not port] ('+FnomObjet+') {}  ;';
       end;
     end;
end;

function TDipole.TexteCircuitikz(j : integer) : string;
const codeON : array[boolean] of char = ('o','*');
var code,option : string;
    i : integer;
    avecNom : boolean;
    N : TNoeud;
    codeA,codeB : char;
    Acarrefour : Tcarrefour;
begin
     FaTracer := false;
     result := '';
     option := '';
     for i := 1 to 2 do
         if FIndexNoeud[i]=0 then
             FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
     case Modele of
        dR:code := 'R';
        dC:begin
           code := 'C';
           if capaChimique then code := 'eC';
        end;
        dQuartz: code := 'PZ';
        dBat: code :='battery';
        dL: code := 'L'; // cute inductor ? european inductor : rectangle plein
        dGT: code := 'V'; // voltage source
        dGC: code := 'I';
        dAm: code :='ammeter';
        dVm: code :='voltmeter';
        //dOm: code := 'ohmmeter';
        dDiode : code := 'D'+codeON[isON];
        dPhotoDiode : code := 'pD'+codeON[isON];
        dvaricap : code := 'VC'+codeON[isON];
        dGTO : code := 'Ty'+codeON[isON];
        dinterC : code := 'Ty';
        dlampe : code := 'lamp';
        dZener : code := 'zD'+codeON[isON];
        dLed : code := 'leD'+codeON[isON];
        dSwitch : code :='switch';
        dPushSwitch : code :='swpb';
        dFilter : code := nomFiltre[filtre];
        dVCO : code := 'vco';
        dAmpli : code := 'amp';
        dMotor : begin
           code := 'Telmech';
           if Fnom<>'' then begin
              setNomObjet('M');
              texteSup := texteSup+'\draw ('+FnomObjet+') node[]{'+Fnom+'} ;';
              code := code+',n='+FnomObjet;
           end;
        end;
        dGTac : code := 'sV';
        dNot :  code := Noeud[j].texteCircuitikz +
                    '-- ('+FnomObjet+'.in)'+
                      ' ('+FnomObjet+'.out) -- '; // cas particulier
    end;
    if (Modele<>dNot) then begin
       if variable and (Modele in [dR,dC,dL]) then code := 'v'+code;
       codeA := ' ';codeB := ' ';
       for I := 0 to Objets.Count - 1 do
         if (objets[i] is Tcarrefour) then begin
             Acarrefour :=  TCarrefour(objets[i]);
             N := Acarrefour.Noeud[1];
             if (N=Noeud[j]) and (Acarrefour.Fnom<>'') then begin
                codeA := symboleConnect[Acarrefour.Fconnected];
                Acarrefour.FaTracer := false;
             end;
             if (N=Noeud[3-j]) and (Acarrefour.Fnom<>'') then begin
                codeB := symboleConnect[Acarrefour.Fconnected];
                Acarrefour.FaTracer := false;
             end;
         end;
       if codeA<>' ' then option := ','+codeA+'-';
       if codeB<>' ' then begin
          if option='' then option := ',-';
          option := option+codeB;
       end;
       avecNom := (Fnom<>'');
       case Modele of
            dMotor : avecNom := false;
            dGT,dGC,dGTac,dBat : avecNom := avecNom and (tension='');
       end;
       if avecNom then
          code := code+',l='+nomLatex(Fnom);
       if tension<>'' then if ((j=1) and inverseTension) or
                              ((j=2) and not inverseTension)
          then code := code+',v>='+nomLatex(tension)
          else code := code+',v<='+nomLatex(tension);
       if courant<>'' then if ((j=1) and inverseCourant) or
                              ((j=2) and not inverseCourant)
          then code := code+',i>='+nomLatex(courant)
          else code := code+',i<='+nomLatex(courant);
       code := Noeud[j].texteCircuitikz + 'to ' + '['+code+option+'] ';
    end;
    objetSuivantTikz(Noeud[3-j],code); // 1-> 2 et 2-> 1
    result := code;
end;

function TDipole.TexteIEC(j : integer) : string;
var code : string;
    i : integer;
begin
     FaTracer := false;
     result := '';
     for I := 1 to 2 do
         if FIndexNoeud[i]=0 then
             FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
     case Modele of
        dR:code := 'resistor';
        dC:code := 'capacitor';
        dQuartz: code := 'quartz';
        dBat: code :='battery';
        dL: code := 'inductor'; // cute inductor ? european inductor : rectangle plein
        dGT: code := 'voltage source'; // pour avoir un european voltage spource !?
        dGC: code := 'current source';
        dAm: code :='ammeter';
        dVm: code :='voltmeter';
        dDiode : code := 'diode';
        dPhotoDiode : code := 'diode={light dependent}';
        dvaricap : code := 'varicap';
        dGTO : code := '';
        dinterC : code := '';
        dlampe : code := 'bulb';
        dZener : code := 'Zener diode'; // Schottky tunnel backward breakdown
        dLed : code := 'ciode={light emitting}';
        dSwitch : code :='make contact';
        dPushSwitch : code :='';
        dFilter : code := nomFiltre[filtre];
        dVCO : code := '';
        dAmpli : code := '';
        dMotor : code := '';
        dGTac : code := '';
        dNot :  code := '';
     end;
     if (Modele<>dNot) then begin
       if variable then code := 'ajustable'+code;
       if (Fnom<>'') and (modele<>dMotor)
          then code := code+',info='+nomLatex(Fnom);
       if tension<>'' then
          code := code+',v='+nomLatex(tension);
       if courant<>'' then
          code := code+',i='+nomLatex(courant);
       code := Noeud[j].texteCircuitikz + 'to ' + '['+code+'] ';
     end;
     objetSuivantTikz(Noeud[3-j],code); // 1-> 2 et 2-> 1
     result := code;
end;

procedure Tdipole.EcritPSTCirc;
var code,option : string;
    i : integer;
    LPoint : TPointF;
begin
    option := '';
    case Modele of
        dR:begin
            code := '\resistor';
            ajouteOption(option, 'labeloffset=0');
            if zigzag then
              ajouteOption(option, 'dipolestyle=zigzag');
        end;
        dC,dQuartz:begin
           code := '\capacitor';
           if capaChimique then ajouteOption(option,'dipolestyle=chemical');
           if Modele=dQuartz then ajouteOption(option,'dipolestyle=crystal');
        end;
        dBat: code :='\battery';
        dL: begin
           code := '\coil';
           ajouteOption(option,'dipolestyle=curved');
        end;
        dGT: begin
           if variable
              then code := '\vac'
              else begin
                  code := '\Ucc';
                  ajouteOption(option,'dipoleconvention=generator');
                  ajouteOption(option,'labelInside=1');
              end;
        end;
        dGC: begin
           code := '\Icc';
           ajouteOption(option,'dipoleconvention=generator');
        end;
        dAm,dVm: begin
           labeloffset := 0;
           code :='\circledipole';
           ajouteOption(option,labelOffsetLatex);
        end;
        dDiode,dGTO,dvaricap : begin
           code := '\newdiode';
           if not ison then ajouteOption(option, 'ison=false'); // IS ON   Stein 19/05/13
           if Modele=dGTO then ajouteoption(option,'dipolestyle=GTO');
        end;
        dPhotoDiode : begin
           code := '\cell';
        end;
        dInterC : code := '\interC';
        dLampe : code := '\lamp';
        dZener : begin
           code := '\newZener';
           if not ison then ajouteOption(option, 'ison=false'); // IS ON   Stein 19/05/13
        end;
        dLed : begin
           code := '\newLED';
           if not ison then ajouteOption(option, 'ison=false'); // IS ON   Stein 19/05/13
        end;
        dSwitch : begin
           code :='\newSwitch';
           if not ison then ajouteOption(option, 'ison=false'); // IS ON   Stein 19/05/13
        end;
        dPushSwitch : begin
           code :='\swpb';
           if ison then ajouteOption(option, 'contactclodsed=true');
        end;
        dFilter :  begin
            code := '\filter';
            ajouteOption(option,'dipolestyle='+nomFiltre[filtre]);
        end;
        dVCO : code := '\vco';
        dAmpli : code := '\amplifier';
        dMotor : begin
           code := '\newarmature';
           ajouteOption(option, 'labelInside=1'); // Motor   Stein 19/05/13
        end;
        dGTac : code := '\vac';     //    Stein 19/05/13
        dNot : begin
            code := '\logic';
            ajouteOption(option,'logicType=not');
            ajouteOption(option,'invertoutput=true');
        end;
    end;
    if tension<>'' then begin
       ajouteOption(option,'tensionlabel='+nomLatex(tension));
       ajouteOption(option,'tensionlabeloffset=-1');
       ajouteOption(option,'tensionoffset=-0.7');
       if not inverseTension then ajouteOption(option,'dipoleconvention=generator'); // receptor par dfaut
    end;
(*
tension (boolean): (default: false)
tensionoffset (dimension): (default: 1)
tensionlabeloffset (dimension): (default: 1.2 )
tensioncolor (PSTricks color): (default: black)
tensionlabelcolor (PSTricks color): (default: black)
tensionwidth (dimension): (default: \pslinewidth)
*)
    if courant<>'' then begin
       ajouteOption(option,'intensitylabel='+nomLatex(courant));
       if not inverseCourant then ajouteOption(option,'directconvention=false');  // true par dfaut
    end;
(*
intensity (boolean): (default: false)
intensitylabeloffset (dimension): (default: 0.5 )
intensitycolor (PSTricks color): (default: black)
intensitylabelcolor (PSTricks color): (default: black)
intensitywidth (dimension): (default: \pslinewidth)
*)
    if variable then
       ajouteOption(option,'variable');
    if option<>'' then code := code+option+']';
    if Modele=dNot
       then begin
          LPoint := PointRel(0,+2*pas); // FPointF pointe sur l'origine en bas  gauche
          code := code+pointLatex(LPoint);
          code := code+'{'+Fnom+'}';
       end
       else begin
          for i := 1 to 2 do begin
             if FIndexNoeud[i]=0 then begin
                FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
                Noeud[i].ecritPSTCirc; // if not trouve crire le noeud
             end;
          code := code+'('+noeud[i].Fnom+')';
          end;
          code := code+'{'+nomLatex(Fnom)+'}';
       end;
    TexteLatex.add(code);
end; // dipole ecritPSTCirc

function TQuadripole.DessineCircuitikz : string;
var code : string;
    posBase : TpointF;
    i : integer;
begin
     FaTracer := true;
     for I := 1 to 4 do
         if FIndexNoeud[i]=0 then
             FindexNoeud[i] := ajouteNoeud(borne[i],CodeBorne[i]);
     case Modele of
        qtransfo: begin
           code := 'transformer';
           if noyau  then code := code + ' core';
           code := code+',yscale=0.952';
              // hauteur transfo 2.1 ; pour hauteur 3 x1.429 ou pour 2 x0.952
           setNomObjet('T');
        end;
        qoptoC: begin
           code := 'coupler';
           code := code+',yscale=1.1';
           setNomObjet('C');
        end;
        qGenerique: begin
           code := 'coupler2';
           code := code+',yscale=1.1';
           setNomObjet('C');
        end;
     end;
     Posbase.x := (borne[1].x+borne[3].x)/2;
     if Modele=qTransfo
        then begin
           PosBase.y := borne[1].y;
           result := '\draw '+pointLatex(posBase)+' node['+code+'] ('+FnomObjet+
               ') {} ('+FnomOBjet+'.base) node{'+nomLatex(Fnom)+'} ;';
        end
        else begin
           Posbase.y := FPointF.y;
           result := '\draw '+pointLatex(posBase)+' node['+code+'] ('+FnomObjet+
               ') {'+nomLatex(Fnom)+'} ;';
        end;
     // T.A1 et T.A2 sont les bornes du primaire
     // T.B1 et T.B2 sont les bornes du secondaire
     // T.base le milieu du sommet
     primaireAtracer := true;
     secondaireAtracer := true;
end;

function TQuadripole.TexteCircuitikz(j : integer) : string;
const codeOpto : array[1..4] of char = ('4','1','3','2');
var code : string;
begin
     result := '';
     if (j in [1,2]) and primaireATracer then begin
        primaireAtracer := false;
        if Modele=qtransfo
           then code := Noeud[j].texteCircuitikz+ '-| ('+FnomObjet+'.A'+intToStr(j)+
                 ') ('+FnomObjet+'.A'+intToStr(3-j)+') |-'
           else code :=  Noeud[j].texteCircuitikz+ '-| ('+FnomObjet+'.'+codeOpto[j]+
                 ') ('+FnomObjet+'.'+codeOpto[3-j]+') |-';
        objetSuivantTikz(Noeud[3-j],code); // 1 > 2 et 2 > 1
        result := code;
     end;
     if (j in [3,4]) and secondaireATracer then begin
        secondaireAtracer := false;
        if Modele=qtransfo
           then code := Noeud[j].texteCircuitikz+ '-| ('+FnomObjet+'.B'+intToStr(j-2)+
                 ') ('+FnomObjet+'.B'+intToStr(5-j)+') |-'
           else code := Noeud[j].texteCircuitikz+ '-| ('+FnomObjet+'.'+codeOpto[j]+
                 ') ('+FnomObjet+'.'+codeOpto[7-j]+') |-';
        // (j-2) : 3 > 1 et 4 > 2
        objetSuivantTikz(Noeud[7-j],code); // 3 > 4 et 4 > 3
        result := code;
     end;
end;

procedure Tquadripole.EcritPSTCirc;
var code,option : string;
    i : integer;
begin
    option := '';
    case Modele of
        qtransfo:code := '\transformer';
        qoptoC:code := '\optoCoupler';
        qGenerique: code := '\quadripole';
    end;
    code := code+option;
//  gauche puis droite ; bas puis haut
//  2 d'cart vertical entre les deux bornes
    for i := 1 to 4 do
        code := code+'('+noeud[i].Fnom+')';
    code := code+'{'+nomLatex(Fnom)+'}';
    TexteLatex.add(code);
(*
transformeriprimary (boolean): (default: false)
transformerisecondary (boolean): (default: false)
transformeriprimarylabel (string): (default: \empty )
transformerisecondarylabel (string): (default: \empty )
*)
end;

function TMonopole.TexteCircuitikz(j : integer) : string;
const codeM : array[gMasse] of string = ('ground','rground','sground','cground');
// terre,ref,signal,chassis
const codeA : array[gAntenne] of string = ('antenna','rxantenna','txantenna','');
begin
     FaTracer := false;
     case Modele of
          mMasse : begin
             result := Noeud[1].texteCircuitikz +'node ['+codeM[ModeleM]+']{}';
             //  if connectingdot then ajouteOption(option,'connectingdot');
          end;
          mAntenne : result := Noeud[1].texteCircuitikz +'node ['+codeM[modeleM]+']{}';
          else result := ''; // pour le compilateur
     end;
end;

procedure TMonopole.EcritPSTCirc;
var code,option : string;
begin
    code :='\newground';
    option := '';
    ajouteOption(option,'groundstyle=' + codeMasse[ModeleM]);
    if not connectingdot then
       ajouteOption(option,'connectingdot=false');
    if option<>'' then code := code + option+']';
    if Fangle<>0 then code := code + '{'+intToStr(45*Fangle)+'}';
    code := code + '('+noeud[1].Fnom+')';
    TexteLatex.add(code);
end;

function TLien.TexteCircuitikz(j : integer) : string;
var i : integer;
begin
      result := '';
      if j=1 then begin
         FaTracer := false;
         i := 1;
         while i<NBornes do begin
            result := result+noeud[i].texteCircuitikz+'--';
            inc(i);
         end;
         ObjetSuivantTikz(noeud[NBornes],result);
      end;
      if (j=NBornes) and FaTracer then begin
         FaTracer := false;
         i := NBornes;
         while i>1 do begin
             result := result+noeud[i].texteCircuitikz+'--';
             dec(i);
         end;
         ObjetSuivantTikz(noeud[1],result);
      end;
      // j au milieu : ne pas tracer
end;

procedure Tlien.EcritPSTCirc;
var i : integer;
    nom1,nom2 : string;
begin
     for i := 1 to NBornes-1 do begin
         nom1 := noeud[i].Fnom;
         nom2 := noeud[i+1].Fnom;
         if nom1<>nom2 then
            TexteLatex.Add('\wire'+'('+nom1+')'+'('+nom2+')');
     end;
end;

function TTension.DessineCircuitikz : string;
var AngleTension : single;
    NoeudA,NoeudB : TpointF;

function PointRelTikz(aPoint : TpointF;decale : single) : TpointF;
var dx,dy : single;
begin
     result := aPoint;
     dx := decale*cos(angleTension);
     dy := decale*sin(angleTension);
     result.offset(dx,dy)
end;

var Aconnect,Bconnect : boolean;
    i : integer;
    N : TNoeud;
    codePos : string;
begin
     chercheNoeuds;
     FaTracer := false;
     angleTension := Noeud[2].FPointF.Angle(Noeud[1].FPointF);
     NoeudA := PointRelTikz(Noeud[1].FPointF,demipas);
     NoeudB := PointRelTikz(Noeud[2].FPointF,-demipas);
     Aconnect := False;
     Bconnect := False;
     for I := 0 to Objets.Count - 1 do
         if (objets[i] is Tcarrefour) then begin
             N := TCarrefour(objets[i]).Noeud[1];
             if N=Noeud[1] then Aconnect := TCarrefour(objets[i]).Fconnected;
             if N=Noeud[2] then Bconnect := TCarrefour(objets[i]).Fconnected;
         end;
     if labelOffset<0
        then codePos := ',above'
        else if labelOffset>0
           then codePos := ',below'
           else codePos := '';
// \draw (A) to[open, v<=$V_1$] (B);
//  tester
     if straightVoltage
        then result := '\draw'+
               ' node['+codeConnect[Aconnect]+'] (A) at '+Noeud[1].texteCircuitikz+'{}'+
               ' node['+codeConnect[Bconnect]+'] (B) at '+Noeud[2].texteCircuitikz+'{}'+
               '[->,>=latex] '+PointLatex(NoeudA)+' -- '+PointLatex(NoeudB)+' node[midway'+
               codePos+',sloped] {'+nomLatex(Fnom)+'};'
        else result := '\draw'+
               ' node (A) at '+Noeud[1].texteCircuitikz+'{}'+
               ' node (B) at '+Noeud[2].texteCircuitikz+'{}'+
               ' (A) to[open,v<='+nomLatex(Fnom)+','+symboleConnect[Aconnect]+'-'+symboleConnect[Bconnect]+'] (B);';
end;

procedure TTension.EcritPSTCirc;
begin
     chercheNoeuds;
     if (FindexNoeud[1]=0) or (FIndexNoeud[2]=0) then exit; // ne devrait pas arriver !
     TexteLatex.Add('\tension'+
             '['+labelOffsetLatex+']'+
             '('+noeud[1].Fnom+')'+
             '('+noeud[2].Fnom+')'+'{'+nomLatex(Fnom)+'}');
end;

{******************************   DRAW TRIPOLE  ***************************** }

Procedure Ttripole.Affiche;

Procedure Cellule_AO;
const
   nomBorne : array[boolean] of string = ('+','-');
var h,l : single;
Begin
  RectangleP(PointRel(-LargeurTri,-hauteurTri),
             PointRel(+LargeurTri,+hauteurTri));
  l := -2*largeurTri/3;
  h := 2*hauteurTri/3; // 1 unit
  feuille.Font.Size := 16;
  outTextP(l,-h,nomBorne[not inversion]);
  outTextP(l,h,nomBorne[inversion]);   // vu
End;

Procedure Cellule_Logic;
const nomLogic : array[tAND..tXOR] of string = ('&','>1','&','>1','=1');
var P : TpointF;
Begin
  RectangleP(FPointF,PointRel(+LogicWidth,-LogicHeight));
  feuille.Font.Size := 16;
  outTextP(LogicWidth/2,LogicHeight/2,nomLogic[Modele]);
  if Modele in [tNand,tNor] then begin
     P := FPointF;
     P.offset(TpointF.Create(logicWidth+rayonLogic,-logicHeight/2));
     cercle(P,rayonLogic,true)
  end;
End;

Procedure Cellule_Switch_PST;
var P : TPointF;
begin
   cercle(PointRel(-pas,-2*pas),dimBorne,true); // entre gauche
   cercle(PointRel(+pas,-2*pas),dimBorne,true); // entre droite
   cercle(PointRel(0,0),rayonLogic,true); // sortie
   case droiteGauche of
     aDroite: P := PointRel(+pas,-2*pas);
     aGauche: P := PointRel(-pas,-2*pas);
     aCentre: P := PointRel(0,-pas);
   end;
   LigneP(PointRel(-2*pas,-2*pas),PointRel(-pas,-2*pas));
   LigneP(PointRel(2*pas,-2*pas),PointRel(pas,-2*pas));
   LigneP(PointRel(0,pas),PointRel(0,0));
   LigneP(PointRel(0,0),P);
 (*
   LigneP(PointRel(-largeurTri,0),
          PointRel(-largeurTri/2,0));
   LigneP(PointRel(largeurTri,0),
          PointRel(largeurTri/2,0));
   LigneP(PointRel(0,HauteurTri),
          PointRel(0,hauteurTri/4));
   cercle(PointRel(0,hauteurTri/2),dimBorne,true)
   *)
end;

Procedure Cellule_Switch_Tikz;
begin
   LigneP(PointRel(-pas,0),
          PointRel(pas/2,0));
   LigneP(PointRel(pas/2,pas/2),
          PointRel(pas,pas/2));
   LigneP(PointRel(pas/2,-pas/2),
          PointRel(pas,-pas/2));
   cercle(PointRel(-pas/2,0),dimBorne,true)
end;

Procedure Cellule_Transistor;
const  codeAff : array[boolean,gTransistor] of string = (
          ('NPN','Nfet','NMOS','Nigbt','NPhoto'),
          ('PNP','Pfet','PMOS','Pigbt','PPhoto'));
var code : string;
begin
   RectangleP(PointRel(-LargeurTri,-4*hauteurTri/3),
              PointRel(+LargeurTri,+4*hauteurTri/3));
   if Modele in [tnpn,tpnp]
      then code := codeAff[Modele=tpnp,ModeleTransistor]
      else code := nomTripole[Modele];
   if withDiode then ;
   outTextP(0,0,code);
end;

Procedure Cellule_Potar;
var j : integer;
    N : TNoeud;
    Acarrefour,Bcarrefour : boolean;
Begin             // Stein 2013/04/28 - to rotate
 ACarrefour := false;
 BCarrefour := false;
 for j := 0 to Objets.Count - 1 do
      if (objets[j] is Tcarrefour) then begin
          N := TCarrefour(objets[j]).Noeud[1];
          if N=Noeud[1] then Acarrefour := true;
          if N=Noeud[2] then Bcarrefour := true;
  end;
  if  Acarrefour and Bcarrefour then begin
      FPointF.X := (Noeud[1].FPointF.X+Noeud[2].FPointF.X)/2;
      FPointF.Y := (Noeud[1].FPointF.Y+Noeud[2].FPointF.Y)/2;
  end;
  RectangleP(PointRel(-LargeurDi,-HauteurDi), PointRel(LargeurDi,hauteurDi));
  (*
  LigneP(PointRel(-LargeurDi,-HauteurDi), PointRel(-LargeurDi,HauteurDi)); // left
  LigneP(PointRel(LargeurDi,-HauteurDi), PointRel(LargeurDi,HauteurDi)); // right
  LigneP(PointRel(-LargeurDi,HauteurDi), PointRel(LargeurDi,HauteurDi)); // bottom
  LigneP(PointRel(-LargeurDi,-HauteurDi), PointRel(LargeurDi,-HauteurDi)); // top
  LigneP(PointRel(0,HauteurDi), PointRel(0,hauteurTri));
  *)
  LigneP(PointRel(-LargeurDi,0), PointRel(-2*Pas,0)); // entre A
  LigneP(PointRel(LargeurDi,0), PointRel(+2*Pas,0)); // entree B
  LigneP(PointRel(0,HauteurDi), PointRel(0,2*Pas)); // curseur
  outTextP(0,0,Fnom);
end;

Procedure Cellule_Mixer;
var posXY : integer;
begin
  Cercle(FPointF,rayonDi,false);
  posXY := round(rayonDi/sqrt(2));
  LigneP(PointRel(posXY,posXY),
         PointRel(-posXY,-posXY));
  LigneP(PointRel(posXY,-posXY),
         PointRel(-posXY,posXY));
end;

Procedure Cellule_Circulator;
begin
  Cercle(FPointF,rayonDi,false);
  Arc(FPointF,rayonDi/2,0,270);
end;

Begin // tripole.affiche
  inherited;
  case Modele of
    tAO : Cellule_AO;
    tpnp,tnpn : Cellule_Transistor;
   // tPotar : Cellule_Potar;
    tSwitch : case moteurLatex of
       lTikz: Cellule_Switch_Tikz;
       lPST: Cellule_Switch_PST;
    end;
    TMixer : Cellule_Mixer;
    TCirculator : Cellule_Circulator;
    tNand,tNor,tOr,tAnd,tXor : Cellule_Logic;
  end;
End; // AfficheTripole

{ ****************************   DRAW QUADRIPOLE  **************************** }

Procedure TQuadriPole.Affiche;
const textQuadripole : array[boolean,gQuadripole] of string =
          (('Transfo','Opto-C','Gnr'),('Transfo','coupler','coupler2'));
var h : single;
begin
  inherited;
  if Modele=qGenerique
    then h := hauteurQgen
    else h := hauteurQtransfo;
  RectangleP(PointRel(-LargeurQ, -h), PointRel(+LargeurQ, +h));
  outTextP(0,0,textQuadripole[moteurLatex=lTikz,Modele]);
end;

{ ******************************   DRAW DIPOLE  ***************************** }

Procedure TDipole.Affiche;

procedure TraceCourant;
var
  Points: TPolygon;
  posFleche : single;
  signe : single;
begin
    setLength(Points,4);
    if inverseCourant then signe := -1 else signe := 1;
    posFleche := 2*signe*largeurDi;
    Points[0] := PointRel(posFleche,0);
    Points[1] := PointRel(posFleche+2*signe*dimFleche,dimFleche);
    Points[2] := PointRel(posFleche+2*signe*dimFleche,-dimFleche);
    Points[3] := Points[0];
    feuille.Fill.Kind := TBrushKind.Solid;
//    feuille.Fill.Color := claBlack;
    feuille.DrawPolygon(Points,1);
    feuille.FillPolygon(Points,1);
    Finalize(Points);
end;

procedure TraceTension;
var
  Points: TPolygon;
  xFleche,yFleche : single;
  signe : single;
begin
    setLength(Points,4);
    if inverseTension then signe := -1 else signe := 1;
    if inverseCourant then signe := -signe;
    xFleche := signe*largeurDi;
    yFleche := 2*hauteurDi;
    Points[1] := PointRel(xFleche,yFleche);
    xFleche := -xFleche;
    Points[0] := PointRel(xFleche,yFleche);
    ligneP(Points[0],Points[1]);
    Points[1] := PointRel(xFleche+2*signe*dimFleche,yFleche+dimFleche);
    Points[2] := PointRel(xFleche+2*signe*dimFleche,yFleche-dimFleche);
    Points[3] := Points[0];
    feuille.Fill.Kind := TBrushKind.Solid;
//    feuille.Fill.Color := claBlack;
    feuille.DrawPolygon(Points,1);
    feuille.FillPolygon(Points,1);
    Finalize(Points);
end;

Procedure Cellule_Generique(const n : string);
Begin             // Stein 2013/04/28 - to rotate
//  RectangleP(PointRel(-LargeurDi,-HauteurDi), PointRel(LargeurDi,hauteurDi));
  RectangleP(PointRel(-LargeurDi,-HauteurDi), PointRel(LargeurDi,hauteurDi));
  LigneP(PointRel(-LargeurDi,-HauteurDi), PointRel(-LargeurDi,HauteurDi)); // esquerda
  LigneP(PointRel(LargeurDi,-HauteurDi), PointRel(LargeurDi,HauteurDi)); // direita
  LigneP(PointRel(-LargeurDi,HauteurDi), PointRel(LargeurDi,HauteurDi)); // bottop
  LigneP(PointRel(-LargeurDi,-HauteurDi), PointRel(LargeurDi,-HauteurDi)); // top
  outTextP(0,0,n);
End;

Procedure Cellule_Not;
Begin
  RectangleP(PointRel(-2*pas,-HauteurDi), PointRel(0,hauteurDi));
  LigneP(PointRel(0,0), PointRel(Pas/2,0));
  LigneP(PointRel(0,HauteurDi/3), PointRel(Pas/2,0));
  LigneP(PointRel(-2*pas,0), PointRel(-7*pas/2,0));
  outTextP(-pas,0,'Not');
End;

Procedure Cellule_Diode;
var FPath : TPathData;
Begin                         // Stein 2013/04/28
  FPath := TPathData.create;
  FPath.moveTo(PointRel(LargeurDi div 2,0));     // triangle
  FPath.lineTo(PointRel(-LargeurDi div 2,hauteurDi));
  FPath.lineTo(PointRel(-LargeurDi div 2,-hauteurDi));
  FPath.lineTo(PointRel(LargeurDi div 2,0));
  if Modele = dzener then begin
    FPath.moveTo(PointRel(LargeurDi div 4,-hauteurDi));
    FPath.lineTo(PointRel(LargeurDi div 2,-0.8*hauteurDi));
    FPath.lineTo(PointRel(LargeurDi div 2,0.8*hauteurDi));
    FPath.lineTo(PointRel(3*LargeurDi div 4,hauteurDi));
  end else begin                                 // |
    FPath.moveTo(PointRel(LargeurDi div 2,-hauteurDi));
    FPath.lineTo(PointRel(LargeurDi div 2,hauteurDi));
  end;
  if Modele = dLED then begin
    FPath.moveTo(PointRel(LargeurDi div 8,-0.8*hauteurDi));
    FPath.lineTo(PointRel(LargeurDi div 4,-1.2*hauteurDi));
    FPath.moveTo(PointRel(-LargeurDi div 4,-0.8*hauteurDi));
    FPath.lineTo(PointRel(-LargeurDi div 8,-1.2*hauteurDi));
  end;
  feuille.drawPath(FPath,1);
  FPath.Free;
  outTextP(0,1.8*hauteurDi,Fnom);
End;

Procedure Cellule_R(aZigzag : boolean);
var FPath : TPathData;
    y : single;
Begin      // Stein 2013/04/28 - to rotate and zigzag
  FPath := TPathData.create;
  if aZigzag then begin       // Stein 2013/04/28
    FPath.moveTo(PointRel(-LargeurDi,0));
    FPath.lineTo(PointRel(-5*LargeurDi div 6,-hauteurDi));
    FPath.lineTo(PointRel(-3*LargeurDi div 6,hauteurDi));
    FPath.lineTo(PointRel(-LargeurDi div 6,-hauteurDi));
    FPath.lineTo(PointRel(LargeurDi div 6,hauteurDi));
    FPath.lineTo(PointRel(3*LargeurDi div 6,-hauteurDi));
    FPath.lineTo(PointRel(5*LargeurDi div 6,hauteurDi));
    FPath.lineTo(PointRel(LargeurDi,0));
    y := 1.8*hauteurDi;
  end else begin
    FPath.moveTo(PointRel(-LargeurDi,-HauteurDi)); // esquerda superior
    FPath.lineTo(PointRel(-LargeurDi,HauteurDi));  // esquerda inferior
    FPath.lineTo(PointRel(LargeurDi,HauteurDi));   // direita inferior
    FPath.lineTo(PointRel(LargeurDi,-HauteurDi));  // direita superior
    FPath.lineTo(PointRel(-LargeurDi,-HauteurDi)); // esquerda superior
    y := 0;
  end;
  feuille.drawPath(FPath,1);
  FPath.Free;
  outTextP(0,y,Fnom);
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_C(isCrystal : boolean);
Begin
  LigneP(PointRel(-LargeurDi div 3,-hauteurDi),
         PointRel(-LargeurDi div 3,+hauteurDi));
  LigneP(PointRel(LargeurDi div 3,-hauteurDi),
         PointRel(LargeurDi div 3,+hauteurDi));
  LigneP(PointRel(-LargeurDi,0), PointRel(-LargeurDi div 3,0));
  LigneP(PointRel(LargeurDi,0),  PointRel(LargeurDi div 3,0));
  outTextP(0,1.8*hauteurDi,Fnom);                  // Stein 2013/04/28
  if isCrystal then begin                          // Stein 2013/04/28
    LigneP(PointRel(-LargeurDi div 6,-HauteurDi), PointRel(-LargeurDi div 6,HauteurDi)); // esquerda
    LigneP(PointRel(LargeurDi  div 6,-HauteurDi), PointRel(LargeurDi  div 6,HauteurDi)); // direita
    LigneP(PointRel(-LargeurDi  div 6,HauteurDi), PointRel(LargeurDi  div 6,HauteurDi)); // bottop
    LigneP(PointRel(-LargeurDi  div 6,-HauteurDi), PointRel(LargeurDi  div 6,-HauteurDi)); // top
  end;
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_Batt;
Begin
  LigneP(PointRel(-LargeurDi div 3,-hauteurDi*2),
         PointRel(-LargeurDi div 3,+hauteurDi*2));
  LigneP(PointRel(LargeurDi div 3,-hauteurDi),
         PointRel(LargeurDi div 3,+hauteurDi));
  LigneP(PointRel(-LargeurDi,0),
         PointRel(-LargeurDi div 3,0));
  LigneP(PointRel(LargeurDi,0),
         PointRel(LargeurDi div 3,0));
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_Inter;
Begin
  LigneP(PointRel(LargeurDi div 2,0),
         PointRel(LargeurDi,0));
  LigneP(PointRel(-LargeurDi div 2,0),
         PointRel(+LargeurDi div 2,-hauteurDi));
  LigneP(PointRel(-LargeurDi div 2,0),
         PointRel(-LargeurDi,0));
  outTextP(0,hauteurDi,Fnom);
End;

Procedure Cellule_L;
var i : integer;        // Stein 2013/04/28 - to rotate
    radius,center,P0 : TpointF;
    P1 : TpointF;
Begin
  P0 := PointRel(-largeurDi,0);
  P1 := PointRel(-3*largeurDi/4,0);
  LigneP(P0,P1);

  case Fangle of
    0: begin   // horizontal 0
       radius := TpointF.Create(LargeurDi / 4, LargeurDi);
       for i := 1 to 3 do begin
            center := PointRel(-LargeurDi + i * LargeurDi / 2, 0);
            Feuille.drawArc(center, radius, 0, -180, 1); // Stein 2013/04/28
       end;
    end;
    2: begin    // vertical 90
       radius := TpointF.Create(LargeurDi, LargeurDi / 4);
       for i := 1 to 3 do begin
            center := PointRel(-LargeurDi + i * LargeurDi / 2, 0);
            Feuille.drawArc(center, radius, -90, -180, 1); // Stein 2013/04/28
       end;
    end;
    4: begin    // horizontal 180
       radius := TPointF.Create(LargeurDi / 4, LargeurDi);
       for i := 1 to 3 do begin
            center := PointRel(-LargeurDi + i * LargeurDi / 2, 0);
            Feuille.drawArc(center, radius, -180, -180, 1); // Stein 2013/04/28
       end;
    end;
     6: begin    // vertical 270
        radius := TpointF.Create(LargeurDi, LargeurDi / 4);
        for i := 1 to 3 do begin
            center := PointRel(-LargeurDi + i * LargeurDi / 2, 0);
            Feuille.drawArc(center, radius, -270, -180, 1); // Stein 2013/04/28
        end;
    end;
  end;
  P0 := PointRel(+largeurDi,0);
  P1 := PointRel(3*largeurDi/4,0);
  ligneP(P0,P1);
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_GC;
Begin
  Cercle(FPointF,rayonDi,false);
  LigneP(PointRel(0,rayonDi), PointRel(0,-rayonDi));
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_GT;
var xfleche : integer;
Begin
  xFleche := rayonDi-2*dimFleche;
  Cercle(FPointF,rayonDi,false);
  LigneP(PointRel(rayonDi,0), PointRel(-rayonDi,0));
  if moteurLatex=lPST then begin
     LigneP(PointRel(rayonDi,0), PointRel(xFleche,+dimFleche));
     LigneP(PointRel(rayonDi,0), PointRel(xFleche,-dimFleche));
  end;
  if courant<>'' then traceCourant;
  if tension<>'' then traceTension;
End;

Procedure Cellule_AV(const s : string);
Begin
  Cercle(FPointF,rayonDi,false);
  outTextP(0,0,s);
 // if FnomObjet='' then FnomObjet := s[1];
End;

Procedure Cellule_Lampe;
var r : single;
Begin
  Cercle(FPointF,rayonDi,false);
  r := rayonDi*sqrt(2);
  LigneP(PointRel(r,-r), PointRel(-r,r));
  LigneP(PointRel(-r,-r), PointRel(r,r));
End;

var Acarrefour,Bcarrefour : boolean;
    j : integer;
    N : TNoeud;
Begin // dipole.Affiche
  inherited; // en particulier couleur
  // recentrer entre les noeuds
  Acarrefour := false;
  Bcarrefour := false;
  for j := 0 to Objets.Count - 1 do
      if (objets[j] is Tcarrefour) then begin
          N := TCarrefour(objets[j]).Noeud[1];
          if N=Noeud[1] then Acarrefour := true;
          if N=Noeud[2] then Bcarrefour := true;
  end;
  if  Acarrefour and Bcarrefour then begin
      FPointF.X := (Noeud[1].FPointF.X+Noeud[2].FPointF.X)/2;
      FPointF.Y := (Noeud[1].FPointF.Y+Noeud[2].FPointF.Y)/2;
  end;
  case Modele of
        dR: Cellule_R(zigzag);
        dC: Cellule_C(false);
        dL: Cellule_L;
        dGT,dGTac: Cellule_GT;
        dGC: Cellule_GC;
        dAm: Cellule_AV('A');
        dVm: Cellule_AV('V');
        dQuartz: Cellule_C(true);
        dswitch: cellule_inter;
        dPushSwitch: cellule_inter;
        dBat: cellule_batt;
        ddiode: cellule_diode;
        dphotodiode: cellule_diode;
        dvaricap: cellule_diode;
        dinterC: cellule_diode;
        dZener: cellule_diode;
        dGTO: cellule_diode;
        dled: cellule_diode;
        dlampe: cellule_lampe;
        dVCO: cellule_generique('VCO');
        dFilter: begin
            case filtre of
                 pBande : cellule_generique('pBande');
                 pBas : cellule_generique('pBas');
                 pHaut : cellule_generique('pHaut');
                 cBande : cellule_generique('cBande');
                 else cellule_generique('filtre');
            end;
        end;
        dAmpli: cellule_generique('Ampli');
        dNot: cellule_Not;
        dMotor: cellule_AV('Mcc');
        else cellule_generique('?');
   end;
End; // Affiche_Dipole

procedure Tobjet.Affiche;
var i : integer;
begin
    feuille.Fill.color := couleur;
    feuille.Stroke.color := couleur;
    feuille.Stroke.Dash := TStrokeDash.Solid;
    feuille.font.size := 12;
    feuille.Stroke.kind := TBrushKind.Solid;
    feuille.Stroke.Thickness := 1;
    for i := 1 to Nbornes do
        if FindexNoeud[i]<>0 then afficheBorne(i);
    feuille.Fill.kind := TBrushKind.None;
end;

procedure Tobjet.AfficheBorne(i : indexBornes);
begin
    cercle(borne[i],dimBorne,true);
end;

Procedure Tlien.ChercheNoeudsLogic;

procedure setNoeudsIntermediaires;
var Pdebut,Pfin,LPoint : TPointF;
    noeud3,noeud2 : integer;
begin
    pdebut := debut.Noeud[borneDebut].FPointF;
    pfin := fin.Noeud[borneFin].FPointF;
    if (pdebut.x=pfin.x) then begin // liaison au ras du rectangle
       if (debut is Ttripole) and
          ((debut as Ttripole).Modele in [tAND,tOR,tNAND,tNOR,tXOR])
          then with (debut as Ttripole) do begin
               if borneDebut=1
                  then LPoint := PointRel(-LogicConnectLength,-LogicHeight/4)
                  else LPoint := PointRel(-LogicConnectLength,-3*LogicHeight/4);
               noeud2 := ajouteNoeud(LPoint,verifNom('N'));
               LPoint.Offset(0,pfin.y-pdebut.y );
               noeud3 := ajouteNoeud(LPoint,verifNom('N'));
          end
          else with (fin as Ttripole) do begin
              if borneFin=1
                  then LPoint := PointRel(-LogicConnectLength,-LogicHeight/4)
                  else LPoint := PointRel(-LogicConnectLength,-3*LogicHeight/4);
              noeud3 := ajouteNoeud(LPoint,verifNom('N'));
              LPoint.Offset(0,-pfin.y+pdebut.y );
              noeud2 := ajouteNoeud(LPoint,verifNom('N'));
          end; // crer deux carrefours intermdiaires
       NBornes := 4;
       FindexNoeud[1] := debut.FindexNoeud[borneDebut];
       FindexNoeud[2] := noeud2;
       FindexNoeud[3] := noeud3;
       FindexNoeud[4] := fin.FindexNoeud[borneFin];
    end
    else ChercheNoeuds;
end;

begin
     if ((debut is Ttripole) and
         ((debut as Ttripole).Modele in [tAND,tOR,tNAND,tNOR,tXOR])) or
        ((fin is Ttripole) and
         ((fin as Ttripole).Modele in [tAND,tOR,tNAND,tNOR,tXOR]))
          then SetNoeudsIntermediaires
          else ChercheNoeuds;
end; // ChercheNoueudsLogic

Procedure Tlien.ChercheNoeuds;
Var Pdebut,Pfin : TPointF;
    debutNoeud,finNoeud : boolean;
    debutOrient,finOrient : Torientation;

Procedure AfficheHH;
Var P1,P2 : TpointF;
    borneDebutDroite,borneFinDroite : boolean;
Begin
    borneDebutDroite := debut.borne[borneDebut].x>debut.FPointF.X;
    borneFinDroite := fin.borne[borneFin].x>fin.FPointF.X;
    if pfin.y=pdebut.y then begin // un noeud au milieu
    // cas (borne  droite) non trait : cf. utilisateur
       P1.x := round((debut.borne[borneDebut].x+fin.borne[borneFin].x)/2/pas)*pas;
       NBornes := 1;
       FindexNoeud[1] := ajouteNoeud(TpointF.create(P1.x,pfin.y),debut.codeBorne[borneDebut]);
       debut.FindexNoeud[borneDebut] := FindexNoeud[1];
       fin.FindexNoeud[borneFin] := FindexNoeud[1];
    end
    else begin
            if borneDebutDroite
                  then if borneFinDroite
                      then P1.x := max(pfin.x,pdebut.x) + 2*pas
                      else P1.x := (pfin.x+pdebut.x)/2
                  else if borneFinDroite
                      then P1.x := (Pfin.x+pdebut.x)/2
                      else P1.x := max(pfin.x,pdebut.x) - 2*pas;
            P2.x := P1.x;
            P1.y := pdebut.y;
            P2.y := pfin.y;
            NBornes := 2;
            FindexNoeud[1] := ajouteNoeud(P1,debut.codeBorne[borneDebut]);
            debut.FindexNoeud[borneDebut] := FindexNoeud[1];
            FindexNoeud[2] := ajouteNoeud(P2,fin.codeBorne[borneFin]);
            fin.FindexNoeud[borneFin] := FindexNoeud[2];
     end;
End;

Procedure AfficheVV;
Var P1,P2 : TpointF;
    borneDebutHaut,borneFinHaut : boolean;
Begin
    borneDebutHaut := debut.borne[borneDebut].y>debut.FPointF.Y;
    borneFinHaut := fin.borne[borneFin].y>fin.FPointF.Y;
    if pfin.x=pdebut.x then begin // un noeud au milieu
       P1.y := round((fin.borne[borneFin].y+debut.borne[borneDebut].y)/2/pas)*pas;
       NBornes := 1;
       FindexNoeud[1] := ajouteNoeud(TpointF.Create(pdebut.x,P1.Y),debut.codeBorne[borneDebut]);
       debut.FindexNoeud[borneDebut] := FindexNoeud[1];
       fin.FindexNoeud[borneFin] := FindexNoeud[1];
    end
    else begin
         if borneDebutHaut
            then if borneFinHaut
                 then P1.y := max(pfin.y,pdebut.y) + 2*pas
                 else P1.y := (pfin.y+pdebut.y)/2
            else if borneFinHaut
                then P1.y := (pfin.y+pdebut.y)/2
                else P1.y := max(pfin.y,pdebut.y) - 2*pas;
         P2.y := P1.y;
         P1.x := pdebut.x;
         P2.X := pfin.x;
         NBornes := 2;
         FindexNoeud[1] := ajouteNoeud(P1,debut.codeBorne[borneDebut]);
         debut.FindexNoeud[borneDebut] := FindexNoeud[1];
         FindexNoeud[2] := ajouteNoeud(P2,fin.codeBorne[borneFin]);
         fin.FindexNoeud[borneFin] := FindexNoeud[2];
    end;
End;

Procedure AfficheHV;
Begin // aucun noeud
    NBornes := 1;
    if debutOrient=oVert
       then FindexNoeud[1] := ajouteNoeud(TpointF.Create(pdebut.x,pfin.y),fin.codeBorne[borneFin])
       else FindexNoeud[1] := ajouteNoeud(TpointF.Create(pfin.x,pdebut.y),fin.codeBorne[borneFin]);
// ajout d'un coude
    debut.FindexNoeud[borneDebut] := FindexNoeud[1];
    fin.FindexNoeud[borneFin] := FindexNoeud[1];
End;

Procedure AfficheDebutNoeud;
var P1,P2 : TpointF;
Begin
    FindexNoeud[1] := debut.FindexNoeud[borneDebut];
    case finOrient of
       oVert : begin
           NBornes := 2;
           FindexNoeud[2] := ajouteNoeud(TpointF.Create(pfin.x,pdebut.y),fin.codeBorne[borneFin]);
           fin.FindexNoeud[borneFin] := FindexNoeud[2];
       end;
       oHoriz : begin
           NBornes := 2;
           FindexNoeud[2] := ajouteNoeud(TpointF.Create(pdebut.x,pfin.y),
           fin.codeBorne[borneFin]);
           fin.FindexNoeud[borneFin] := FindexNoeud[2];
       end
       else begin
           P1.x := (pfin.x+pdebut.x)/2;
           if pfin.x>pdebut.x then P2.x := pfin.x-pas else P2.x := pfin.x+pas;
           if Abs(P1.x-pfin.x)>Abs(P2.x-pfin.x) then P1.x := P2.x;
           P1.y := pdebut.y;
           P2.y := pfin.y;
           NBornes := 3;
           FindexNoeud[2] := ajouteNoeud(P1,debut.codeBorne[borneDebut]);
           FindexNoeud[3] := ajouteNoeud(TPointF.create(P1.x,P2.y),
           fin.codeBorne[borneFin]);
           fin.FindexNoeud[borneFin] := FindexNoeud[3];
       end;
    end;
End;

Procedure AfficheFinNoeud;
var P1,P2 : TpointF;
Begin
    case debutOrient of
       oVert : begin
           NBornes := 2;
           FindexNoeud[1] := ajouteNoeud(TpointF.Create(pdebut.x,pfin.y),
           debut.codeBorne[borneDebut]);
       end;
       oHoriz : begin
           NBornes := 2;
           FindexNoeud[1] := ajouteNoeud(TpointF.Create(pfin.x,pdebut.y),
           debut.codeBorne[borneDebut]);
       end;
       else begin
           P1.x := (pfin.x+pdebut.x)/2;
           if pfin.x>pdebut.x then P2.x := pdebut.x+pas else P2.x := pdebut.x-pas;
           if Abs(p1.x-pdebut.x)>Abs(P2.x-pdebut.x) then P1.x := P2.x;
           P1.y := pdebut.y;
           P2.y := pfin.y;
           NBornes := 3;
           FindexNoeud[1] := ajouteNoeud(P1,debut.codeBorne[borneDebut]);
           FindexNoeud[2] := ajouteNoeud(TpointF.Create(P1.x,P2.y),
           fin.codeBorne[borneFin]);
       end;
    end;
    debut.FindexNoeud[borneDebut] := FindexNoeud[1];
    FindexNoeud[NBornes] :=  fin.FindexNoeud[borneFin];
End;

Begin  // Tlien.chercheNoeuds
    NBornes := 0;
    debutNoeud := debut.Noeud[borneDebut]<>Noeuds[0];
    finNoeud := fin.Noeud[borneFin]<>Noeuds[0];
    debutOrient := debut.orientation[borneDebut];
    finOrient := fin.orientation[borneFin];
    if debutNoeud
       then pdebut := debut.Noeud[borneDebut].FPointF
       else pdebut := debut.borne[borneDebut];
    if finNoeud
       then pfin := fin.Noeud[borneFin].FPointF
       else pfin := fin.borne[borneFin];
    if debutNoeud and finNoeud then begin // (1)
       FindexNoeud[1] := debut.FindexNoeud[borneDebut];
       if (pdebut.x=pfin.x) or (pdebut.y=pfin.y)
          then NBornes := 2 // liaison directe entre deux Noeuds
          else begin  // un coude avec un noeud intermdiaire
             NBornes := 3;
             if debut.Noeud[borneDebut].Fpredefini
                then FindexNoeud[2] := ajouteNoeud(TpointF.Create(pfin.x,pdebut.y),verifNom('L'))
                else FindexNoeud[2] := ajouteNoeud(TpointF.Create(pdebut.x,pfin.y),
                         debut.codeBorne[borneDebut]);
          end;
       FindexNoeud[NBornes] := fin.FindexNoeud[borneFin];
       exit;
    end;
    if debutNoeud and // not finNoeud dj rgl (1)
      ( ((pdebut.x=pfin.x) and (finOrient=oVert)) or
        ((pdebut.y=pfin.y) and (finOrient=oHoriz))) then begin
             fin.FindexNoeud[borneFin] := debut.FindexNoeud[borneDebut];
             exit;
    end;
    if finNoeud and // not debutNoeud dj rgl (1)
       (((pdebut.x=pfin.x) and (debutOrient=oVert)) or
        ((pdebut.y=pfin.y) and (debutOrient=oHoriz))) then begin
             debut.FindexNoeud[borneDebut] := fin.FindexNoeud[borneFin];
             exit;
    end;
    if (debutOrient=oVert) and (finOrient=oVert)
       then afficheVV
       else if (debutOrient=oHoriz) and (finOrient=oHoriz)
          then afficheHH
          else if debutNoeud
               then afficheDebutNoeud
               else if finNoeud
                  then afficheFinNoeud
                  else afficheHV;
End; // Tlien.chercheNoeuds

Procedure Tlien.Affiche;
Var i: Integer;
    FPath : TPathData;
Begin
    inherited;
    feuille.stroke.Thickness := 2;
    feuille.Stroke.Kind := TBrushKind.Solid;
    FPath := TPathData.create;
    FPath.MoveTo(debut.borne[borneDebut]);
    for i := 1 to NBornes do
        FPath.lineTo(Noeud[i].FPointF);
    FPath.lineTo(fin.borne[borneFin]);
    feuille.drawPath(FPath,1);
    FPath.Free;
End;

Procedure TTension.ChercheNoeuds;
var dx,dy : single;
begin
   FindexNoeud[1] := debut.FindexNoeud[borneDebut];
   FindexNoeud[2] := fin.FindexNoeud[borneFin];
   dx := (Noeud[2].FPointF.X-Noeud[1].FPointF.X);
   dy := (Noeud[2].FPointF.Y-Noeud[1].FPointF.Y);
   Fangle := round(arctan2(-dy,dx)/Pi*4)+4;
   // +4 : arctan renvoie entre -pi et pi
   // on raisonne entre 0 et 2 pi
   // -dy : y cran vers le bas
end;

Procedure TTension.Affiche;
var yFleche,angleF : single;
    P2 : TpointF;
Begin
    inherited;
    chercheNoeuds;
    if (FindexNoeud[1]=0) or (FIndexNoeud[2]=0) then exit; // ne devrait pas arriver !
    yFleche := 3*dimFleche;
    ligneP(Noeud[1].FPointF,Noeud[2].FpointF);
    angleF := Noeud[1].FPointF.Angle(Noeud[2].FpointF);
    P2.x := Noeud[2].FPointF.X-dimFleche*sin(angleF)+yFleche*cos(angleF);
    P2.Y := Noeud[2].FPointF.Y+dimFleche*cos(angleF)+yFleche*sin(angleF);
    ligneP(Noeud[2].FPointF,P2);
    P2.x := Noeud[2].FPointF.X+dimFleche*sin(angleF)+yFleche*cos(angleF);
    P2.Y := Noeud[2].FPointF.Y-dimFleche*cos(angleF)+yFleche*sin(angleF);
    ligneP(Noeud[2].FPointF,P2);
    FpointF := Noeud[1].FPointF.MidPoint(Noeud[2].FPointF);
    outTextP(0,labelOffset*pasLabel,Fnom);
End;

Procedure TMonopole.Affiche; //    Stein 19/05/13
var
  i: Integer;
Begin
  inherited;
  feuille.Stroke.Thickness := 1;
  LigneP(PointRel(0,largeurDi), PointRel(0,0));  // lien
  case ModeleM of
    mTerre : begin
      ligneP(PointRel(0, LargeurDi), PointRel(0, 0));
      ligneP(PointRel(trunc(-0.75*LargeurDi), LargeurDi), PointRel(trunc(0.75*LargeurDi), LargeurDi));
      ligneP(PointRel(trunc(-0.5*LargeurDi), trunc(1.25*LargeurDi)), PointRel(trunc(0.55*LargeurDi), trunc(1.25*LargeurDi)));
      ligneP(PointRel(trunc(-0.25*LargeurDi), trunc(1.5*LargeurDi)), PointRel(trunc(0.25*LargeurDi), trunc(1.5*LargeurDi)));
    end;
    mTrait : begin
      ligneP(PointRel(0, LargeurDi), PointRel(0, 0));
      Feuille.Stroke.Thickness := 3;
      ligneP(PointRel(-LargeurDi, LargeurDi), PointRel(+LargeurDi, LargeurDi));
      Feuille.Stroke.Thickness := 1;
    end;
    mTriangle : begin
      ligneP(PointRel(0, LargeurDi), PointRel(0, 0));
      ligneP(PointRel(trunc(-0.5*LargeurDi), LargeurDi), PointRel(trunc(0.5*LargeurDi), LargeurDi));
      ligneP(PointRel(trunc(-0.5*LargeurDi), LargeurDi), PointRel(0, trunc(2*LargeurDi)));
      ligneP(PointRel(trunc(0.5*LargeurDi), LargeurDi), PointRel(0, trunc(2*LargeurDi)));
    end;
    mChassis : begin
      ligneP(PointRel(0, LargeurDi), PointRel(0, 0));
      ligneP(PointRel(-LargeurDi, LargeurDi), PointRel(+LargeurDi, LargeurDi));
      for i := -2 to 2 do
          ligneP(PointRel(i*LargeurDi/2,largeurDi), PointRel((i+1)*largeurDi/2,1.5*largeurDi));
    end;
    end;
End;

Procedure TCarrefour.Affiche;
var P1,P2 : TpointF;
Begin
    inherited;
    feuille.Fill.Kind := TBrushKind.Solid;
    P1 := FPointF;P2 := FpointF;
    P1.Offset(-dimBorne,-dimBorne);
    P2.Offset(dimBorne,dimBorne);
    Cercle(FpointF,dimFleche,Fconnected);
    if Fnom<>'' then
       outTextP(pas/2,0,Fnom);
End;

Procedure TTexte.Affiche;
Begin
    FAngle := 0;
    outTextP(0,0,Fnom);
End;

Constructor TObjet.Create;
Begin
    FPointF := TpointF.Create(0,0);
    FPointClick := TpointF.Create(0,0);
    Nbornes := 0;
    FAngle := 0;
    Fnom := '';
    Fflottant := false;
    FgenreObjet := un_Frame;
End;

Constructor TNoeud.Create(aP:TPointF;const Anom : string);
Begin
    FPointF := aP;
    Fnom := anom;
    Fpredefini := false;
End;

Constructor TCarrefour.Create;
Begin
    inherited create;
    Nbornes := 1;
    FgenreObjet := un_Carrefour;
    Fconnected := true;
End;

Constructor TTexte.Create(const Anom : string);
Begin
    inherited create;
    Nbornes := 0;
    FNom := Anom;
    FgenreObjet := un_Texte;
End;

Constructor TTexte.CreateSimple;
Begin
    inherited create;
    Nbornes := 0;
    FNom := '';
    FgenreObjet := un_Texte;
End;

Constructor Ttripole.Create(ModeleT:gTripole);
var FileDefault : TMemIniFile;
Begin
    inherited Create;
    Nbornes := 3;
    Modele := ModeleT;
    FgenreObjet := un_Tripole;
    if not FileExists(nomDefault) then exit;
    FileDefault := TMemIniFile.create(nomDefault);
    sortieEnHaut := FileDefault.ReadBool(sectionTripole,'HB',false);
    inversion := FileDefault.ReadBool(sectionTripole,stInvers,false);
    ideal := FileDefault.ReadBool(sectionTripole,stIdeal,true);
    alimentation := FileDefault.ReadBool(sectionTripole,stAlim,false);
    zigzag := FileDefault.ReadBool(sectionTripole,stZigzag,false);
    french := FileDefault.ReadBool(sectionTripole,stFrench,true);
    ModeleTransistor := gTransistor(FileDefault.ReadInteger(sectionTripole,stTransistor,0));
    droiteGauche := gDroiteGauche(FileDefault.readInteger(sectionTripole,'DG',0));
    Fnom := nomTripole[ModeleT];
    FileDefault.Free;
End;

Constructor Ttripole.CreateSimple;
Begin
    inherited Create;
    FgenreObjet := un_Tripole;
    Modele := gTripole(0);
    Nbornes := 3;
End;

Constructor TMonopole.Create;
var FileDefault : TMemIniFile;
Begin
    inherited Create;
    NBornes := 1;
    FgenreObjet := un_Monopole;
    if not FileExists(nomDefault) then exit;
    FileDefault := TMemIniFile.create(nomDefault);
    Modele := gMonopole(FileDefault.ReadInteger(sectionMonopole,stModele,0));
    ModeleM := gMasse(FileDefault.ReadInteger(sectionMasse,stModele,0));
    connectingdot := FileDefault.ReadBool(sectionMasse,'connectingdot',true);
    FileDefault.Free;
End;

Constructor TDipole.Create(ModeleD:gdipole);
var FileDefault : TMemIniFile;
Begin
    inherited Create;
    Fnom := nomDefautDipole[ModeleD];
    Nbornes := 2;
    Modele := ModeleD;
    FgenreObjet := un_dipole;
    if not FileExists(nomDefault) then exit;
    FileDefault := TMemIniFile.create(nomDefault);
    filtre := gFiltre(FileDefault.ReadInteger(sectionDipole,'F',0));
    variable := FileDefault.ReadBool(sectionDipole,'V',false);
    tension := FileDefault.ReadString(sectionDipole,'Tension','');
    courant := FileDefault.ReadString(sectionDipole,stCourant,'');
    zigzag := FileDefault.ReadBool(sectionDipole,stZigzag,false);
    inverseCourant := FileDefault.ReadBool(sectionDipole,stCourant+'I',false);
    inverseTension := FileDefault.ReadBool(sectionDipole,'TensionI',false);
    FileDefault.Free;
End;

Constructor TDipole.CreateSimple;
Begin
    inherited Create;
    FgenreObjet := un_dipole;
    Modele := gDipole(0);
    Fnom := nomDefautDipole[modele];
    Nbornes := 2;
End;

Constructor TQuadripole.Create(ModeleQ:gquadripole);
var FileDefault : TMemIniFile;
Begin
    inherited Create;
    Fangle := 0;
    Nbornes := 4;
    Modele := ModeleQ;
    FgenreObjet := un_quadripole;
    if not FileExists(nomDefault) then exit;
    FileDefault := TMemIniFile.create(nomDefault);
    ideal := FileDefault.ReadBool(sectionQuadripole,stIdeal,true);
    noyau := FileDefault.ReadBool(sectionQuadripole,stNoyau,true);
    FileDefault.Free;
End;

Constructor TQuadripole.CreateSimple;
Begin
    inherited Create;
    FgenreObjet := un_quadripole;
    Modele := gQuadripole(0);
    Fangle := 0;
    Nbornes := 4;
    FgenreObjet := un_quadripole;
End;

Constructor Tlien.Create;
Begin
    inherited Create;
    Fflottant := true;
    FgenreObjet := un_Lien;
End;

Constructor TTension.Create;
var FileDefault : TMemIniFile;
Begin
    inherited Create;
    FNom := 'V';
    Fflottant := true;
    FgenreObjet := une_tension;
    if not FileExists(nomDefault) then exit;
    FileDefault := TMemIniFile.create(nomDefault);
    labelOffset := FileDefault.ReadInteger(sectionTension,'labelOffset',4);
    straightVoltage := FileDefault.ReadBool(sectionTension,'Straight',false);
    FileDefault.Free;
End;

Procedure TObjet.Offset(dx,dy:single);
begin
    FPointF.offset(dx,dy)
end;

Procedure TFrame.Offset(dx,dy:single);
begin
    debut.offset(dx,dy);
    fin.offset(dx,dy);
end;

Procedure TObjet.rotate;
begin
    Fangle := Fangle + 2; // +90
    if Fangle = 8 then Fangle := 0;   // 360 = 0
end;

Procedure TTension.rotate;
var Aobjet : Tobjet;
    Aborne : integer;
begin
     Aborne := borneDebut;
     borneDebut := borneFin;
     borneFin := ABorne;
     Aobjet := debut;
     debut := fin;
     fin := Aobjet;
end;

Function TObjet.Proche(Xs,Ys:single) : single;
begin
   result := FPointF.distance(TPointF.Create(Xs,Ys));
end;

Function TObjet.BorneProche(Xs,Ys:single;var dMin : single) : integer;
var i : integer;
    Ps : TpointF;
    d : single;
begin
   result := 0;
   Ps := TPointF.Create(Xs,Ys);
   For i := 1 To Nbornes Do begin
      d := Ps.Distance(borne[i]);
      if d<dMin then begin
        result := i;
        dMin := d;
      end;
   end;
end;

Function TFrame.BorneProche(Xs,Ys:single;var dMin : single) : integer;
var Ps : TpointF;
    d : single;
begin
   result := 0;
   Ps := TPointF.Create(Xs,Ys);
   d := Ps.Distance(debut);
   if d<dMin then begin
        result := 1;
        dMin := d;
   end;
   d := Ps.Distance(fin);
   if d<dMin then begin
        result := 2;
        dMin := d;
   end;
end;

Function Ttripole.Proche(Xs,Ys:single) : single;
var P,Ps : TPointF;
begin
   P := FPointF;
   Ps := TPointF.Create(Xs,Ys);
   if Modele in [tNand,tNor,tOr,tAnd,tXor] then P.Offset(logicWidth/2,-logicHeight/2);
   result := Ps.Distance(P);
end;

Function Tlien.Proche(Xs,Ys:single) : single;
var P1,P2,Ps,Pc : TPointF;

function procheLoc : single;
begin
       if (P1.x=P2.x) or (P1.y=P2.y)
       then begin // horizontal ou vertical
          Pc := P1.MidPoint(P2);
          result := Ps.Distance(Pc);
       end
       else result := screen.Width;
end;

var i : integer;
    distMin,dist : single;
begin
   Ps := TPointF.Create(Xs,Ys);
   P1 := debut.borne[borneDebut];
   if Nbornes=0 then begin
      P2 := fin.borne[borneFin];
      result := procheLoc;
      exit;
   end;
   P2 := Noeud[1].FPointF;
   distMin := procheLoc;
 //  if result then exit;
   for i := 1 to NBornes-1 do begin
       P1 := Noeud[i].FPointF;
       P2 := Noeud[i+1].FPointF;
       dist := procheLoc;
       if dist<distMin then distMin := dist;
 //      if result then exit;
   end;
   P1 := fin.borne[borneFin];
   P2 := Noeud[Nbornes].FPointF;
   dist := procheLoc;
   if dist<distMin then distMin := dist;
   result := distMin;
end;

Function TTension.Proche(Xs,Ys:single) : single;
var Ps,Pc : TpointF;
begin
       Ps := TPointF.Create(Xs,Ys);
       Pc := Noeud[1].FPointF.MidPoint(Noeud[2].FPointF);
       result := Ps.Distance(Pc);
end;

Function TObjet.getNoeud(i:indexBornes) : TNoeud;
begin
     try
     result := Noeuds[FindexNoeud[i]];
     except
     result := Noeuds[0]
     end;
end;

Function TObjet.getOrientation(i:indexBornes) : Torientation;
begin
     result := oNone
end;

function TDipole.getOrientation(i : indexBornes) : Torientation;
begin
     if FindexNoeud[i]=0
     then if (Fangle=2) or (Fangle=6)
         then result := oVert
         else result := oHoriz
     else result := oNone
end;


function TTripole.getOrientation(i : indexBornes) : Torientation;
begin
     result := oNone;
     case Modele  of
          tMixer,tSwitch,tCirculator : begin
             if i=3
                 then result := oVert  // commande curseur ...
                 else result := oHoriz; // bornes
             if (Fangle=2) or (Fangle=6) then
                if result=oVert
                   then result := oHoriz
                   else result := oVert
          end;
          tnpn,tpnp : begin
             if i=1
                then result := oHoriz // base
                else result := oVert; // collecteur metteur
             if (Fangle=2) or (Fangle=6) then
                if result=oVert
                   then result := oHoriz
                   else result := oVert
          end;
          else if FIndexNoeud[i]=0
             then if (Fangle=2) or (Fangle=6)
               then result := oVert
               else result := oHoriz
     end;
end;

function TQuadripole.getOrientation(i : indexBornes) : Torientation;
begin
     if FIndexNoeud[i]=0
     then if (Fangle=2) or (Fangle=6)
         then result := oVert
         else result := oHoriz
     else result := oNone
end;

Function TDipole.getBorne(i:indexBornes) : TPointF;
begin
    if Modele in [dDiode,dZener,dGTO,dLed,dInterC,dPhotoDiode,dVaricap]
    then case i of
       1 : result := PointRel(-largeurDi/2,0);
       2 : result := PointRel(largeurDi/2,0);
       else result := PointOrigine;
    end
    else case i of
       1 : result := PointRel(-largeurDi,0);
       2 : result := PointRel(largeurDi,0);
       else result := PointOrigine;
    end;
    if Modele=dNot then case i of
       1 : result := PointRel(-2*pas,0);
       2 : result := PointRel(pas/2,0);
       else result := PointOrigine;
    end;
end;

Function TObjet.getCodeBorne(i:indexBornes) : string;
begin
    result := 'N';
end;

Function TMonopole.getCodeBorne(i:indexBornes) : string;
begin
    result := verifNom('M')
end;

Function TCarrefour.getCodeBorne(i:indexBornes) : string;
begin
    result := verifNom('N')
end;

Function TTexte.getCodeBorne(i:indexBornes) : string;
begin
    result := verifNom('T')
end;

Function TTension.getCodeBorne(i:indexBornes) : string;
begin
    result := verifNom('U')
end;

Function TDipole.getCodeBorne(i:indexBornes) : string;
var nomBorne : string;
begin
    nomBorne := getNomBorne;
    result := nomBorne+char(ord('a')+i-1)
end;

Function TLien.getBorne(i:indexBornes) : TPointF;
begin
     result := Noeud[i].FPointF
end;

Function TTripole.getBorne(i:indexBornes) : TPointF;
begin
    result := PointOrigine;
    case Modele of
      tAO : case i of
         1 : result := PointRel(-largeurTri,-2*hauteurTri/3);
         2 : result := PointRel(-largeurTri,+2*hauteurTri/3);
         3 : result := PointRel(largeurTri,0);
      end;
      tpnp,tnpn : case i of
         3 : result := PointRel(largeurTri,-4*hauteurTri/3);
         2 : result := PointRel(largeurTri,+4*hauteurTri/3);
         1 : result := PointRel(-largeurTri,0);
      end;
      (*
      tPotar: case i of
         1 : result := PointRel(2*pas,0);
         2 : result := PointRel(-2*pas,0);
         3 : result := PointRel(0,2*pas);
      end;
      *)
      tSwitch : case moteurLatex of
         lTikz : case i of
            1 : result := PointRel(-pas,0);
            2 : result := PointRel(pas,pas/2);
            3 : result := PointRel(pas,-pas/2);
         end;
         lPST : case i of
            1 : result := PointRel(-2*pas,-2*pas);
            2 : result := PointRel(+2*pas,-2*pas);
            3 : result := PointRel(0,pas);
         end;
      end;
      tNand,tNor,tOR,tAnd,tXor : case i of
         1 : result := PointRel(0,-LogicHeight/4);
         2 : result := PointRel(0,-3*LogicHeight/4);
         3 : if Modele in [tNand,tNor]
            then result := PointRel(LogicWidth+pas/2,-LogicHeight/2)
            else result := PointRel(LogicWidth,-LogicHeight/2)
      end;
      tMixer,tCirculator : case i of
         1 : result := PointRel(-largeurDi,0);
         2 : result := PointRel(+largeurDi,0);
         3 : if sortieEnHaut
             then result := PointRel(0,-largeurDi)
             else result := PointRel(0,largeurDi)
      end
    end;
end;

Function TTripole.getCodeBorne(i:indexBornes) : string;
var nomBorne : string;
begin
   nomBorne := getNomBorne;
   case Modele of
        tAO : case i of
           1 : result := nomBorne+'E';
           2 : result := nomBorne+'Ei';
           3 : result := nomBorne+'S';
        end;
        tnpn,tpnp : case i of
           1 : result := nomBorne+'B';// G
           2 : result := nomBorne+'C';// D
           3 : result := nomBorne+'E';// S
        end;
        tSwitch : case i of
           1 : result := nomBorne+'Ea';
           2 : result := nomBorne+'Eb';
           3 : result := nomBorne+'S';
        end;
        tNand,tOR,tAnd,tNOR,tXOR : case i of
           1 : result := nomBorne+'1';
           2 : result := nomBorne+'2';
           3 : result := nomBorne+'Q';
        end;
        tMixer,tCirculator : case i of
           1 : result := nomBorne+'1';
           2 : result := nomBorne+'2';
           3 : result := nomBorne+'Q';
        end;
        else result := 'T';
   end;
end;

Function TObjet.getBorne(i:indexBornes) : TPointF;
begin
    result := FPointF;
end;

Function TQuadripole.getBorne(i:indexBornes) : TPointF;
var h : single;
begin
    if (Modele=qgenerique) and (moteurLatex=lPST)
      then h := 2*Pas
      else h := hauteurQtransfo;
    case i of
       1 : result := PointRel(-largeurQ,-h);
       2 : result := PointRel(-largeurQ,h);
       3 : result := PointRel(+LargeurQ,-h);
       4 : result := PointRel(+LargeurQ,h);
       else result := PointOrigine;
    end;
    if moteurLatex=lTikz then if Modele=qTransfo
       then case i of
       1 : result := PointRel(-largeurQ,-h);
       2 : result := PointRel(-largeurQ,h);
       3 : result := PointRel(+LargeurQ,-h);
       4 : result := PointRel(+LargeurQ,h);
       else result := PointOrigine;
    end
    else case i of
       1 : result := PointRel(-largeurQ,-h/2);
       2 : result := PointRel(-largeurQ,h/2);
       3 : result := PointRel(+LargeurQ,-h/2);
       4 : result := PointRel(+LargeurQ,h/2);
       else result := PointOrigine;
    end;
end;

Function TQuadripole.getCodeBorne(i:indexBornes) : string;
var nomBorne : string;
begin
    nomBorne := getNomBorne;
    case i of
       1 : result := nomBorne+'Ea';
       2 : result := nomBorne+'Eb';
       3 : result := nomBorne+'Sa';
       4 : result := nomBorne+'Sb';
       else result := 'N';
    end;
end;

procedure TObjet.EcritEnTete(F : TMemIniFile;const S : string);
begin
    F.writeFloat(s,'X',FPointF.X);
    F.writeFloat(s,'Y',FPointF.Y);
    F.writeInteger(s,'A',Fangle);
    F.writeString(s,stNom,Fnom);
end;

procedure TObjet.EcritDefault;
begin
end;

procedure TDipole.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
     s := codeIni[un_dipole]+intToStr(index);
     inherited EcritEntete(F,s);
     F.WriteInteger(s,'M',ord(Modele));
     F.WriteBool(s,'V',variable);
     F.writeString(s,'Tension',tension);
     F.writeString(s,stCourant,courant);
     F.WriteBool(s,stZigzag,zigzag);
     F.WriteBool(s,stCourant+'I',InverseCourant);
     F.WriteBool(s,'TensionI',InverseTension);
end;

procedure TDipole.EcritDefault;
var FileDefault : TMemIniFile;
begin
     FileDefault := TMemIniFile.create(nomDefault);
     FileDefault.WriteInteger(sectionDipole,'M',ord(Modele));
     FileDefault.WriteInteger(sectionDipole,'F',ord(Filtre));
     FileDefault.WriteBool(sectionDipole,'V',variable);
     FileDefault.writeString(sectionDipole,'Tension',tension);
     FileDefault.writeString(sectionDipole,stCourant,courant);
     FileDefault.WriteBool(sectionDipole,stZigzag,zigzag);
     FileDefault.WriteBool(sectionDipole,stCourant+'I',InverseCourant);
     FileDefault.WriteBool(sectionDipole,'TensionI',InverseTension);
     FileDefault.updateFile;
     FileDefault.Free;
end;

procedure TTension.EcritDefault;
var FileDefault : TMemIniFile;
begin
     FileDefault := TMemIniFile.create(nomDefault);
     FileDefault.WriteInteger(sectionTension,'labelOffset',labelOffset);
     FileDefault.WriteBool(sectionTension,'Straight',straightVoltage);
     FileDefault.updateFile;
     FileDefault.Free;
end;

procedure TTripole.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
      s := codeIni[un_tripole]+intToStr(index);
      inherited EcritEntete(F,s);
      F.WriteInteger(s,'M',ord(Modele));
      F.WriteBool(s,stInvers,inversion);
      F.WriteBool(s,stIdeal,ideal);
      F.WriteBool(s,stZigzag,zigzag);
      F.WriteBool(s,stFrench,french);
      F.WriteBool(s,'HB',sortieEnHaut);
      F.WriteInteger(s,stTransistor,ord(ModeleTransistor));
      F.WriteInteger(s,'DG',ord(droiteGauche));
end;

procedure TTripole.EcritDefault;
var FileDefault : TMemIniFile;
begin
      FileDefault := TMemIniFile.create(nomDefault);
      FileDefault.WriteInteger(sectionTripole,'M',ord(Modele));
      FileDefault.WriteBool(sectionTripole,'HB',sortieEnHaut);
      FileDefault.WriteBool(sectionTripole,stInvers,inversion);
      FileDefault.WriteBool(sectionTripole,stIdeal,ideal);
      FileDefault.WriteBool(sectionTripole,stAlim,alimentation);
      FileDefault.WriteBool(sectionTripole,stZigzag,zigzag);
      FileDefault.WriteBool(sectionTripole,stFrench,french);
      FileDefault.WriteInteger(sectionTripole,'FET',ord(ModeleTransistor));
      FileDefault.WriteInteger(sectionTripole,'DG',ord(droiteGauche));
      FileDefault.updateFile;
      FileDefault.Free;
end;

procedure TQuadripole.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
     s := codeIni[un_quadripole]+intToStr(index);
     inherited EcritEnTete(F,s);
     F.WriteInteger(s,'M',ord(Modele));
     F.WriteBool(s,stIdeal,ideal);
     F.WriteBool(s,stNoyau,noyau);
end;

procedure TQuadripole.EcritDefault;
var FileDefault : TMemIniFile;
begin
     FileDefault := TMemIniFile.create(nomDefault);
     FileDefault.WriteInteger(sectionQuadripole,'M',ord(Modele));
     FileDefault.WriteBool(sectionQuadripole,stIdeal,ideal);
     FileDefault.WriteBool(sectionQuadripole,stNoyau,noyau);
     FileDefault.updateFile;
     FileDefault.Free;
end;

procedure TMonopole.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
    s := codeIni[un_monopole]+intToStr(index);
    inherited EcritEntete(F,s);
    F.WriteBool(s,'connectingdot',connectingdot);
    F.WriteInteger(s,'Masse',ord(ModeleM));
    F.WriteInteger(s,stAntenne,ord(ModeleA));
    F.WriteInteger(s,stModele,ord(Modele));
end;

procedure TMonopole.EcritDefault;
var FileDefault : TMemIniFile;
begin
    FileDefault := TMemIniFile.create(nomDefault);
    FileDefault.WriteInteger(sectionMasse,stModele,ord(Modele));
    FileDefault.WriteBool(sectionMasse,'connectingdot',connectingdot);
    FileDefault.updateFile;
    FileDefault.Free;
end;

procedure Tlien.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
       s := codeIni[un_lien]+intToStr(index);
       inherited EcritEntete(F,s);
       F.writeInteger(s,'OD',indexObjet(Debut));
       F.writeInteger(s,'OF',indexObjet(Fin));
       F.writeInteger(s,'D',borneDebut);
       F.writeInteger(s,'F',borneFin);
end;

procedure TTension.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
       s := codeIni[une_tension]+intToStr(index);
       inherited EcritEntete(F,s);
       F.writeInteger(s,'OD',indexObjet(Debut));
       F.writeInteger(s,'OF',indexObjet(Fin));
       F.writeInteger(s,'D',borneDebut);
       F.writeInteger(s,'F',borneFin);
       F.writeInteger(s,'LO',labelOffset);
end;

procedure TCarrefour.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
      s := codeIni[un_carrefour]+intToStr(index);
      inherited EcritEntete(F,s);
      F.WriteBool(s,'C',Fconnected);
end;

procedure TTexte.EcritFichier(F : TMemIniFile;index : integer);
begin
     inherited EcritEntete(F,codeIni[un_texte]+intToStr(index));
end;

procedure TObjet.LitFichier(F : TMemIniFile;const s : string);
begin
    FPointF.X := F.readFloat(s,'X',FpointF.X);
    FPointF.Y := F.readFloat(s,'Y',FpointF.Y);
    FPointF.x := round(FpointF.X/Pas)*Pas;
    FPointF.y := round(FPointF.Y/Pas)*Pas;
    Fangle := F.readInteger(s,'A',Fangle);
    Fnom := F.readString(s,stNom,FNom);
end;

procedure TDipole.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    Modele := gDipole(F.readInteger(s,'M',0));
    variable := F.readBool(s,'V',variable);
    tension := F.readString(s,'Tension',tension);
    courant := F.readString(s,stCourant,courant);
    zigzag := F.readBool(s,stZigzag,zigzag);
    inverseCourant := F.readBool(s,stCourant+'I',false);
    inverseTension := F.readBool(s,'TensionI',false);
end;

procedure TTripole.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    Modele := gTripole(F.readInteger(s,'M',ord(Modele)));
    inversion := F.readBool(s,stInvers,inversion);
    zigzag := F.readBool(s,stZigzag,zigzag);
    french := F.readBool(s,stFrench,french);
    ModeleTransistor := gTransistor(F.readInteger(s,stTransistor,0));
    sortieEnHaut := F.readBool(s,'HB',false);
    droiteGauche := gDroiteGauche(F.readInteger(s,'DG',0));
end;

procedure TQuadripole.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    try
    Modele := gQuadripole(F.readInteger(s,'M',ord(Modele)));
    except
      Modele := qGenerique
    end;
    ideal := F.ReadBool(sectionQuadripole,stIdeal,ideal);
    noyau := F.ReadBool(sectionQuadripole,stNoyau,noyau);
end;

procedure TMonopole.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    connectingdot := F.readBool(s,'connectingdot',connectingdot);
    ModeleM := gMasse(F.readInteger(s,'Masse',0));
    ModeleA := gAntenne(F.readInteger(s,stAntenne,0));
    Modele := gMonopole(F.readInteger(s,stModele,0));
end;

procedure Tlien.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    borneDebut := F.readInteger(s,'D',borneDebut);
    borneFin := F.readInteger(s,'F',borneFin);
    debut := Objets[F.readInteger(s,'OD',0)];
    fin := Objets[F.readInteger(s,'OF',0)];
end;

procedure TTension.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    borneDebut := F.readInteger(s,'D',borneDebut);
    borneFin := F.readInteger(s,'F',borneFin);
    debut := Objets[F.readInteger(s,'OD',0)];
    fin := Objets[F.readInteger(s,'OF',0)];
    labelOffset := F.readInteger(s,'LO',labelOffset);
end;

procedure TCarrefour.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
    FConnected := F.readBool(s,'C',true);
end;

procedure TTexte.LitFichier(F : TMemIniFile;const s : string);
begin
    inherited LitFichier(F,s);
end;

Function Tlien.NoeudProche(Xs,Ys:single;var dMin : single) : integer;
begin
    result := 0;
end;

Function TMonopole.NoeudProche(Xs,Ys:single;var dMin : single) : integer;
begin
    result := BorneProche(Xs,Ys,dMin)
end;

Function TCarrefour.NoeudProche(Xs,Ys:single;var dMin : single) : integer;
begin
    result := BorneProche(Xs,Ys,dMin)
end;

Function TTexte.NoeudProche(Xs,Ys:single;var dMin : single) : integer;
begin
    result := BorneProche(Xs,Ys,dMin)
end;

Function TObjet.NoeudProche(Xs,Ys:single;var dMin : single) : integer;
var i : integer;
    Ps : TpointF;
    d : single;
begin
   result := 0;
   Ps := TPointF.Create(Xs,Ys);
   For i := 1 To NBornes Do begin
       d := Ps.Distance(noeud[i].FPointF);
       if d<dmin then begin
          result := i;
          dmin := d;
       end;
   end;
end;

Procedure ResetNoeuds;
var i,j : integer;
    Anoeud : Tnoeud;
begin
   for i := 0 to Objets.count-1 do
       for j := low(indexBornes) to high(indexBornes) do
           objets[i].FindexNoeud[j] := 0;
   while (Noeuds.Count>0) do Noeuds.delete(Noeuds.Count-1);
   Anoeud := Tnoeud.Create(PointOrigine,'O');
   Noeuds.add(Anoeud);
   case moteurLatex of
   lTikz: begin
      LogicWidth  := 4*Pas;
      LogicHeight := 2*Pas;
      HauteurQtransfo := 2*Pas;
      LargeurQ        := 2*Pas;
   end;
   lPST: begin
      LogicWidth  := 3*Pas;
      LogicHeight := 4*Pas;
      HauteurQtransfo := 3*Pas;
      LargeurQ        := 3*Pas;
   end;
   end;
end;

function TrimCarac(var s : string) : string;
const caracPermis : TSysCharSet = ['0'..'9','A'..'Z','a'..'z'];
var longueur,j : integer;
begin
	longueur := Length(s);
  result := '';
	for j := 1 to longueur do
		if CharInset(s[j],caracPermis)
    	then result := result+s[j]
end;

Function Tobjet.getNomBorne : string;
var i : integer;
begin
   if FnomBorne='' then
      if Fnom = ''
         then FnomBorne := 'N'
         else FnomBorne := trimCarac(Fnom);
   for i := 0 to Objets.count-1 do if objets[i]<>self then
       if objets[i].FNomBorne=FnomBorne then
          FnomBorne := verifNom(FnomBorne);
   result := FnomBorne;
end;

Procedure Tobjet.setNomObjet(const defaut : string);
var i : integer;
begin
   FnomObjet := defaut;
   for i := 0 to Objets.count-1 do if objets[i]<>self then begin
       if objets[i].FNomObjet=FnomObjet then
          FnomObjet := verifNom(defaut);
   end;
end;

procedure ResetObjets;
var  i : integer;
begin
   PileSauvegarde.Reset;
   for i := 0 to Objets.count-1 do
       objets[i].free;
   objets.Clear;
end;

procedure PreambulePSTCirc;
var Amemo : Tmemo;
begin
   TexteLatex := TstringList.Create;
   TexteLatex.Add('\usepackage{siunitx}');
   TexteLatex.Add('\usepackage{pstricks,pst-circ}');
   TexteLatex.Add('\usepackage{auto-pst-pdf}');
   TexteLatex.Add('');
   TexteLatex.Add('% chelle par dfaut 1 cm ; pour changer : \psset{unit=5mm}');
   TexteLatex.Add('% autre modif. possible : \psset{intensitywidth=3\pslinewidth}');
   TexteLatex.Add('% Dfinition interrupteur command');
   TexteLatex.Add('\makeatletter % Need for anything that contains an @ command');
   TexteLatex.Add('\newCircDipole{interC}%');
   TexteLatex.Add('\def\pst@draw@interC{%');
   TexteLatex.Add('\pspolygon[arrows=-,linewidth=1.5\pslinewidth](-0.25,-0.3)(-0.25,0.3)(0.25,0)');
   TexteLatex.Add('\psline[arrows=-,linewidth=1.5\pslinewidth](0.3,0.3)(0.3,-0.3)');
   TexteLatex.Add('\psline[arrows=-](0.3,0.1)(0.6,0.2)');
   TexteLatex.Add('\psline[arrows=-](0.3,0.2)(0.6,0.3)');
   TexteLatex.Add('\pnode(-0.3,0){dipole@1}');
   TexteLatex.Add('\pnode(+0.3,0){dipole@2}}');
   TexteLatex.Add('\makeatother % End of region containing @ commands');
   TexteLatex.Add('% fin interrupteur');
   Amemo := Tmemo.Create(nil);
   aMemo.lines := TexteLatex;
   aMemo.SelectAll;
   aMemo.CopyToClipboard;
   AMemo.Free;
   TexteLatex.Free;
end;

procedure PreambuleCircuitikz;
var Amemo : Tmemo;
begin
   TexteLatex := TstringList.Create;
   TexteLatex.Add('\usepackage{tikz}');
   if straightVoltage
      then TexteLatex.Add('\usepackage[european,straightvoltages,cuteinductors,siunitx]{circuitikz}')
      else TexteLatex.Add('\usepackage[european,cuteinductors,siunitx]{circuitikz}');
   TexteLatex.Add('%Remplacer l= par l_= pour changer la position des tiquettes');
   TexteLatex.Add('\usetikzlibrary{babel}');
   TexteLatex.Add('%Sinon problme avec babel. On peut aussi essayer \shorthandoff{;?!:} puis \shorthandon{;?!:}');
   Amemo := Tmemo.Create(nil);
   Amemo.lines := TexteLatex;
   Amemo.SelectAll;
   Amemo.CopyToClipboard;
   Amemo.Free;
   TexteLatex.Free;
end;

procedure PreambuleIEC;
var Amemo : Tmemo;
begin
   TexteLatex := TstringList.Create;
   TexteLatex.Add('\usepackage{tikz}');
   if straightVoltage
      then TexteLatex.Add('\usepackage[european,straightvoltages,cuteinductors,siunitx]{circuitikz}')
      else TexteLatex.Add('\usepackage[european,cuteinductors,siunitx]{circuitikz}');
   Amemo := Tmemo.Create(nil);
   aMemo.lines := TexteLatex;
   aMemo.SelectAll;
   aMemo.CopyToClipboard;
   AMemo.Free;
   TexteLatex.Free;
end;

Procedure GetMinMax;
Var i,j : integer;
    minX,maxY:single;
    P : TPointF;
begin
   minX:=screen.width;maxY:=0;
   For i := 0 To Objets.Count-1 Do begin
      if not(Objets[i] is TLien) then begin
         P := Objets[i].FPointF;
         if P.x<minX then minX := P.X;
         if P.y>maxY then maxY := P.Y;
      end;
      For j := 1 To Objets[i].NBornes Do begin
         if Objets[i].FindexNoeud[j]<>0
            then P := Objets[i].Noeud[j].FPointF
            else P := Objets[i].Borne[j];
         If P.x<minX then minX := P.x;
         If P.y>maxY then maxY := P.y;
      end;
   end;
   maxY := ceil(maxY/(2*pas))*2*pas;
   minX := floor(minX/(2*pas))*2*pas;
   origineY := maxY;
   origineX := minX;
end;

Procedure EcritCircuitikzClip;

procedure debutTikz;
begin
   getMinMax;
   TexteLatex := TstringList.Create;
   if (langue=fr) and withBabel then TexteLatex.Add('\shorthandoff{;:!?}');
   TexteLatex.Add('\begin{tikzpicture}');  // [scale=0.9, transform shape]
   resetNoeuds;
end;

Procedure FinTikz;
var Amemo : Tmemo;
begin
  {$IFDEF Debug}
   TexteLatex.Add('%\draw[very thin,gray] (0,0) grid (12,6);');
  {$ENDIF}
   TexteLatex.Add('\end{tikzpicture}');
   if (langue=fr) and withBabel then TexteLatex.Add('\shorthandon{;:!?}');
   Amemo := TMemo.Create(nil);
   Amemo.lines := TexteLatex;
   Amemo.enabled := true;
   Amemo.SelectAll;
   Amemo.CopyToClipboard;
   Amemo.Free;
   TexteLatex.Free;
end;

Var i,j : integer;
    texte : string;
    Aobjet : Tobjet;
begin
   moteurLatex := lTikz;
   debutTikz;
   for i := 0 to Objets.Count - 1 do begin
       Aobjet := objets[i];
       if not(aObjet is Tlien) and not(Aobjet is TTension) then
          Aobjet.chercheNoeuds;
   end;
   for i := 0 to Objets.Count - 1 do
      if (objets[i] is Tlien) then
         objets[i].chercheNoeuds;
   For i := 0 To Objets.Count-1 Do begin
       texte := objets[i].DessineCircuitikz;
       if texte<>'' then TexteLatex.Add(texte);
   end;
   For i := 0 To Objets.Count-1 do begin
       j := 1;
       while (objets[i].aTracer) do begin
           texteSup := '';
           texte := objets[i].TexteCircuitikz(j);
           if texte<>'' then TexteLatex.Add('\draw '+texte+' ;');
           if texteSup<>'' then TexteLatex.Add(texteSup);
           inc(j);
       end;
   end;
   FinTikz;
end; // ecritCircuitTikz

Procedure EcritIECClip;

procedure debutIEC;
begin
   getMinMax;
   TexteLatex := TstringList.Create;
   TexteLatex.Add('\begin{tikzpicture}');  // [scale=0.9, transform shape]
   resetNoeuds;
end;

Procedure FinIEC;
var Amemo : Tmemo;
begin
  {$IFDEF Debug}
   TexteLatex.Add('%\draw[very thin,gray] (0,0) grid (12,6);');
  {$ENDIF}
   TexteLatex.Add('\end{tikzpicture}');
   aMemo := TMemo.Create(nil);
   aMemo.lines := TexteLatex;
   aMemo.enabled := true;
   aMemo.SelectAll;
   aMemo.CopyToClipboard;
   aMemo.Free;
   TexteLatex.Free;
end;

Var i,j : integer;
    texte : string;
    Aobjet : Tobjet;
begin
   moteurLatex := lTikz;
   debutIEC;
   for i := 0 to Objets.Count - 1 do begin
       Aobjet := objets[i];
       if not(aObjet is Tlien) and not(Aobjet is TTension) then
          Aobjet.chercheNoeuds;
   end;
   for i := 0 to Objets.Count - 1 do
      if (objets[i] is Tlien) then
         objets[i].chercheNoeuds;
   For i := 0 To Objets.Count-1 Do begin
       texte := objets[i].DessineIEC;
       if texte<>'' then TexteLatex.Add(texte);
   end;
   For i := 0 To Objets.Count-1 do begin
       j := 1;
       while (objets[i].aTracer) do begin
           texteSup := '';
           texte := objets[i].TexteIEC(j);
           if texte<>'' then TexteLatex.Add('\draw '+texte+' ;');
           if texteSup<>'' then TexteLatex.Add(texteSup);
           inc(j);
       end;
   end;
   FinIEC;
end; // ecritIECClip

procedure EcritPSTCirc;

procedure setNomLogic;
Var i,k : integer;
    NombreNot : integer;
    NombreTripole : array[gTripole] of integer;
    j : gTripole;
    Lnom : string;
    Lpoint : TpointF;
begin
    NombreNot := 0;
    for j := low(gTripole) to High(gTripole) do
        NombreTripole[j] := 0;
    for i := 0 to Objets.Count - 1 do begin
        if (objets[i] is TDipole) and
           ((objets[i] as TDipole).Modele=dNot) then
              inc(NombreNot);
        if (objets[i] is TTripole) then begin
           j := (objets[i] as TTripole).Modele;
           inc(NombreTripole[j]);
        end;
    end;
    k := 0;
    if nombreNot>0 then
       for i := 0 to Objets.Count - 1 do
       if (objets[i] is TDipole) and
          ((objets[i] as TDipole).Modele=dNot) then with (objets[i] as TDipole) do begin
            inc(k);
            if nombreNot=1
               then LNom := 'NOT'
               else LNom := 'NOT'+intToStr(k);
            FNom := Lnom;
            FnomBorne := Lnom;
            Lpoint := PointRel(-7*pas/2,0);
            FindexNoeud[1] := ajouteNoeudLogic(Lpoint,LNom+'1');
            Lpoint := PointRel(pas/2,0);
            FindexNoeud[2] := ajouteNoeudLogic(Lpoint,LNom+'Q');
       end;
     for j  := tAND to tXOR do
         if nombreTripole[j]>0 then begin
            k := 0;
            for i := 0 to Objets.Count - 1 do
               if (objets[i] is TTripole) and
                  ((objets[i] as TTripole).Modele=j) then with (objets[i] as TTripole) do begin
                   inc(k);
                   if nombreTripole[j]=1
                      then LNom := nomTripole[j]
                      else LNom := nomTripole[j]+intToStr(k);
                   FNom := Lnom;
                   FnomBorne := Lnom;
                   LPoint := PointRel(0,-LogicHeight/4);
                   FindexNoeud[1] := ajouteNoeudLogic(Lpoint,LNom+'1');
                   Lpoint := PointRel(0,-3*LogicHeight/4);
                   FindexNoeud[2] := ajouteNoeudLogic(Lpoint,LNom+'2');
                   if j in [tNand,tNor]
                      then LPoint := PointRel(LogicWidth+pas/2,-LogicHeight/2)
                      else Lpoint := PointRel(LogicWidth,-LogicHeight/2);
                   FindexNoeud[3] := ajouteNoeudLogic(Lpoint,LNom+'Q');
               end;
         end;
end;

Procedure DebutPSTCirc;
Var i : integer;
    withLogic : boolean;
    Aobjet : Tobjet;
begin
   getMinMax;
   withLogic := false;
   For i := 0 To Objets.Count-1 Do begin
      if objets[i] is TTripole then begin
         if (TTripole(objets[i]).Modele in [tNand,tNor,tOR,tAnd,tXor])
            then withLogic := true;
      end;
      if objets[i] is TDipole and
         (TDipole(objets[i]).Modele=dNot)
            then withLogic := true;
   end;
   TexteLatex := TstringList.Create;
   if withLogic then begin
      TexteLatex.Add('\psset{logicHeight=2}'); // de manire  ce que les entres  1/4 tombe sur un chiffre rond
      TexteLatex.Add('\psset{logicWireLength=0}'); // de manire  ne pas avoir de trait en double
   end;
  {$IFDEF Debug}
   TexteLatex.Add('\newpsstyle{gridstyle}{subgriddiv=2,subgridcolor=lightgray}');
   TexteLatex.Add('\begin{pspicture}[showgrid](15,7)');
  {$ELSE}
   TexteLatex.Add('\begin{pspicture}');
  {$ENDIF}
   resetNoeuds;
   if withLogic then setNomLogic;
   For i := 0 To Objets.Count-1 do begin
       Aobjet := objets[i];
       if not(aObjet is Tlien) and not(Aobjet is TTension) then
          Aobjet.chercheNoeuds;
   end;
   for i := 0 to Objets.Count - 1 do
       if (objets[i] is Tlien) then
          if withLogic
             then (objets[i] as Tlien).chercheNoeudsLogic
             else objets[i].chercheNoeuds
end;

Procedure FinPSTCirc;
var Amemo : Tmemo;
begin
   TexteLatex.Add('\end{pspicture}');
//   TexteLatex.Add('%\normalsize');
   Amemo := TMemo.Create(nil);
   Amemo.lines := TexteLatex;
   Amemo.enabled := true;
   Amemo.SelectAll;
   Amemo.CopyToClipboard;
   Amemo.Free;
   TexteLatex.Free;
end;

var i : integer;
begin
   moteurLatex := lPST;
   debutPSTCirc;
   for i := 1 to Noeuds.Count - 1 do
       noeuds[i].EcritPSTCirc;
   for i := 0 to Objets.Count - 1 do
       objets[i].EcritPSTCirc;
   finPSTCirc;
end; // ecritPSTCirc

procedure Tframe.Affiche;

Procedure AfficheCoint(aPoint : TPointF);
var P1,P2 : TpointF;
Begin
   P1 := aPoint;
   P2 := aPoint;
   P1.Offset(-dimBorne,-dimBorne);
   P2.Offset(dimBorne,dimBorne);
   RectangleP(P1,P2);
end;

begin
   inherited;
   feuille.Stroke.Dash := TStrokeDash.Dash;
   RectangleP(debut,fin);
   feuille.Stroke.Dash := TStrokeDash.Solid;
   afficheCoint(debut);
   afficheCoint(fin);
end;

function Tframe.DessineCircuitikz : string;
begin
      FaTracer := false;
      result := '\draw '+pointLatex(debut)+' rectangle '+pointLatex(fin)+';';
end;

procedure Tframe.EcritPSTCirc;
begin
   TexteLatex.Add('\psframe'+
             '[linestyle=dashed]'+
             pointLatex(debut)+
             pointlatex(fin));
end;

procedure Tframe.EcritFichier(F : TMemIniFile;index : integer);
var s : string;
begin
     s := codeIni[un_Frame]+intToStr(index);
     inherited EcritEntete(F,s);
     F.writeFloat(s,'XD',Debut.X);
     F.writeFloat(s,'YD',Debut.Y);
     F.writeFloat(s,'XF',Fin.X);
     F.writeFloat(s,'YF',Fin.Y);
end;

procedure Tframe.LitFichier(F : TMemIniFile;const S : String);
begin
    inherited LitFichier(F,s);
    Debut.X := F.readInteger(s,'XD',0);
    Fin.X := F.readInteger(s,'XF',10);
    debut.Y := F.readInteger(s,'YD',0);
    fin.Y := F.readInteger(s,'YF',10);
end;

Constructor Tframe.Create;
begin
    inherited Create;
    NBornes := 2;
end;

Function Tframe.Proche(Xs,Ys:single) : single;
var dMin : single;
begin
   dMin := screen.width;
   BorneProche(Xs,Ys,dMin);
   result := dmin;
end;

Procedure TObjet.SetPosition(x,y : single);
var newPoint : TPointF;
begin
    newPoint := pointF(x,y);
   {$IFDEF DEBUG}
     writeln(fileTrace,'setPosXY ', round(x),',', round(y));
   {$ENDIF}
    if FPointClick.Distance(newPoint)>2 then begin
        FPointF.x := round(X/Pas)*Pas;
        FPointF.y := round(Y/Pas)*Pas;
    end;
    {$IFDEF DEBUG}
     writeln(fileTrace,'setPosPoint ', round(FpointF.x),',', round(FpointF.y));
   {$ENDIF}
end;

Procedure TObjet.SavePosition(x,y : single);
begin
    FPointClick := pointF(x,y);
    FoldPointF := FPointF;
end;

Procedure TObjet.GetEcart(x,y : single;var dx,dy : single);
begin
    dx := x-FPointF.x;
    dy := y-FPointF.y;
   {$IFDEF DEBUG}
     writeln(fileTrace,'getEcart ', round(dx),',', round(dy));
   {$ENDIF}
end;

Procedure TCarrefour.SetPosition(x,y : single);
var newPoint : TPointF;
begin
   newPoint := pointF(x,y);
   if FPointClick.Distance(newPoint)>2 then begin
      FPointF.x := round(X/demiPas)*demiPas;
      FPointF.y := round(Y/demiPas)*demiPas;
   end;
end;

Procedure TFrame.SetPosition(x,y : single);
var D1,D2 : single;
begin
    D1 := abs(x-debut.X) + abs(y-debut.Y);
    D2 := abs(x-fin.X) + abs(y-fin.Y);
    x := round(X/demiPas)*demiPas;
    y := round(Y/demiPas)*demiPas;
    if D1>D2 then begin
        fin.x := x;
        fin.y := y;
    end
    else begin
        debut.x := x;
        debut.y := y;
    end;
end;

Procedure TObjet.VerifMinMaxX(var mini,maxi : single);
begin
    if FPointF.x<mini then mini:=FPointF.x;
    if FPointF.x>maxi then maxi:=FPointF.x;
end;

Procedure TObjet.VerifMinMaxY(var mini,maxi : single);
begin
    if FPointF.y<mini then mini:=FPointF.y;
    if FPointF.y>maxi then maxi:=FPointF.y;
end;

// TSauvegarde

constructor Tsauvegarde.Create(objetCourant : TObjet;aUndo : TgenreSauvegarde);
begin
   inherited create;
   Fundo := aUndo;
   FObjet := nil;
   FobjetSauve := objetCourant;
   case FUndo of
       uDelete : FpileDelete := TpileObjet.create;
       uMove,uModif : begin
          case objetCourant.genreObjet of
              un_monopole : Fobjet := TMonopole.create;
              un_dipole : Fobjet := TDipole.create((objetCourant as TDipole).Modele);
              un_tripole : FObjet := TTripole.create((objetCourant as TTripole).Modele);
              un_quadripole : FObjet := TQuadripole.create((objetCourant as Tquadripole).Modele);
              un_lien : FObjet := TLien.create;
              un_carrefour : FObjet := TCarrefour.create;
              une_tension : FObjet := TTension.create;
              un_texte : FObjet := TTexte.create('');
              un_frame : FObjet := TFrame.create;
              else Fobjet := nil; // pour le compilateur
          end;
          if Fobjet<>nil then begin
             FObjet.Assign(objetCourant);
             if Fundo=uMove then FObjet.FPointF := objetCourant.FoldPointF;
          end;
       end;
       uAdd : ;
   end;
end;

procedure TSauvegarde.AddObjetDetruit(aObjet : TObjet);
begin
    FPileDelete.push(aObjet);
end;

destructor Tsauvegarde.destroy;
var Aobjet : Tobjet;
begin
   case FUndo of
      uDelete : begin
         while (FPileDelete.Count > 0) do begin
             Aobjet := FPileDelete.pop;
             Aobjet.free;
         end;
         FPileDelete.Free;
      end;
      uAdd : ; //FobjetSauve.free; // fait dans objets.free ou dans restaure
      uMove,uModif : if FObjet<>nil then FObjet.free;
   end;
   inherited destroy;
end;

Procedure Tsauvegarde.Restaure;
var Aobjet : Tobjet;
begin
    case Fundo of
         uDelete : begin
            while (FPileDelete.Count > 0) do begin
                Aobjet := FPileDelete.pop;
                objets.Add(aObjet);
            end;
         end;
         uAdd : begin
             Objets.Remove(FObjetSauve);
             FObjetSauve.free;
         end;
         uMove,uModif : if FObjet<>nil then FobjetSauve.assign(Fobjet);
    end;
end;

constructor TpileSauvegarde.create;
begin
    Liste := TList<Tsauvegarde>.create;
end;

function TPileSauvegarde.pop : Tsauvegarde;
begin
    if liste.count>0
       then result := liste.extract(liste[count-1])
       else result := nil;
end;

function TPileSauvegarde.getCount : integer;
begin
    result := liste.count;
end;

procedure TPileSauvegarde.push(s : Tsauvegarde);
var i : integer;
    Sd : TSauvegarde;
begin
    if liste.count>20 then begin // pour mnager la mmoire
       for I := 0 to 5 do begin
           Sd := Liste[0];
           Liste.Delete(0);
           Sd.free;
       end;
    end;
    Liste.add(s);
end;

destructor TpileSauvegarde.Destroy;
begin
    Reset;
    Liste.free;
end;

procedure TPileSauvegarde.Reset;
var S : Tsauvegarde;
begin
   while Liste.Count>0 do begin
      S := Liste[0];
      Liste.Delete(0);
      S.Free;
   end;
end;

// ***************** Assign ********************

procedure Tobjet.Assign(Source: TPersistent);
var Aobjet : TObjet;
begin
    if Source is Tobjet then begin
       Aobjet := Tobjet(Source);
       Nbornes := aObjet.Nbornes;
       FPointF := aObjet.FPointF;
       FIndexNoeud := aObjet.FindexNoeud;
       Fflottant := aObjet.FFlottant;
       FgenreObjet := aObjet.FgenreObjet;
       FnomBorne := aObjet.FNomBorne;
       FnomObjet := aObjet.FNomobjet;
       FaTracer := aObjet.Fatracer;
       LabelOffset := aObjet.LabelOffset;
       Fangle := aObjet.Fangle;
       Fnom := aObjet.Fnom;
    end
    else inherited Assign(Source)
end;

procedure TDipole.Assign(Source: TPersistent);
var Adipole : Tdipole;
begin
     if source is TDipole then begin
        Adipole := Tdipole(source);
        Modele  := Adipole.Modele;
        variable := Adipole.variable;
        zigzag := Adipole.zigzag;
        inverseTension := Adipole.inverseTension;
        inverseCourant := Adipole.inverseCourant;
        tension := Adipole.tension;
        courant := Adipole.courant;
        dipoleOutput := aDipole.dipoleOutput;
        inputArrow := Adipole.inputarrow;
        capaChimique := Adipole.capaChimique;
        filtre := Adipole.Filtre;
        ison := Adipole.isOn;
     end;
     inherited Assign(Source);
end;

procedure TTripole.Assign(Source: TPersistent);
var Atripole : TTripole;
begin
     if source is TTripole then begin
        Atripole := TTripole(source);
        Modele  := Atripole.Modele;
        ideal := Atripole.ideal;
        modeleTransistor := Atripole.modeleTransistor;
        zigzag := Atripole.zigzag;
        inversion := aTripole.inversion;
        BorneATracer := aTripole.BorneATracer;
        withDiode := aTripole.withDiode;
        alimentation := aTripole.alimentation;
        french := aTripole.french;
        inputArrow := Atripole.inputarrow;
        sortieEnHaut := Atripole.sortieEnHaut;
        inputArrow := Atripole.inputArrow;
        DroiteGauche := Atripole.DroiteGauche;
     end;
     inherited Assign(Source);
end;

procedure TQuadripole.Assign(Source: TPersistent);
var Aquadripole : TQuadripole;
begin
     if source is TQuadripole then begin
        Aquadripole := TQuadripole(source);
        Modele  := Aquadripole.modele;
        ideal := Aquadripole.ideal;
        noyau := Aquadripole.noyau;
        secondaireAtracer := Aquadripole.secondaireAtracer;
        primaireAtracer := Aquadripole.primaireAtracer;
     end;
     inherited Assign(Source);
end;

procedure TLien.Assign(Source: TPersistent);
var Alien : TLien;
begin
     if source is TLien then begin
        Alien := TLien(source);
        debut  := Alien.debut;
        fin := Alien.fin;
        borneDebut := Alien.borneDebut;
        borneFin := Alien.borneFin;
     end;
     inherited Assign(Source);
end;

procedure TCarrefour.Assign(Source: TPersistent);
var Acarrefour : TCarrefour;
begin
     if source is TCarrefour then begin
        Acarrefour := TCarrefour(source);
        Fconnected := Acarrefour.Fconnected;
     end;
     inherited Assign(Source);
end;

procedure TTension.Assign(Source: TPersistent);
var Atension : TTension;
begin
     if source is TTension then begin
        Atension := TTension(source);
        debut := Atension.debut;
        fin := Atension.fin;
        BorneDebut := Atension.borneDebut;
        BorneFin := Atension.borneFin;
     end;
     inherited Assign(Source);
end;

procedure TFrame.Assign(Source: TPersistent);
var Aframe : TFrame;
begin
     if source is TFrame then begin
        Aframe := TFrame(source);
        debut := Aframe.debut;
        fin := Aframe.fin;
     end;
     inherited Assign(Source);
end;

procedure TMonopole.Assign(Source: TPersistent);
var Amonopole : TMonopole;
begin
     if source is TMonopole then begin
        Amonopole := TMonopole(source);
        modeleM := Amonopole.modeleM;
        modeleA := Amonopole.modeleA;
        modele := Amonopole.modele;
        connectingDot := Amonopole.connectingDot;
     end;
     inherited Assign(Source);
end;

{$IFDEF MACOS}
procedure RecupereBundle;
var
   AppBundle: NSBundle;
   resourcesDir : string;
begin
   AppBundle := TNSBundle.Wrap(TNSBundle.OCClass.mainBundle);
   ResourcesDir := AppBundle.bundlePath.UTF8String+'/Contents/Resources';
   ResourcesDir := IncludeTrailingPathDelimiter(resourcesDir);
   HelpFile := ResourcesDir+'CircuitLatex.Help/circuitlatex.pdf';
   ExemplesDir := AppBundle.bundlePath.UTF8String+'/Contents/Resources/Startup/';
end;
{$ENDIF}

{$IFDEF LINUX}
procedure RecupereBundle;
begin
    ExemplesDir := application.GetNamePath;
    ExemplesDir := IncludeTrailingPathDelimiter(ExemplesDir);
    ExemplesDir := ExemplesDir+'Exemples/';
    HelpFile := '';
end;
{$ENDIF}

{$IFDEF MSWINDOWS}
procedure RecupereBundle;
begin
   ExemplesDir := ParamStr(0);
   ExemplesDir := ExtractFilePath(ExemplesDir);
   ExemplesDir := IncludeTrailingPathDelimiter(ExemplesDir);
   ExemplesDir := ExemplesDir+'Exemples\';
   HelpFile := '';
end;
{$ENDIF}

procedure TListObjet.Notify(const Item : TObjet;Action : TCollectionNotification);
begin
    case Action of
      cnAdded: ;
      cnRemoved : ;
      cnExtracted: ;
    end;
end;

procedure TListNoeud.Notify(const Item : TNoeud;Action : TCollectionNotification);
begin
    case Action of
      cnAdded: ;
      cnRemoved : Item.destroy;
      cnExtracted: ;
    end;
end;

var configDir : string;
initialization
   mesDocuments := system.IOUtils.TPath.getDocumentsPath;
   mesDocuments := system.IOUtils.TPath.Combine(mesDocuments, 'CircuitLatex');
   if not system.IOUtils.TDirectory.Exists(mesDocuments) then
         system.IOUtils.TDirectory.createDirectory(mesDocuments);
   mesDocuments := IncludeTrailingPathDelimiter(mesDocuments);
   recupereBundle;
   {$IFDEF LINUX}
   ConfigDir := System.SysUtils.GetEnvironmentVariable('XDG_CONFIG_HOME');
   if configDir=''
      then begin
         configDir := system.IOUtils.TPath.getHomePath;
         configDir := IncludeTrailingPathDelimiter(configDir);
         configDir := configDir+'.config/';
      end
      else configDir := IncludeTrailingPathDelimiter(configDir);
   {$ELSE}
   configDir := mesDocuments;
   {$ENDIF}
   nomDefault := configDir + 'circuitLatex.ini';
   PointOrigine := TPointF.Create(0,0);
   Objets := TListObjet.create;
   Noeuds := TListNoeud.create;
   moteurLatex := lPST;
   withBabel := false;
   PileSauvegarde := TpileSauvegarde.Create;

   {$IFDEF DEBUG}
   AssignFile(fileTrace,mesDocuments+'circuitLatex.txt');
   Rewrite(fileTrace);
   {$ENDIF}

finalization
   {$IFDEF DEBUG}
    CloseFile(fileTrace);
   {$ENDIF}
   resetNoeuds;
   Noeuds.Free;
   resetObjets;
   Objets.Free;
   PileSauvegarde.Free;
end.
