unit pstcircu;

interface

uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,
  System.IniFiles,
  System.UIConsts,
  System.Generics.Collections,

  FMX.StdCtrls,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.Menus,
  FMX.Memo,
  FMX.Layouts,
  FMX.Edit,
  FMX.Graphics,
  FMX.Platform,
  FMX.DialogService.Sync,
  FMX.Controls.Presentation,
  FMX.ScrollBox,
  FMX.ImgList,
  FMX.Printer,

  {$IFDEF POSIX}
   Posix.Unistd,
  {$ENDIF}

{$IFDEF MACOS}
  Macapi.ObjectiveC,
  Macapi.CoreFoundation,
  Macapi.Foundation,
{$ENDIF}

  pstcircker,
  System.ImageList;

const
   maxMRU = 3;

type
  TpstCircMainForm = class(TForm)
    DipoleToolBar: TToolBar;
    ResistanceBtn: TButton;
    ToolButton2: TButton;
    ToolButton3: TButton;
    ToolButton4: TButton;
    ToolButton5: TButton;
    ToolButton6: TButton;
    ToolButton7: TButton;
    LedBtn: TButton;
    TripoleToolBar: TToolBar;
    ToolButton9: TButton;
    MasseBtn: TButton;
    NoeudBtn: TButton;
    PotarBtn: TButton;
    TensionBtn: TButton;
    quartzBtn: TButton;
    ToolButton15: TButton;
    LienToolBar: TToolBar;
    LienBtn: TButton;
    CadreBtn: TButton;
    QuadripoleBtn: TButton;
    PaintBox: TPaintBox;
    Circle: TCircle;
    Rectangle: TRectangle;
    Line: TLine;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    MoteurBtn: TButton;
    NandBtn: TButton;
    StatusBar: TStatusBar;
    AideLabel: TLabel;
    transistorBtn: TButton;
    MainMenu: TMainMenu;
    pstcircItem: TMenuItem;
    FileMenu: TMenuItem;
    LatexItem: TMenuItem;
    HelpMenu: TMenuItem;
    AboutMenu: TMenuItem;
    AideMenu: TMenuItem;
    NewMenu: TMenuItem;
    OpenMenu: TMenuItem;
    SaveMenu: TMenuItem;
    SaveAsMenu: TMenuItem;
    MRU0: TMenuItem;
    MRU1: TMenuItem;
    MRU2: TMenuItem;
    MRU3: TMenuItem;
    PreambPstMenu: TMenuItem;
    SchemaPstMenu: TMenuItem;
    NotBtn: TButton;
    ExitMenu: TMenuItem;
    BidonBtn: TButton;
    PreambTikzMenu: TMenuItem;
    SchemaTikzMenu: TMenuItem;
    MRUseparator: TMenuItem;
    ExemplesItem: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    LogicToolBar: TToolBar;
    xorbtn: TButton;
    OrBtn: TButton;
    NorBtn: TButton;
    AndBtn: TButton;
    MenuItem26: TMenuItem;
    ImageList1: TImageList;
    TexteBtn: TButton;
    LangItem: TMenuItem;
    FrenchMenu: TMenuItem;
    EnglishMenu: TMenuItem;
    EditionItem: TMenuItem;
    UndoItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    AidepdfItem: TMenuItem;
    CloseMenu: TMenuItem;
    PrintMenu: TMenuItem;
    InterBtn: TButton;
    Lang: TLang;
    TimerPaint: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,Y: single);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: single);
    procedure LienItemClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure SaveAsItemClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Quitter1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure TripoleClick(Sender: TObject);
    procedure Carrefour1Click(Sender: TObject);
    procedure ResistanceClick(Sender: TObject);
    procedure PreambuleClick(Sender: TObject);
    procedure SchemaClick(Sender: TObject);
    procedure Masse1Click(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: single);
    procedure NewClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;  var KeyChar: System.WideChar;Shift: TShiftState);
    procedure SaveItemClick(Sender: TObject);
    procedure TensionClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Aide2Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FrameClick(Sender: TObject);
    procedure QuadripoleBtnClick(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject; Canvas: TCanvas);
    procedure CircleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure NandBtnClick(Sender: TObject);
    procedure NotBtnClick(Sender: TObject);
    procedure PreambTikzMenuClick(Sender: TObject);
    procedure SchemaTikzMenuClick(Sender: TObject);
    procedure MenuItem14Click(Sender: TObject);
    procedure TexteBtnClick(Sender: TObject);
    procedure FrenchMenuClick(Sender: TObject);
    procedure EnglishMenuClick(Sender: TObject);
    procedure UndoItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure PaintBoxDblClick(Sender: TObject);
    procedure CloseMenuClick(Sender: TObject);
    procedure PrintMenuClick(Sender: TObject);
    procedure PaintBoxMouseLeave(Sender: TObject);
    procedure EditionItemClick(Sender: TObject);
    procedure TimerPaintTimer(Sender: TObject);
  private
    MruList : TStringList;
    NomFichier:String;
    fichierModifie:boolean;
    etat : Tetat;
    objetCourant : TObjet;
    borneCourante : integer;
    lienCourant : Tlien;
    tensionCourante : TTension;
    frameCourant : TFrame;
    oldX,oldY : single;
    Xinit,Yinit : single;
    MRUitem : array[0..maxMRU] of TMenuItem;
    ExemplesList : TStringList;
    BoutonCourant : TButton;
    ObjetCopie : Tobjet;
    originePaintBox : TPointF;
    RepaintToDo : boolean;
//    procedure testLinux(aide : string);
    procedure MruItemUpdate;
    procedure MruAdd(const FileName: String);
    procedure MruDel(const FileName: String);
    Procedure AjouteObjet(Objet : TgenreObjet;option : integer);
    procedure LitFichier(const nom:string);
    Procedure Decale(dx,dy:single);
    procedure EcritFichier(nom : string);
    procedure SetMenu;
    procedure GetObjetCourant(x,y : single);
    function GetObjetXY(x,y : single) : Tobjet;
    procedure LitOptions(x,y : single);
    procedure SetBoutonCourant(Sender: TObject);
    procedure Paint(Canvas: TCanvas);
  public
  end;

var
  pstCircMainForm: TpstCircMainForm;

implementation

uses aboutU, dipoleU, masseU, aideU, tripoleU, quadripoleU,
     tensionU, carrefourU;

{$R *.FMX}

resourceString
    sectionFichier = 'Fichier';
    identMRU = 'MRU';
    identLangue = 'Langue';

const titre = 'Circuit Latex';
      extension = '.pst';

function GetOSLangID: String;
var
  LocServ: IFMXLocaleService;
begin
   if TPlatformServices.Current.SupportsPlatformService(IFMXLocaleService, IInterface(LocServ))
      then begin
         result := locServ.GetCurrentLangID;
         if (Result<>'fr') and (Result<>'en') then result := 'en';
      end
      else result := 'fr';
end;

//  ************************   FORM CREATE AND DESTROY   ***********************

procedure TpstCircMainForm.FormCreate(Sender: TObject);

Procedure LitExemples;
const maxExemples = 10; // ExemplesItem.childrenCount ne fonctionne pas
var
  Rini : TMemIniFile;
  nomIni : string;
  i : integer;
  nom : string;
begin
  ExemplesList := TStringList.Create;
  ExemplesItem.Visible := false;
  nomIni := ExemplesDir+'Exemples.ini';
  if not FileExists(nomIni) then exit;
  Rini := TMemIniFile.create(nomIni);
  for i := 0 to maxExemples do begin
      ExemplesItem.Items[i].visible := false;
      nom := Rini.ReadString(intToStr(i),'Nom','');
      if nom<>'' then begin
         ExemplesItem.items[i].visible := true;
         ExemplesItem.items[i].text := Rini.ReadString(intToStr(i),'Texte',Nom);
         ExemplesList.add(nom);
         ExemplesItem.Visible := true;
      end;
  end;
  Rini.free;
end; // litExemples

Procedure LitCurrentUser;
var Rini : TMemIniFile;
    i : integer;
    zz : string;
begin
  MruList := TStringList.Create;
  if not FileExists(nomDefault) then exit;
  Rini := TMemIniFile.create(nomDefault);
  if Rini.ReadBool(sectionFichier,'Tikz',true)
     then moteurLatex := lTikz
     else moteurLatex := lPST;
  WithBabel := Rini.ReadBool(sectionFichier,'Babel',true);
  straightVoltage := Rini.ReadBool(sectionTension,'Straight',false);
  for i := 0 to maxMRU do begin
      try
      zz := Rini.ReadString(sectionFichier,identMRU + IntToStr(i), '');
      if zz <> '' then  MRUList.Add(zz);
      except
      end;
  end;
  chaineLangue := Rini.ReadString(sectionFichier,identLangue,chaineLangue);
  Rini.Free;
  MruItemUpdate;
end;

begin
  MRUitem[0] := MRU0;
  MRUitem[1] := MRU1;
  MRUitem[2] := MRU2;
  MRUitem[3] := MRU3;
  fichierModifie := false;
  feuille := paintBox.canvas;
  aideLabel.Text := '';
  lienCourant := nil;
  tensionCourante := nil;
  frameCourant := nil;
  repaintToDo := false;
  BoutonCourant := ResistanceBtn;
  chaineLangue := GetOSLangID;
  originePaintBox := TpointF.create(-paintBox.position.x,-paintBox.position.y);
  litCurrentUser;
  LoadLangFromStrings(Lang.LangStr[chaineLangue]);
  langue := fr;
  if chaineLangue='en' then langue := en;
  setMenu;
  openDialog.InitialDir := MesDocuments;
  saveDialog.InitialDir := MesDocuments;
  litExemples;
end;

procedure TpstCircMainForm.SetMenu;
 // TLang ne traduit pas les menus ?
begin
  if Langue=en then begin
     aboutMenu.Text := 'About';
     exitMenu.Text := 'Quit CircuitLatex';
     fileMenu.text := 'File';
     helpMenu.Text := 'Help';
     aideMenu.Text := 'Help';
     saveMenu.Text := 'Save';
     closeMenu.Text := 'Close';
     saveasMenu.Text := 'Save as...';
     openMenu.Text := 'Open...';
     printMenu.Text := 'Print...';
     newMenu.Text := 'New';
     editionItem.Text := 'Edition';
     undoItem.Text := 'Undo';
     copyItem.Text := 'Copy';
     pasteItem.Text := 'Paste';
     preambpstMenu.text := 'Prambule PST to clipboard';
     schemaPstMenu.Text := 'Schma PST to clipboard';
     preambTikzMenu.text := 'Prambule Tikz to clipboard';
     schemaTikzMenu.Text := 'Schma Tikz to clipboard';
  end;
  if langue=fr then begin
     aboutMenu.Text := 'A propos';
     exitMenu.Text := 'Quitter CircuitLatex';
     fileMenu.text := 'Fichier';
     helpMenu.Text := 'Aide';
     aideMenu.Text := 'Aide';
     saveMenu.Text := 'Enregistrer';
     saveasMenu.Text := 'Enregistrer sous...';
     printMenu.Text := 'Imprimer...';
     openMenu.Text := 'Ouvrir...';
     closeMenu.Text := 'Fermer';
     newMenu.Text := 'Nouveau';
     editionItem.Text := 'Edition';
     undoItem.Text := 'Dfaire';
     copyItem.Text := 'Copier';
     pasteItem.Text := 'Coller';
     preambpstMenu.text := 'Prambule PST vers presse-papiers';
     schemaPstMenu.Text := 'Schma PST vers presse-papiers';
     preambTikzMenu.text := 'Prambule Tikz vers presse-papiers';
     schemaTikzMenu.Text := 'Schma Tikz vers presse-papiers';
  end;
end;

procedure TpstCircMainForm.FormDestroy(Sender: TObject);
begin
    MruList.free;
    ExemplesList.Free;
end;

//  *****************************   ADD COMPONENT   ****************************

procedure TpstCircMainForm.LienItemClick(Sender: TObject);
begin
  if etat in [eLienFin,eLienDebut] then begin
     if (etat=eLienFin) and (lienCourant<>nil) then FreeAndNil(lienCourant);
     etat := eNone;
     aideLabel.text  := '';
     LienBtn.IsPressed := false;
     LienBtn.repaint;
     BidonBtn.SetFocus;
     BoutonCourant.IsPressed := false;
  end
  else ajouteObjet(un_lien,0);
end;

procedure TpstCircMainForm.SetBoutonCourant(Sender: TObject);
begin
  BoutonCourant.IsPressed := false;
  BoutonCourant := sender as TButton;
  BoutonCourant.IsPressed := true;
  LienBtn.IsPressed := false;
  LienBtn.repaint;
end;

procedure TpstCircMainForm.Carrefour1Click(Sender: TObject);
begin
  AjouteObjet(Un_Carrefour,(sender as TComponent).tag);
  setBoutonCourant(Sender);
end;

procedure TpstCircMainForm.Masse1Click(Sender: TObject);
begin
  AjouteObjet(Un_Monopole,0);
  setBoutonCourant(Sender);
end;

procedure TpstCircMainForm.TensionClick(Sender: TObject);
begin
  AjouteObjet(Une_Tension,0)
end;

procedure TpstCircMainForm.QuadripoleBtnClick(Sender: TObject);
begin
  AjouteObjet(Un_Quadripole,(sender as TComponent).tag);
  setBoutonCourant(Sender);
end;

procedure TpstCircMainForm.FrameClick(Sender: TObject);
begin
  AjouteObjet(Un_Frame,0);
  setBoutonCourant(Sender);
end;

procedure TpstCircMainForm.FrenchMenuClick(Sender: TObject);
begin
    LoadLangFromStrings(Lang.LangStr['fr']);
    langue := fr;
    setMenu;
    chaineLangue := 'fr';
end;

procedure TpstCircMainForm.TripoleClick(Sender: TObject);
begin
  AjouteObjet(Un_Tripole,(sender as TComponent).tag);
  setBoutonCourant(Sender);
end;

procedure TpstCircMainForm.ResistanceClick(Sender: TObject);
begin
   AjouteObjet(Un_Dipole,(sender as TComponent).tag);
   setBoutonCourant(Sender);
end;

Procedure TpstCircMainForm.AjouteObjet(Objet : TgenreObjet;option : integer);
Var Amasse : TMonopole;
    Atripole : TTripole;
    Acarrefour : TCarrefour;
    Adipole : TDipole;
    Aquadripole : Tquadripole;
    Atexte : Ttexte;
    values : array of string;
    texte : string;
Begin
  ObjetCourant := nil;
  if (etat=eLienFin) and (lienCourant<>nil) then FreeAndNil(lienCourant);
  if (etat=eTensionFin) and (tensionCourante<>nil) then FreeAndNil(tensionCourante);
  if (etat=eFrameFin) and (frameCourant<>nil) then FreeAndNil(frameCourant);
  if (etat=eAjoute) and (objetCourant<>nil) then FreeAndNil(objetCourant);
  circle.Visible := false;
  rectangle.Visible := false;
  line.Visible := false;
  Case objet Of
    un_tripole: begin
       Atripole := TTripole.create(gTripole(Option));
       objetCourant := Atripole;
    End;
    un_quadripole: begin
       Aquadripole := TQuadripole.create(gQuadripole(Option));
       objetCourant := Aquadripole;
    End;
    un_dipole: begin
       Adipole := TDipole.create(gDipole(option));
       objetCourant := Adipole;
    End;
    Un_Monopole: begin
       Amasse := TMonopole.create;
       objetCourant := AMasse;
    end;
    Un_Carrefour: begin
       Acarrefour := TCarrefour.create;
       ObjetCourant := ACarrefour;
    end;
    Un_Texte: begin
       setLength(values,1);
       if FMX.DialogService.Sync.TDialogServiceSync.InputQuery(Query1[langue], [Query2[langue]], values)
          then texte := values[0]
          else texte := 'azerty';
       Atexte := TTexte.create(texte);
       ObjetCourant := ATexte;
    end;
    Une_Tension: etat := eTensionDebut;
    Un_Frame: etat := eFrameDebut;
    Un_Lien : etat := eLienDebut;
    else etat := eNone;
  End;
  if objetCourant<>nil then begin
     etat := eAjoute;
     paintBox.Cursor := crCross;
  end;
  fichierModifie := etat<>eNone;
  aideLabel.Text := aideEtat(etat);
  LienBtn.IsPressed := etat=eLienDebut;
  LienBtn.repaint;
  editionItem.enabled := etat=eNone;
End; // AjouteObjet

procedure TpstCircMainForm.CircleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   PaintBoxMouseDown(sender,button,shift,
      x+(sender as TShape).Position.x,
      y+(sender as TShape).Position.y)
end;

procedure TpstCircMainForm.CloseMenuClick(Sender: TObject);
begin
   resetObjets;
   caption := titre;
   objetCopie := nil;
   nomFichier := '';
   fichierModifie := false;
   editionItem.Enabled := false;
   paintBox.repaint;
  // WindowState := TWindowState.wsMinimized;
end;

// ************** Menu Edition ******************

procedure TpstCircMainForm.CopyItemClick(Sender: TObject);
begin
    if objetCourant=nil then exit;

    case objetCourant.genreObjet of
        un_dipole : ObjetCopie := TDipole.CreateSimple;
        un_tripole : ObjetCopie := TTripole.CreateSimple;
        un_texte : ObjetCopie := TTexte.CreateSimple;
        un_monopole : ObjetCopie := TMonopole.Create;
        un_quadripole : ObjetCopie := TQuadripole.CreateSimple
        //un_Carrefour
        //une_tension
        else ObjetCopie := nil;
    end;
    if ObjetCopie<>nil then begin
       ObjetCopie.Assign(objetCourant);
    end;
    pasteItem.Enabled := ObjetCopie<>nil;
end;

procedure TpstCircMainForm.PasteItemClick(Sender: TObject);
begin
    if ObjetCopie<>nil then begin
       ObjetCopie.setPosition(objetCopie.point.x+2*pas,ObjetCopie.point.y-2*pas);
       Objets.Add(ObjetCopie);
       objetCourant := nil;
       objetCopie := nil;
       etat := eNone;
       paintBox.repaint;
    end;
end;

procedure TpstCircMainForm.PaintBoxPaint(Sender: TObject; Canvas: TCanvas);
Begin
  Paint(canvas);
  saveAsmenu.Enabled := objets.Count>1;
  saveMenu.Enabled := objets.Count>1;
  printMenu.Enabled := objets.Count>1;
  undoItem.Enabled := (etat=eNone) and (pileSauvegarde.Count > 0);
  pasteItem.Enabled := (etat=eNone) and (objetCopie<>nil);
  copyItem.Enabled := (etat=eNone) and (objetCourant<>nil);
  editionItem.Enabled := undoItem.Enabled or  pasteItem.Enabled or copyItem.Enabled;
  repaintToDo := false;
end;

procedure TpstCircMainForm.Paint(Canvas: TCanvas);
Var i:integer;
    xmax,ymax : single;
    Aobjet : Tobjet;
Begin
  feuille := canvas;
  canvas.Fill.kind := TBrushKind.Solid;
  canvas.Fill.Color := claLightGray;
  canvas.FillRect(TrectF.Create(0,0,canvas.Width,canvas.Height),0,0,[],1);
  canvas.Fill.Color := claWhite;
  xmax := largeurMax*2*pas;
  if xmax>canvas.width then xmax := canvas.Width;
  ymax := hauteurMax*2*pas;
  if ymax>canvas.height then ymax := canvas.Height;
  canvas.FillRect(TrectF.Create(0,0,xmax,ymax),0,0,[],1);
  // partie visible sur un A4
  canvas.Fill.kind := TBrushKind.None;

  canvas.Stroke.Thickness := 1;
  canvas.Stroke.Dash := TStrokeDash.Solid;
  canvas.Stroke.Color := claGray;
  canvas.Stroke.Kind := TBrushKind.Solid;
  for i := 0 to round(canvas.Width/pas/2) do
      canvas.DrawLine(TpointF.create(2*i*pas,0),TpointF.create(2*i*pas,canvas.height),0.3);
  for i := 0 to round(canvas.Height/pas) do
      canvas.DrawLine(TpointF.create(0,2*i*pas),TpointF.create(canvas.width,2*i*pas),0.3);

  canvas.Stroke.Dash := TStrokeDash.Dash;
  canvas.Stroke.Color := claLightGray;
  for i := 0 to round(canvas.Width/pas/2) do
      canvas.DrawLine(TpointF.create((2*i+1)*pas,0),TpointF.create((2*i+1)*pas,canvas.height),0.3);
  for i := 0 to round(canvas.Height/pas) do
      canvas.DrawLine(TpointF.create(0,(2*i+1)*pas),TpointF.create(canvas.width,(2*i+1)*pas),0.3);

  canvas.Stroke.Color := claBlack;
  canvas.Fill.Color := claBlack;
  resetNoeuds;
  for i := 0 to Objets.Count - 1 do begin
      Aobjet := objets[i];
      if not(aObjet is Tlien) and not(Aobjet is TTension) then
         Aobjet.chercheNoeuds;
  end;
  for i := 0 to Objets.Count - 1 do
      if (objets[i] is Tlien) then
         objets[i].chercheNoeuds;
  for i := 0 To Objets.Count-1 Do
      objets[i].affiche;
  if objetCourant<>nil then
     objetCourant.Affiche(claRed);
end; // Paint

// **********************   KEY DOWN (ESC DEL AND F2 = LINE)  *********************

procedure TpstCircMainForm.FormKeyDown(Sender: TObject; var Key: Word;
   var KeyChar: System.WideChar; Shift: TShiftState);
var i : integer;
    S : tsauvegarde;
    ObjetsAdetruire : set of byte;

procedure detruireLien(ObjetSupprime : TObjet);
var Aobjet : TObjet;
    i : integer;
begin
     ObjetsAdetruire := [];
     for i := 0 to Objets.count-1 do begin // supprimer les liens concernant ObjetSupprime
       Aobjet := objets[i];
       if (Aobjet <> objetCourant) then begin
          if (Aobjet is Tlien) then with Tlien(Aobjet) Do
             If (fin=objetSupprime) or (debut=objetSupprime) Then begin
                include(ObjetsAdetruire,i);
                detruireLien(Aobjet);
             end;
          if (Aobjet is TTension) then with TTension(Aobjet) Do
             If (fin=objetSupprime) or (debut=objetSupprime) Then begin
                include(ObjetsAdetruire,i);
                detruireLien(Aobjet);
             end;
       end;
     End; // for i
end;

begin
  case  key of
  vkDelete,vkBack : if (objetCourant<>nil) then begin
     detruireLien(objetCourant);
     S := tsauvegarde.create(objetCourant,uDelete);
     include(ObjetsAdetruire,Objets.indexOf(objetCourant));
     for i := Objets.count-1 downto 0 do
         if i in ObjetsAdetruire then begin
            S.addObjetDetruit(objets[i]);
            // objet.free fait dans sauvegarde.destroy
            objets.Delete(i);
     end;
     PileSauvegarde.Push(S); // Sauvegarde Delete
     objetCourant := nil;
     etat := eNone;
     aideLabel.text  := '';
     BoutonCourant.IsPressed := false;
     lienBtn.isPressed := false;
     bidonBtn.SetFocus;
     LienBtn.repaint;
     paintBox.repaint;
  end;
  vkF2 : LienItemClick(sender);
  vkEscape : begin
      if (etat=eAjoute) and (objetCourant<>nil) then begin
         Objets.Remove(objetCourant);
         objetCourant.free;
         objetCourant := nil;
         copyItem.Enabled := false;
      end;
      if (etat=eLienFin) and (lienCourant<>nil) then
         FreeAndNil(lienCourant);
      etat := eNone;
      editionItem.Enabled := (objetCourant<>nil);
      BoutonCourant.IsPressed := false;
      lienBtn.isPressed := false;
      bidonBtn.SetFocus;
      LienBtn.repaint;
      aideLabel.text  := '';
  end;
  end;
end; // FormKeyDown

// ******************************   MOUSE DOWN   ******************************

procedure TpstCircMainForm.GetObjetCourant(x,y : single);
var distMin,dist : single;
    i,index : integer;
    oldObjet : TObjet;
begin
  distMin := pas;
  index := -1;
  For i := 0 to Objets.count-1 Do begin
      dist := Objets[i].Proche(X,Y);
      if dist<distMin Then Begin
         index := i;
         distMin := dist;
      End;
  end;
  oldObjet := objetCourant;
  if index>=0
  Then Begin
      ObjetCourant := Objets[index];
      aideLabel.Text := ObjetCourant.ClassName+aideMove;
  End
  else ObjetCourant := nil;
  if (oldObjet<>nil) and (oldObjet<>objetCourant) then
      repaintTodo := true;
end;// getObjetCourant

function TpstCircMainForm.GetObjetXY(x,y : single) : TObjet;
var distMin,dist : single;
    i,index : integer;
begin
  distMin := pas;
  index := -1;
  For i := 0 to Objets.count-1 Do begin
      dist := Objets[i].Proche(X,Y);
      if dist<distMin Then Begin
         index := i;
         distMin := dist;
      End;
  end;
  if index>=0
     then result := Objets[index]
     else result := nil;
end;// getObjetXY

procedure TpstCircMainForm.PaintBoxDblClick(Sender: TObject);
var aPoint : TPointF;
begin
    try
       aPoint := screenToClient(screen.MousePos);
       aPoint.offset(originePaintBox);
       LitOptions(aPoint.X,aPoint.y);
    except
      exit;
    end;
end; // Double clic

procedure TpstCircMainForm.LitOptions(x,y : single);
var aobjet : TObjet;

procedure SauveOptions;
var S : tsauvegarde;
begin
   if aObjet<>nil then begin
     S := tsauvegarde.create(aObjet,uMove);
     PileSauvegarde.Push(S);
   end;
end;

var values : array of string;
begin // menu contextuel ou double-clic
  aObjet := getObjetXY(X,Y);
  if aObjet=nil then exit;
  if aobjet is TDipole then begin
    if dipoleDlg = nil then Application.CreateForm(TDipoleDlg, DipoleDlg);
    dipoleDlg.objetCourant := TDipole(aobjet);
    if dipoleDlg.showModal=mrOK then sauveOptions;
  end;
  if aobjet is TCarrefour then begin
    if carrefourDlg = nil then Application.CreateForm(TCarrefourDlg, CarrefourDlg);
    carrefourDlg.objetCourant := TCarrefour(aobjet);
    carrefourDlg.showModal;
  end;
  if aobjet is TTripole then begin
    if tripoleDlg = nil then Application.CreateForm(TtripoleDlg, tripoleDlg);
    tripoleDlg.objetCourant := TTripole(aobjet);
    if tripoleDlg.showModal=mrOK then sauveOptions;
  end;
  if aobjet is TTension then begin
    if tensionDlg = nil then Application.CreateForm(TTensionDlg, TensionDlg);
    tensionDlg.objetCourant := TTension(aobjet);
    if tensionDlg.showModal=mrOK then sauveOptions;
  end;
  if aobjet is TMonopole then begin
    if masseDlg = nil then Application.CreateForm(TMasseDlg, MasseDlg);
    masseDlg.objetCourant := TMonopole(aobjet);
    if masseDlg.showModal=mrOK then sauveOptions;
  end;
  if aobjet is Tquadripole then begin
    if quadripoleDlg = nil then Application.CreateForm(TquadripoleDlg, quadripoleDlg);
    quadripoleDlg.objetCourant := Tquadripole(aobjet);
    if quadripoleDlg.showModal=mrOK then sauveOptions;
  end;
  if aobjet is TTexte then begin
     setLength(values,1);
     values[0] := aObjet.FNom;
     if FMX.DialogService.Sync.TDialogServiceSync.InputQuery(Query1[langue], [Query2[langue]], values)
          then begin
               aObjet.FNom := values[0];
               sauveOptions;
          end;
  end;
  etat := eNone;
  objetCourant := nil;
  paintBox.repaint;
end;

procedure TpstCircMainForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: single);

procedure Sauveadd(Aobjet : TObjet);
var S : tsauvegarde;
begin
   if Aobjet<>nil then begin
      S := tsauvegarde.create(Aobjet,uAdd);
      PileSauvegarde.Push(S);
   end;
end;

procedure CreeCarrefour;
var Acarrefour : TCarrefour;
begin
    Acarrefour := TCarrefour.create;
    ObjetCourant := Acarrefour;
    objetCourant.setPosition(X,Y);
    Objets.Add(objetCourant);
    SauveAdd(objetCourant);
    borneCourante := 1;
end;

Procedure Ajoute;
Begin
  objetCourant.setPosition(X,Y);
  Objets.Add(objetCourant);
  SauveAdd(objetCourant);
  etat :=  eNone;
  objetCourant := nil;
  BoutonCourant.IsPressed := false;
  LienBtn.IsPressed := false;
  bidonBtn.SetFocus;
End;

procedure AffecteDebutLien;
var
  P: TpointF;
begin
  if (objetCourant = nil) then creeCarrefour;  // ??
  if (objetCourant = nil) or (borneCourante = 0) then etat := eNone
  else begin
    lienCourant := Tlien.create;
    lienCourant.debut := objetCourant;
    lienCourant.borneDebut := borneCourante;
    Circle.Visible := true;
    P := objetCourant.noeud[borneCourante].FpointF;
    P.Offset(-2*dimBorne, -2*dimBorne);
    Circle.Position.point := P;
    etat := eLienFin;
  end;
end;

procedure AffecteFinLien;
begin
  if ObjetCourant=nil then CreeCarrefour;
  if (ObjetCourant<>nil) and (borneCourante>0) then begin
      lienCourant.fin := objetCourant;
      lienCourant.borneFin := borneCourante;
      Objets.Add(lienCourant);
      SauveAdd(lienCourant);
  end else FreeAndNil(lienCourant);
  etat := eLienDebut;
  LienBtn.IsPressed := true;
  LienBtn.repaint;
  circle.Visible := false;
end;

procedure AffecteDebutTension;
begin
  if objetCourant=nil then creeCarrefour;
  if (ObjetCourant=nil) or (borneCourante=0)
      then etat := eNone
      else begin
        tensionCourante := TTension.Create;
        tensionCourante.debut := objetCourant;
        tensionCourante.borneDebut := borneCourante;
        line.Visible := true;
        line.Position.Point := objetCourant.noeud[borneCourante].FpointF;
        line.Width := pas;
        line.Height := pas;
        Line.bringToFront;
        etat := eTensionFin;
    end;
end;

procedure AffecteDebutFrame;
begin
        frameCourant := TFrame.Create;
        frameCourant.debut.X := X;
        frameCourant.debut.Y := Y;
        rectangle.Visible := true;
        rectangle.position.Point := FrameCourant.debut;
        rectangle.width := pas;
        rectangle.height := pas;
        rectangle.BringToFront;
        etat := eFrameFin;
end;

procedure AffecteFinTension;
begin
  etat := eNone;
  if objetCourant=nil then creeCarrefour;
  if (ObjetCourant<>nil) and (borneCourante>0)
  then begin
      tensionCourante.fin := objetCourant;
      tensionCourante.borneFin := borneCourante;
      Objets.Add(tensionCourante);
      SauveAdd(tensionCourante);
      tensionCourante.chercheNoeuds;
  end
  else FreeAndNil(tensionCourante);
  line.Visible := false;
  bidonBtn.SetFocus;
end;

procedure AffecteFinFrame;
begin
  etat := eNone;
  frameCourant.fin.X := X;
  frameCourant.Fin.Y := Y;
  Objets.Add(frameCourant);
  SauveAdd(frameCourant);
  rectangle.Visible := false;
  bidonBtn.SetFocus;
end;

begin // paintBoxMouseDown
  paintBox.Cursor := crDefault;
  if (button=TMouseButton.mbRight) and
     (etat in [eNone,eDeplace,eDecale]) then begin  // RIGHT CLICK = OPTIONS
     litOptions(x,y);
     exit;
  end;
  case etat of
     eNone : begin
        getObjetCourant(x,y);
        if (objetCourant <> nil)  // over component?
           then begin
           if (ssCtrl in Shift)
               then begin
                  ObjetCourant.rotate; // if Ctrl then rotate
                  timerPaint.Enabled := true;
                  objetCourant := nil;
               end
               else begin  // else move
                 {$IFDEF DEBUG}
                  writeln(fileTrace,'MouseDown ', round(x),',', round(y));
                 {$ENDIF}
                  objetCourant.SavePosition(x,y);
                  etat := eDeplace;
               end;
           paintBox.Cursor := crHandPoint;
           end
           else begin // left click in back area
              paintBox.Cursor := crSize;  // change cursor
              etat := eDecale;            // state = move all
              oldX := X;Xinit := X;      // save position
              oldY := Y;Yinit := Y;
           end // objetCourant=nil
     end;
     eDeplace : etat := eNone;
     eLienDebut : AffecteDebutLien;
     eLienFin : AffecteFinLien;
     eTensionDebut : AffecteDebutTension;
     eFrameDebut : AffecteDebutFrame;
     eTensionFin : AffecteFinTension;
     eFrameFin : AffecteFinFrame;
     eAjoute : Ajoute;
  end;
  editionItem.Enabled := not(etat in [eDecale,eDeplace]);
  if repaintToDo or not(etat in [eDecale,eDeplace]) then paintBox.repaint;
  aideLabel.Text := aideEtat(etat);
  if etat=eNone then begin
     BoutonCourant.IsPressed := false;
     LienBtn.IsPressed := false;
     bidonBtn.SetFocus;
  end;
end;  // PaintBoxMouseDown

procedure TpstCircMainForm.PaintBoxMouseLeave(Sender: TObject);
begin
end;

//  ******************************   MOUSE MOVE   ******************************

procedure TpstCircMainForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,Y: single);

Procedure MoveChoix;
var distMin,dist : single;
    i,index : integer;
    Aobjet : Tobjet;
begin
  distMin := screen.Width;
  index := -1;
  For i := 0 to Objets.count-1 Do begin
      dist := Objets[i].Proche(X,Y);
      if dist<distMin Then Begin
         index := i;
         distMin := dist;
      End;
  end;
  if (distMin<pas) and (index>=0)
  Then Begin
      Aobjet := Objets[index];
      aideLabel.Text := Aobjet.ClassName+aideMove;
  End
  else Aobjet := nil;
  if Aobjet=nil
     then paintBox.cursor := crDefault
     else paintBox.cursor := crHandPoint;
END;

Procedure MoveDeplace;
Begin
  {$IFDEF DEBUG}
   writeln(fileTrace,'MouseMove ', round(x),',' ,round(y));
  {$ENDIF}
  ObjetCourant.setPosition(x,y);
  paintBox.Repaint;
  paintBox.cursor := crHandPoint;
End;

Procedure MoveDecale;
begin
   if (abs(X-oldX)+abs(Y-oldY))>pas then begin
      decale(x-oldx,y-oldy);
      oldX := X;
      oldY := Y;
   end;
end;

procedure MoveLien;
var i,b : integer;
    dMin : single;
    P : TpointF;
begin
  ObjetCourant := nil;
  borneCourante := 0;
  paintBox.cursor := crDefault;
  dMin := pas;
  For i := 0 to Objets.count-1 Do begin
      b := Objets[i].BorneProche(X,Y,dMin);
      if b>0 Then Begin
         borneCourante := b;
         ObjetCourant := Objets[i];
      End;
  end;
  Circle.Visible := ObjetCourant<>nil;
  if ObjetCourant<>nil Then Begin
      P := ObjetCourant.Borne[borneCourante];
      P.Offset(-dimBorne,-dimBorne);
      circle.Position.point := P;
      circle.BringToFront;
      paintBox.cursor := crHandPoint;
     {$IFDEF DEBUG}
      writeln(fileTrace,'MoveLien ',ObjetCourant.Fnom,' ', round(P.x),',', round(P.y));
     {$ENDIF}
  end;
end; // MoveLien

procedure MoveTension;
var i,b : integer;
    dMin : single;
    P : TpointF;
begin
  ObjetCourant := nil;
  borneCourante := 0;
  paintBox.cursor := crDefault;
  dMin := pas;
  For i := 0 to Objets.count-1 Do begin
      b := Objets[i].NoeudProche(X,Y,dMin);
      if b>0 Then Begin
         borneCourante := b;
         ObjetCourant := Objets[i];
      End;
  end;
  circle.Visible := ObjetCourant<>nil;
  if ObjetCourant<>nil Then Begin
      P := ObjetCourant.noeud[borneCourante].FpointF;
      P.offset(-dimBorne,-dimBorne);
      circle.Position.Point := P;
      circle.BringToFront;
      paintBox.cursor := crHandPoint;
  end;
  if etat=eTensionFin then begin
    dMin := x-Line.Position.x;
    if dmin>=0 then line.Width := dMin
    else begin
         line.Width := -dMin;
         Line.Position.x := x;
    end;
    dMin := y-Line.Position.y;
    if dMin>=0 then line.Height := dMin
    else begin
         line.Height := -dmin;
         Line.Position.y := y;
    end;
  end;
end; // MoveTension

procedure MoveFrame;
var i,b : integer;
    dMin : single;
    P : TpointF;
begin
  ObjetCourant := nil;
  borneCourante := 0;
  paintBox.cursor := crDefault;
  dMin := pas;
  For i := 0 to Objets.count-1 Do begin
      b := Objets[i].NoeudProche(X,Y,dMin);
      if b>0 Then Begin
         borneCourante := b;
         ObjetCourant := Objets[i];
      End;
  end;
  circle.Visible := ObjetCourant<>nil;
  if ObjetCourant<>nil Then Begin
      P := ObjetCourant.noeud[borneCourante].FpointF;
      P.offset(-dimBorne,-dimBorne);
      circle.Position.Point := P;
      circle.BringToFront;
      paintBox.cursor := crHandPoint;
  end;
  if etat=eFrameFin then begin
     rectangle.Width := x-rectangle.Position.x;
     rectangle.Height := y-rectangle.Position.y;
  end;
end; // MoveTension

begin
  case etat of
       eNone : MoveChoix;
       eDeplace : MoveDeplace;
       eDecale : MoveDecale;
       eLienDebut,eLienFin : MoveLien;
       eTensionDebut,eTensionFin : MoveTension;
       eFrameDebut,eFrameFin : MoveFrame;
       eAjoute : ;
  end;
end; // PaintBoxMouseMove

//  *******************************   MOUSE UP   *******************************

procedure TpstCircMainForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: single);
var S : TSauvegarde;
    newPoint : TPointF;
begin
  case etat of
    eNone : ;
    eDeplace: begin
        {$IFDEF DEBUG}
        writeln(fileTrace,'MouseUp ', round(x),',', round(y));
        {$ENDIF}
        newPoint := PointF(x,y);
        if newPoint.distance(objetCourant.PointClick)>pas then begin
           S := tsauvegarde.create(objetCourant,uMove);
           PileSauvegarde.Push(S);
        end;
        ObjetCourant.setPosition(x,y);
        etat := eNone;
        aideLabel.text  := '';
        paintBox.repaint;
    end;
    eDecale: begin
        x := round((x-xInit)/pas)*pas;
        y := round((y-yInit)/pas)*pas;
        decale(x,y);
        etat := eNone;
        aideLabel.text := '';
        objetCourant := nil;
        paintBox.repaint;
    end;
  end;
  if objetCourant=nil
     then paintBox.Cursor := crDefault
     else paintBox.Cursor := crHandPoint;
  circle.Visible := false;
  rectangle.Visible := false;
  line.Visible := false;
end;  // MouseUp

//  ***************************   MOVE COMPONENT(S)   **************************

Procedure TpstCircMainForm.Decale(dx,dy:single);
Var i : integer;
    minX,maxX,minY,maxY:single;
begin
  minX := 100*Pas; maxX := 0;
  minY := 100*Pas; maxY := 0;
  For i := 0 To Objets.Count-1 Do
      if not(Objets[i].flottant) then begin
         Objets[i].verifMinMaxX(minX,maxX);
         Objets[i].verifMinMaxY(minY,maxY);
      end;
  If (dx<0) and (minX<-2*dx) then exit;
  If (dx>0) and (maxX>(paintBox.width-2*dx)) then exit;
  If (dy<0) and (minY<-2*dy) then exit;
  If (dy>0) and (maxY>(paintBox.height-2*dy)) then exit;
  dx := round(dx/demiPas)*demiPas;
  dy := round(dy/demiPas)*demiPas;
  For i := 0 To Objets.Count-1 Do Objets[i].Offset(dx,dy);
  paintBox.repaint;
end;

//  *************************   OPEN, NEW, SAVE, CLOSE   ***********************

procedure TpstCircMainForm.OpenClick(Sender: TObject);  // open
var dialogValeur : integer;
begin
  if fichierModifie then begin
     Dialogvaleur:= TDialogServiceSync.MessageDialog(SaveFileStr[langue],
       TMsgDlgType.mtConfirmation,
      [TMsgDlgBtn.mbYes,TMsgDlgBtn.mbNo,TMsgDlgBtn.mbCancel],
      TMsgDlgBtn.mbYes,
      0);
     Case dialogValeur of
       mrYes:SaveAsItemClick(Sender);
       mrCancel:exit;
       mrNo:;
     end;
  end;
  if openDialog.execute then LitFichier(OpenDialog.Filename);
end;

procedure TpstCircMainForm.LitFichier(const nom:string);   // open

procedure reset;
begin
    borneCourante := 0;
    lienCourant := nil;
    tensionCourante := nil;
    etat := eNone;
    objetCourant := nil;
    ObjetCopie := nil;
end;

var i:integer;
    F:TMemIniFile;
    nomS : TStringList;
    carac : char;
    Amasse : TMonopole;
    Atripole : TTripole;
    Acarrefour : TCarrefour;
    Adipole : TDipole;
    Aquadripole : TQuadripole;
    Alien : Tlien;
    Atension : TTension;
    Aframe : Tframe;
    Atexte : TTexte;
begin
  resetObjets;
  reset;
  F := TMemIniFile.create(nom);
  nomS := TstringList.Create;
  F.ReadSections(nomS);
  for i := 0 to nomS.Count - 1 do begin
      carac := nomS[i][1];
      case carac of
           'D' : begin   // dipole
               Adipole := TDipole.createSimple;
               Adipole.LitFichier(F,nomS[i]);
               objets.add(aDipole);
           end;
           'T' : begin  // tripole
               aTripole := TTripole.createSimple;
               aTripole.litFichier(F,nomS[i]);
               objets.add(aTripole);
           end;
           'Q' : begin  // quadripole
               aQuadripole := TQuadripole.createSimple;
               aQuadripole.LitFichier(F,nomS[i]);
               objets.add(aQuadripole);
           end;
           'M' : begin  // ground
               aMasse := TMonopole.create;
               aMasse.LitFichier(F,nomS[i]);
               objets.add(aMasse);
           end;
           'L' : begin  // line
               aLien := Tlien.create;
               try
               aLien.LitFichier(F,nomS[i]);
               objets.add(aLien);
               except
                   aLien.free;
               end;
           end;
           'N' : begin  // node
               aCarrefour := TCarrefour.create;
               aCarrefour.LitFichier(F,nomS[i]);
               objets.add(aCarrefour);
           end;
           'V' : begin  //
               aTension := Ttension.create;
               try
               aTension.litFichier(F,nomS[i]);
               objets.add(aTension);
               except
                   aTension.free;
               end;
           end;
           'F' : begin  //
               Aframe := TFrame.create;
               Aframe.LitFichier(F,nomS[i]);
               objets.add(aFrame);
           end;
           'A' : begin  //
               aTexte := TTexte.createSimple;
               aTexte.LitFichier(F,nomS[i]);
               objets.add(aTexte);
           end;
           else
      end;
  end;
  F.Free;
  nomS.Free;
  nomFichier := nom;
  fichierModifie := false;
  Caption := titre+' ['+ExtractFilename(NomFichier)+']';
  MruAdd(nomFichier);
  paintBox.repaint;
end; // LitFichier

procedure TpstCircMainForm.SaveAsItemClick(Sender: TObject);  // save as
Begin
    if SaveDialog.execute then ecritFichier(SaveDialog.Filename);
end;

procedure TpstCircMainForm.SaveItemClick(Sender: TObject);  // save
begin
   if nomFichier = ''
      then SaveAsItemClick(sender)
      else ecritFichier(nomfichier)
end;

procedure TpstCircMainForm.EcritFichier(nom: string);     // save
var F : TMemIniFile;
    i : integer;
    existe : boolean;
    sections : TstringList;
begin
  nom := changeFileExt(nom,extension);
  existe := fileExists(nom);
  F := TMemIniFile.create(nom);
  try
  if existe then begin // sinon on ajoute les objets  ceux existant
     sections := TstringList.Create;
     F.ReadSections(sections);
     for I := 0 to sections.count-1 do
         F.EraseSection(sections[i]);
     sections.Free;
  end;
  for i := 0 to Objets.Count - 1 do objets[i].EcritFichier(F,i);
  f.updateFile;
  nomFichier := nom;
  fichierModifie := false;
  Caption := titre+' ['+ExtractFilename(NomFichier)+']';
  MruAdd(nomFichier);
  finally
    f.free;
  end;
end;

procedure TpstCircMainForm.EditionItemClick(Sender: TObject);
begin
   undoItem.Enabled := pileSauvegarde.Count > 0;
   pasteItem.Enabled := objetCopie<>nil;
   copyItem.Enabled := objetCourant<>nil;
end;

procedure TpstCircMainForm.EnglishMenuClick(Sender: TObject);
begin
   LoadLangFromStrings(Lang.LangStr['en']);
   langue := en;
   setMenu;
   chaineLangue := 'en';
end;

procedure TpstCircMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var i : integer;
    Rini : TMemInifile;
begin
    RIni := TMemIniFile.create(nomDefault);
    try
    Rini.WriteBool(sectionFichier,'Tikz',moteurLatex=lTikz);
    Rini.WriteBool(sectionFichier,'Babel',withBabel);
    Rini.WriteBool(sectionTension,'Straight',straightVoltage);
    for i := 0 to mruList.Count-1 do
        Rini.WriteString(sectionFichier,identMRU + IntToStr(i),MRUList[i]);
    finally
    Rini.WriteString(sectionFichier,identLangue,chaineLangue);
    Rini.updateFile;
    Rini.Free;
    end;
end;

procedure TpstCircMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var dialogValeur : integer;
begin
   If fichierModifie then begin
     DialogValeur:= TDialogServiceSync.MessageDialog(SaveFileStr[langue],
        TMsgDlgType.mtConfirmation,
        [TMsgDlgBtn.mbYes,TMsgDlgBtn.mbNo,TMsgDlgBtn.mbCancel],
        TMsgDlgBtn.mbYes, 0 );
     Case dialogValeur of
        mrYes : begin
           SaveAsItemClick(Self);
           canClose := true;
        end;
        mrCancel:Canclose := false;
        mrNo:CanClose := true;
        else CanClose := true; // ??
     end;
   end;
end;

procedure TpstCircMainForm.Quitter1Click(Sender: TObject);
begin
  close
end;

procedure TpstCircMainForm.N2Click(Sender: TObject);
var index : Integer;
    nom : string;
begin
  Index := TMenuItem(Sender).Tag;
  nom := MruList[Index];
  if FileExists(nom)
      then LitFichier(nom)
      else begin
           MruDel(nom);
           showMessage(TMenuItem(Sender).Text+NotFoundStr[langue])
      end;
end;

procedure TpstCircMainForm.NandBtnClick(Sender: TObject);
begin
   AjouteObjet(Un_Tripole,(sender as TButton).tag);
   setBoutonCourant(sender);
end;

procedure TpstCircMainForm.NotBtnClick(Sender: TObject);
begin
  AjouteObjet(Un_Dipole,ord(dNot));
  setBoutonCourant(sender);
end;

procedure TpstCircMainForm.NewClick(Sender: TObject);
var dialogValeur : integer;
begin
   If fichierModifie then begin
     DialogValeur:= TDialogServiceSync.MessageDialog(SaveFileStr[langue],
        TMsgDlgType.mtConfirmation,
        [TMsgDlgBtn.mbYes,TMsgDlgBtn.mbNo,TMsgDlgBtn.mbCancel],
        TMsgDlgBtn.mbYes, 0 );
     if dialogValeur=mrYes then begin
        if nomFichier = ''
           then SaveAsItemClick(sender)
           else ecritFichier(nomfichier)
     end;
   end;
   resetObjets;
   caption := titre;
   objetCopie := nil;
   nomFichier := '';
   fichierModifie := false;
   editionItem.Enabled := false;
   PaintBox.repaint;
end;

//  ******************************   HELP, ABOUT   *****************************

procedure TpstCircMainForm.Aide2Click(Sender: TObject);
begin
  if aideDlg = nil then Application.CreateForm(TAideDlg, AideDlg);
  aideDlg.showModal
end;

procedure TpstCircMainForm.Apropos1Click(Sender: TObject);
begin
  if aboutBox = nil then Application.CreateForm(TAboutBox, AboutBox);
  LoadLangFromStrings(AboutBox.Lang.LangStr[chaineLangue]);
  AboutBox.showmodal
end;

procedure TpstCircMainForm.TexteBtnClick(Sender: TObject);
begin
    AjouteObjet(Un_Texte,(sender as TComponent).tag);
    setBoutonCourant(sender);
end;

procedure TpstCircMainForm.TimerPaintTimer(Sender: TObject);
begin
    PaintBox.Repaint;
    timerPaint.Enabled := false;
end;

//*********************************  LATEX  ********************************

procedure TpstCircMainForm.PreambuleClick(Sender: TObject);
begin
   PreambulePSTCirc;
end;

procedure TpstCircMainForm.PrintMenuClick(Sender: TObject);
var coeff : single;
    aBitmap : TBitmap;
    SourceRect,DestRect : TRectF;
begin
      aBitmap := Tbitmap.create;
      aBitmap.Width := round(paintBox.Width);
      aBitmap.Height := round(paintBox.Height);
      coeff := printer.PageWidth/21; // pixels pour 1cm SI portrait !
      coeff := coeff/(2*pas); // 2 pas = 1cm Tikz
      showMessage('coeff='+floatTOStr(coeff));
      aBitmap.canvas.BeginScene;
      paint(aBitmap.canvas);
      aBitmap.canvas.endScene;
      printer.BeginDoc;
      SourceRect.Create(0, 0, aBitmap.width, aBitmap.height);
      DestRect.Create(0, 0, aBitmap.width*coeff, aBitmap.height*coeff);
      printer.Canvas.BeginScene;
      printer.Canvas.DrawBitmap(abitmap, SourceRect,DestRect,1);
      printer.Canvas.EndScene;
      printer.EndDoc;
      aBitmap.Free;
end;

procedure TpstCircMainForm.SchemaClick(Sender: TObject);
begin
   ecritPSTCirc;
end;

procedure TpstCircMainForm.MenuItem14Click(Sender: TObject);
var numero : integer;
begin
    numero := (sender as TMenuItem).tag;
    litFichier(ExemplesDir+ExemplesList[numero])
end;

procedure TpstCircMainForm.PreambTikzMenuClick(Sender: TObject);
begin
    PreambuleCircuitikz;
end;

procedure TpstCircMainForm.SchemaTikzMenuClick(Sender: TObject);
begin
    ecritCircuitikzClip;
 end;

//  *********************************  MRU  ********************************

procedure TpstCircMainForm.MruItemUpdate;
var i : integer;
begin
  for i := 0 to pred(MRUList.count) do begin
      MRUitem[i].Text := ExtractFileName(MRUList[i]);
      MRUitem[i].Visible := true;
  end;
  for i := MRUList.count to maxMRU do
      MRUitem[i].visible := false;
  MRUSeparator.Visible := (MRUList.count>0); // Seperator visible if not blank
end;

procedure TpstCircMainForm.MruAdd(const FileName: String);
begin
  if FileName='' then exit;
  MruDel(FileName);
  if MruList.count=(maxMru+1) then MRUList.delete(MRUList.Count - 1);
  MruList.Insert(0,Filename);
  MruItemUpdate;
end;

procedure TpstCircMainForm.MruDel(const FileName: String);
var
  Index: Integer;
begin
  Index := 0;
  while Index < (MRUList.count - 1) do
    if AnsiUpperCase(FileName) = AnsiUpperCase(MRUList[Index])
       then MRUList.delete(Index)
       else inc(Index)
end;

procedure TpstCircMainForm.UndoItemClick(Sender: TObject);
var S : tsauvegarde;
begin
   if pileSauvegarde.count=0 then exit;
   S := PileSauvegarde.pop;
   S.restaure;
   S.free;
   objetCourant := nil;
   paintBox.repaint;
end;

(*
procedure TpstCircMainForm.TestLinux(aide: string);
begin
    showMessage(aide);
end;
*)

end.


