unit quadripoleU;

interface

uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,

  FMX.StdCtrls,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.ListBox,
  FMX.Layouts,
  FMX.Edit,
//  FMX.Platform,
  FMX.Controls.Presentation,

  pstcircker;


type
  TQuadripoleDlg = class(TForm)
    Bevel: TPanel;
    GenreLB: TListBox;
    NomEdit: TEdit;
    NomEdit_LBL: TLabel;
    defautCB: TCheckBox;
    OKBtn: TButton;
    escBtn: TButton;
    OptoCoupleurItem: TListBoxItem;
    GeneriqueItem: TListBoxItem;
    TransfoItem: TListBoxItem;
    MoteurRG: TGroupBox;
    PSTricksBtn: TRadioButton;
    tIKZBtn: TRadioButton;
    Lang: TLang;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MoteurRGExit(Sender: TObject);
  private
  public
    objetCourant : TQuadripole;
  end;

var
  QuadripoleDlg: TQuadripoleDlg;

implementation

{$R *.FMX}

procedure TQuadripoleDlg.BitBtn1Click(Sender: TObject);
begin with objetCourant do begin
  Fnom := nomEdit.Text;
  modele := gQuadripole(genreLB.ItemIndex);
  if TikzBtn.IsChecked then moteurLatex := lTikz;
  if PSTricksBtn.IsChecked then moteurLatex := lPST;
  if defautCB.IsChecked  then ecritDefault;
end end;

procedure TQuadripoleDlg.FormActivate(Sender: TObject);
begin
if langue=fr then caption := 'Options quadripole';
if langue=en then caption := 'Quadrupole options';
LoadLangFromStrings(Lang.LangStr[chaineLangue]);
with objetCourant do begin
  nomEdit.Text := Fnom;
  genreLB.ItemIndex := ord(modele);
  defautCB.IsChecked  := false;
  TikzBtn.IsChecked := moteurLatex=lTikz;
  PSTricksBtn.IsChecked := moteurLatex=lPST;
  MoteurRGExit(Sender);
end end;

procedure TQuadripoleDlg.FormShow(Sender: TObject);
begin
  FormActivate(sender);
end;

procedure TQuadripoleDlg.MoteurRGExit(Sender: TObject);
begin
  if PSTricksBtn.isChecked then begin
     optoCoupleurItem.Text := CoupleurStr;
     generiqueItem.Text := GenericStr;
  end
  else begin
     optoCoupleurItem.Text := OptoCoupleurStr;
     generiqueItem.Text := CoupleurbisStr;
  end;
end;

end.
