unit tripoleU;

interface

uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,

  FMX.StdCtrls,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.ListBox,
  FMX.Layouts,
  FMX.Edit,
  FMX.Controls.Presentation,

  pstcircker;

type
  TTripoleDlg = class(TForm)
    InversionCB: TCheckBox;
    NomEdit: TEdit;
    NomEdit_LBL: TLabel;
    alimentationCB: TCheckBox;
    Bevel: TPanel;
    defautCB: TCheckBox;
    enhautrb: TRadioButton;
    enbasRB: TRadioButton;
    OKbtn: TButton;
    escBtn: TButton;
    HautBasRG: TGroupBox;
    zigzagCB: TCheckBox;
    frenchCB: TCheckBox;
    modeleLB: TListBox;
    TransistorLB: TListBox;
    MoteurRG: TGroupBox;
    PSTricksBtn: TRadioButton;
    tIKZBtn: TRadioButton;
    DiodeCB: TCheckBox;
    Lang: TLang;
    InterGB: TGroupBox;
    CentreR: TRadioButton;
    GaucheR: TRadioButton;
    DroiteR: TRadioButton;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure modeleLBClick(Sender: TObject);
  private
  public
     objetCourant : TTripole;
  end;

var
  TripoleDlg: TTripoleDlg;

implementation

// tAO,tnpn,tpnp,tpotar,tSwitch,tMixer,tCirculator

{$R *.FMX}

procedure TTripoleDlg.OKBtnClick(Sender: TObject);
begin with objetCourant do begin
     inversion := inversionCB.isChecked;
     sortieEnHaut := enHautRB.isChecked;
     if TikzBtn.isChecked then moteurLatex := lTikz;
     if PSTricksBtn.isChecked then moteurLatex := lPST;
     Fnom := nomEdit.Text;
     alimentation := alimentationCB.isChecked;
     zigzag := zigzagCB.isChecked;
     french := FrenchCB.isChecked;
     ModeleTransistor := gTransistor(TransistorLB.itemIndex);
     Modele := gTripole(ModeleLB.ItemIndex);
     withDiode := DiodeCB.isChecked;
     if centreR.isChecked then droiteGauche := aCentre;
     if droiteR.isChecked then droiteGauche := aDroite;
     if gaucheR.isChecked then droiteGauche := aGauche;
     if defautCB.IsChecked then EcritDefault;
end end;

procedure TTripoleDlg.FormActivate(Sender: TObject);
var i : integer;
begin
if langue=fr then caption := 'Options tripole';
if langue=en then caption := 'Tripole options';
LoadLangFromStrings(Lang.LangStr[chaineLangue]);
for i := 0 to ModeleLB.Count-1 do
      ModeleLB.items[i] := nomCaptionTripole(gTripole(i));
with objetCourant do begin
     inversionCB.IsChecked := inversion;
     diodeCB.isChecked := WithDiode;
     alimentationCB.IsChecked := alimentation;
     enhautRB.isChecked := objetCourant.sortieEnHaut;
     hautBasRG.visible := Modele in [tMixer,tCirculator];
  //   zigzagCB.visible := Modele=tpotar;
     frenchCB.visible := Modele=tAO;
     alimentationCB.visible := objetCourant.Modele=tAO;
     TransistorLB.itemIndex := ord(objetCourant.ModeleTransistor);
     TransistorLB.Visible := Modele in [tnpn,tpnp];
     inversionCB.visible := Modele in [tAO,tnpn,tpnp];
     diodeCB.Visible := Modele in [tnpn,tpnp];
     case objetCourant.Modele of
          tAO : begin
             inversionCB.Text  := InvertStr;
             FrenchCB.isChecked := objetCourant.french;
          end;
          tnpn : case ModeleTransistor of
              tbipolaire,tIGBT,tPhoto : inversionCB.Text  := EmetteurUpStr[langue];
              else inversionCB.Text  := DrainDownStr[langue];
          end;
          tpnp : case ModeleTransistor of
              tbipolaire,tIGBT,tPhoto : inversionCB.Text  := EmetteurDownStr[langue];
              else inversionCB.Text  := DrainUpStr[langue];
          end;
          //tpotar : zigzagCB.isChecked := zigzag;
          tSwitch : ;
          tMixer,tCirculator : ;
     end;
     case droiteGauche of
          aDroite : droiteR.IsChecked := true;
          aGauche : gaucheR.IsChecked := true;
          aCentre : centreR.IsChecked := true;
     end;
     nomEdit.Text := Fnom;
     ModeleLB.ItemIndex := ord(Modele);
     TikzBtn.IsChecked := moteurLatex=lTikz;
     PSTricksBtn.IsChecked := moteurLatex=lPST;
end end;

procedure TTripoleDlg.FormShow(Sender: TObject);
begin
     FormActivate(sender);
end;

procedure TTripoleDlg.ModeleLBClick(Sender: TObject);
var Modele : gTripole;
    ModeleTransistor : gTransistor;
begin
     Modele := gTripole(modeleLB.ItemIndex);
     ModeleTransistor := gTransistor(transistorLB.ItemIndex);
     hautBasRG.visible := Modele in [tMixer,tCirculator];
  //   zigzagCB.visible := Modele=tpotar;
     frenchCB.visible := Modele=tAO;
     alimentationCB.visible := Modele=tAO;
     TransistorLB.Visible := Modele in [tnpn,tpnp];
     inversionCB.visible := Modele in [tAO,tnpn,tpnp];
     diodeCB.Visible := Modele in [tnpn,tpnp];
     interGB.Visible := modele=TSwitch;
     case modele of
          tAO : inversionCB.Text  := InvertStr;
          tnpn : case modeleTransistor of
              tbipolaire,tIGBT : inversionCB.Text  := EmetteurUpStr[langue];
              else inversionCB.Text  := DrainDownStr[langue];
          end;
          tpnp : case modeleTransistor of
              tbipolaire,tIGBT : inversionCB.Text  := EmetteurDownStr[langue];
              else inversionCB.Text  := DrainUpStr[langue];
          end;
     end;
end;

end.


