unit u_urlopen;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
{$IFDEF IOS}
  macapi.helpers, iOSapi.Foundation, FMX.helpers.iOS;
{$ENDIF}
{$IFDEF ANDROID}
   //Androidapi.JNI.GraphicsContentViewText,
   //Androidapi.JNI.Net,
   //Androidapi.JNI.App,
   //Androidapi.helpers;
{$ENDIF}
{$IFDEF MACOS}
Posix.Stdlib;
{$ENDIF}
{$IFDEF LINUX}
Posix.Stdlib;
{$ENDIF}
{$IFDEF MSWINDOWS}
Winapi.ShellAPI, Winapi.Windows;
{$ENDIF}

type
  tUrlOpen = class
    class procedure Open(URL: string);
  end;

implementation

class procedure tUrlOpen.Open(URL: string);
{$IF Defined(ANDROID)}
var
  Intent: JIntent;
{$ENDIF}
begin
{$IFDEF ANDROID}
  Intent := TJIntent.Create;
  Intent.setAction(TJIntent.JavaClass.ACTION_VIEW);
  Intent.setData(StrToJURI(URL));
  tandroidhelper.Activity.startActivity(Intent);
  // SharedActivity.startActivity(Intent);
{$ENDIF}
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'OPEN', PWideChar(URL), nil, nil, SW_SHOWNORMAL);
{$ENDIF}
{$IFDEF IOS}
  SharedApplication.OpenURL(StrToNSUrl(URL));
{$ENDIF}
{$IFDEF LINUX}
  _system(PAnsiChar('open ' + AnsiString(URL)));
{$ENDIF}
{$IFDEF MACOS}
  _system(PAnsiChar('open ' + AnsiString(URL)));
{$ENDIF}
end;

end.
